(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    310074,       7447]
NotebookOptionsPosition[    307702,       7372]
NotebookOutlinePosition[    308035,       7387]
CellTagsIndexPosition[    307992,       7384]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["\<\
Investigation of correlated systematic errors in jet production
Pavel Nadolsky, December 2008\
\>", "Text"],

Cell[CellGroupData[{

Cell["Common setup", "Section"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"BeginPackage", "[", "\"\<dtaread2016boting`\>\"", "]"}], ";"}], 
  " ", "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"ReadLisFile", "::", "usage"}], "=", "\"\<\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"ExptIDtoName", "::", "usage"}], "=", "\"\<\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"ExptIDEcm", "::", "usage"}], "=", "\"\<\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"ExptIDprocess", "::", "usage"}], "=", "\"\<\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"ReadDta", "::", "usage"}], "=", "\"\<\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ReadExptTable", "::", "usage"}], "=", "\"\<\>\""}], ";"}], "\n", 
  
  RowBox[{"(*", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"EZIDecomposition", "::", "usage"}], "=", "\"\<\>\""}], ";", 
    "\n", 
    RowBox[{
     RowBox[{"selectdatacolume", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\n", "*)"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ExptIDinfo", "::", "usage"}], "=", "\"\<\>\""}], ";"}], "\n", 
  RowBox[{"(*", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"selectExptxQ", "::", "usage"}], "=", "\"\<\>\""}], ";"}], "\n", 
   "*)"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"selectExptxQv2", "::", "usage"}], "=", "\"\<\>\""}], ";"}], "\n", 
  RowBox[{"(*", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"selectExptresidual", "::", "usage"}], "=", "\"\<\>\""}], ";", 
    "\n", 
    RowBox[{
     RowBox[{"obsxQ", "::", "usage"}], "=", "\"\<\>\""}], ";", "\n", 
    RowBox[{
     RowBox[{"obsxQresidual", "::", "usage"}], "=", "\"\<\>\""}], ";", "\n", 
    RowBox[{
     RowBox[{"selectExptobservable", "::", "usage"}], "=", "\"\<\>\""}], ";", 
    "\n", 
    RowBox[{
     RowBox[{"selectExptxQall", "::", "usage"}], "=", "\"\<\>\""}], ";", "\n", 
    RowBox[{
     RowBox[{"extractdata2", "::", "usage"}], "=", "\"\<\>\""}], ";", "\n", 
    RowBox[{
     RowBox[{"extractobsfromdata", "::", "usage"}], "=", "\"\<\>\""}], ";", 
    "\n", 
    RowBox[{
     RowBox[{"makexQdataset", "::", "usage"}], "=", "\"\<\>\""}], ";", "\n", 
    RowBox[{
     RowBox[{"makeobsdataset", "::", "usage"}], "=", "\"\<\>\""}], ";", "\n", 
    
    RowBox[{
     RowBox[{"PDFloglogplot", "::", "usage"}], "=", "\"\<\>\""}], ";"}], "\n",
    "*)"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"colorset", "::", "usage"}], "=", "\"\<\>\""}], ";"}]}], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}], ";"}], " "}]], "Code"],

Cell["Mathematica version-specific set up", "Text"],

Cell[BoxData[{
 RowBox[{"Off", "[", 
  RowBox[{"General", "::", "spell"}], "]"}], "\n", 
 RowBox[{"Off", "[", 
  RowBox[{"General", "::", "spell1"}], "]"}]}], "Input",
 InitializationCell->True],

Cell["\<\
Set Interpolation Order
\
\>", "Text"],

Cell[BoxData[
 RowBox[{"SetOptions", "[", 
  RowBox[{"Interpolation", ",", 
   RowBox[{"InterpolationOrder", "->", "2"}]}], "]"}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"InterpolationOrder", "->", "2"}], ",", 
   RowBox[{"Method", "->", "Automatic"}], ",", 
   RowBox[{"PeriodicInterpolation", "->", "False"}]}], "}"}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"InterpolationOrder", "->", "2"}], ",", 
   RowBox[{"Method", "->", "Automatic"}], ",", 
   RowBox[{"PeriodicInterpolation", "->", "False"}]}], "}"}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "Plot", ",", "ListPlot", ",", "Graphics", ",", "ParametricPlot"}], "}"}],
     ",", 
    RowBox[{"BaseStyle", "->", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"FontFamily", "->", "\"\<Helvetica\>\""}], ",", "16"}], 
      "}"}]}]}], "]"}], ";"}]], "Input",
 InitializationCell->True],

Cell[CellGroupData[{

Cell["\<\
Subroutines to generate the table of the experiment names from the \"...lis\" \
file\
\>", "Subsection"],

Cell["\<\
Given the \"...lis\" file lisFileName (e.g., M01lis), generate a table of \
correspondence between the three-digit experiment ID and its name (lisTable)\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"2016.11", ".20", " ", "test", " ", "error"}], "*)"}], "\n", 
  RowBox[{
   RowBox[{
    RowBox[{"lisTable", "=", 
     RowBox[{"{", "}"}]}], ";"}], "\n", "\n", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"old", " ", "version", "\n", "ReadLisFile"}], "=", 
     RowBox[{"Function", "[", 
      RowBox[{"lisFileName", ",", "\n", 
       RowBox[{"Module", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"lisFile", ",", "lisTable"}], "}"}], ",", "\n", 
         RowBox[{
          RowBox[{"lisFile", "=", 
           RowBox[{"OpenRead", "[", "lisFileName", "]"}]}], ";", "\n", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"lisFile", "==", "$Failed"}], ",", 
            RowBox[{"Abort", "[", "]"}]}], "]"}], ";", "\n", "\n", 
          RowBox[{"(*", " ", 
           RowBox[{
           "Dump", " ", "the", " ", "first", " ", "two", " ", "lines"}], " ", 
           "*)"}], "\n", 
          RowBox[{"Read", "[", 
           RowBox[{"lisFile", ",", 
            RowBox[{"{", 
             RowBox[{"Record", ",", "Record", ",", "Record"}], "}"}]}], "]"}],
           ";", "\n", "\n", 
          RowBox[{"lisTable", "=", 
           RowBox[{"ReadList", "[", 
            RowBox[{"lisFile", ",", 
             RowBox[{"{", 
              RowBox[{"Number", ",", "Number", ",", "Word", ",", "Record"}], 
              "}"}]}], "]"}]}], ";", "\n", 
          RowBox[{"Close", "[", "lisFile", "]"}], ";", "\n", "\n", 
          RowBox[{"(*", " ", 
           RowBox[{
           "Generate", " ", "the", " ", "correspondence", " ", "table"}], " ",
            "*)"}], "\n", 
          RowBox[{"lisTable", "=", 
           RowBox[{"Select", "[", 
            RowBox[{"lisTable", ",", 
             RowBox[{
              RowBox[{
               RowBox[{"Round", "[", 
                RowBox[{"#", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "]"}], " ", "!=", "0"}], 
              "&"}]}], "]"}]}], ";", "\n", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"lisTable", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "*", "100"}], "+", 
               RowBox[{
                RowBox[{"lisTable", "[", 
                 RowBox[{"[", "i", "]"}], "]"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}]}], ",", 
              RowBox[{
               RowBox[{"lisTable", "[", 
                RowBox[{"[", "i", "]"}], "]"}], "[", 
               RowBox[{"[", "3", "]"}], "]"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", 
              RowBox[{
               RowBox[{"Dimensions", "[", "lisTable", "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}]}], "}"}]}], "]"}]}]}], "\n", 
        "]"}]}], 
      RowBox[{"(*", 
       RowBox[{"Module", "\[Rule]"}], "*)"}], "\n", "]"}]}], 
    RowBox[{"(*", 
     RowBox[{"Function", "\[Rule]"}], "*)"}], "\n", "*)"}], "\n", "\n", 
   RowBox[{"(*", 
    RowBox[{"2016.11", ".20", " ", "test", " ", "error"}], "*)"}], "\n", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"new", " ", 
      RowBox[{"version", ":", " ", 
       RowBox[{"listable", " ", "is", " ", "global"}]}]}], ",", " ", 
     RowBox[{
     "so", " ", "it", " ", "could", " ", "be", " ", "used", " ", "by", " ", 
      "ExptIDtoName"}]}], "*)"}], "\n", 
   RowBox[{"ReadLisFile", "=", 
    RowBox[{"Function", "[", 
     RowBox[{"lisFileName", ",", "\n", 
      RowBox[{"Module", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"lisFile", ",", "lisTabletmp"}], "}"}], ",", "\n", 
        RowBox[{
         RowBox[{"lisFile", "=", 
          RowBox[{"OpenRead", "[", "lisFileName", "]"}]}], ";", "\n", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"lisFile", "==", "$Failed"}], ",", 
           RowBox[{"Abort", "[", "]"}]}], "]"}], ";", "\n", "\n", 
         RowBox[{"(*", " ", 
          RowBox[{
          "Dump", " ", "the", " ", "first", " ", "two", " ", "lines"}], " ", 
          "*)"}], "\n", 
         RowBox[{"Read", "[", 
          RowBox[{"lisFile", ",", 
           RowBox[{"{", 
            RowBox[{"Record", ",", "Record", ",", "Record"}], "}"}]}], "]"}], 
         ";", "\n", "\n", 
         RowBox[{"lisTabletmp", "=", 
          RowBox[{"ReadList", "[", 
           RowBox[{"lisFile", ",", 
            RowBox[{"{", 
             RowBox[{"Number", ",", "Number", ",", "Word", ",", "Record"}], 
             "}"}]}], "]"}]}], ";", "\n", 
         RowBox[{"Close", "[", "lisFile", "]"}], ";", "\n", "\n", 
         RowBox[{"(*", " ", 
          RowBox[{
          "Generate", " ", "the", " ", "correspondence", " ", "table"}], " ", 
          "*)"}], "\n", 
         RowBox[{"lisTabletmp", "=", 
          RowBox[{"Select", "[", 
           RowBox[{"lisTabletmp", ",", 
            RowBox[{
             RowBox[{
              RowBox[{"Round", "[", 
               RowBox[{"#", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "]"}], " ", "!=", "0"}], 
             "&"}]}], "]"}]}], ";", "\n", "\n", 
         RowBox[{"lisTable", "=", "\n", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"lisTabletmp", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "*", "100"}], "+", 
               RowBox[{
                RowBox[{"lisTabletmp", "[", 
                 RowBox[{"[", "i", "]"}], "]"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}]}], ",", 
              RowBox[{
               RowBox[{"lisTabletmp", "[", 
                RowBox[{"[", "i", "]"}], "]"}], "[", 
               RowBox[{"[", "3", "]"}], "]"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", 
              RowBox[{
               RowBox[{"Dimensions", "[", "lisTabletmp", "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}]}], "}"}]}], "]"}]}], ";", "\n", 
         "lisTable"}]}], "\n", "]"}]}], 
     RowBox[{"(*", 
      RowBox[{"Module", "\[Rule]"}], "*)"}], "\n", "]"}], 
    RowBox[{"(*", 
     RowBox[{"Function", "\[Rule]"}], "*)"}]}]}]}]], "Input",
 InitializationCell->True],

Cell["\<\
Given the three-digit experiment ID, the function ExptIDtoName  returns its \
true name\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"2016.11", ".20", " ", "test", " ", "error"}], "*)"}], "\n", 
  RowBox[{"(*", "\n", 
   RowBox[{
    RowBox[{"ExptIDtoName", "=", "\n", 
     RowBox[{"Function", "[", 
      RowBox[{"ExptID", ",", 
       RowBox[{
        RowBox[{"IDPosition", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"Position", "[", 
            RowBox[{"lisTable", ",", "ExptID"}], "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", 
        RowBox[{
         RowBox[{"lisTable", "[", 
          RowBox[{"[", "IDPosition", "]"}], "]"}], "[", 
         RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}]}], ";"}], "\n", "*)"}], 
  "\n", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"20170214", ":", " ", 
     RowBox[{
     "seems", " ", "make", " ", "problem", " ", "in", " ", "parallel", " ", 
      "mode"}]}], ",", " ", 
    RowBox[{"modify", " ", 
     RowBox[{"it", ":", " ", 
      RowBox[{"variables", " ", "become", " ", "local"}]}]}]}], "*)"}], "\n", 
  
  RowBox[{
   RowBox[{"ExptIDtoName", "[", "ExptIDin_", "]"}], ":=", "\n", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ExptID", "=", "ExptIDin"}], ",", "IDPosition", ",", 
       "lisTabletmp", ",", "output"}], "}"}], ",", "\n", 
     RowBox[{
      RowBox[{"lisTabletmp", "=", "lisTable"}], ";", "\n", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
        "20170426", " ", "even", " ", "exptid", " ", "not", " ", "in", " ", 
         "lisTable"}], ",", " ", 
        RowBox[{"show", " ", "exptname", " ", "as", " ", "\"\<None\>\""}]}], 
       "*)"}], "\n", 
      RowBox[{"If", "[", "\n", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", 
          RowBox[{"Position", "[", 
           RowBox[{"lisTabletmp", ",", "ExptID"}], "]"}], " ", "]"}], "!=", 
         "0"}], ",", "\n", 
        RowBox[{
         RowBox[{"IDPosition", "=", 
          RowBox[{
           RowBox[{
            RowBox[{"Position", "[", 
             RowBox[{"lisTabletmp", ",", "ExptID"}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}]}], ";", "\n", 
         RowBox[{"output", "=", 
          RowBox[{
           RowBox[{"lisTabletmp", "[", 
            RowBox[{"[", "IDPosition", "]"}], "]"}], "[", 
           RowBox[{"[", "2", "]"}], "]"}]}]}], ",", "\n", 
        RowBox[{
         RowBox[{"Print", "[", 
          RowBox[{
          "\"\<can not find expt id = \>\"", ",", "ExptID", ",", 
           "\"\< in lisTable\>\""}], "]"}], ";", "\n", 
         RowBox[{"output", "=", "\"\<None\>\""}]}]}], "\n", "]"}], ";", "\n", 
      
      RowBox[{"(*", "\n", 
       RowBox[{
        RowBox[{"lisTabletmp", "[", 
         RowBox[{"[", "IDPosition", "]"}], "]"}], "[", 
        RowBox[{"[", "2", "]"}], "]"}], "\n", "*)"}], "\n", "output"}]}], 
    "\n", "\n", "]"}]}]}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{"(*", "\n", 
  RowBox[{
   RowBox[{"ExptIDtoName", "[", "ExptIDin_", "]"}], ":=", "\n", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ExptID", "=", "ExptIDin"}], "}"}], ",", "\n", 
     RowBox[{"(*", "\n", 
      RowBox[{
       RowBox[{"IDPosition", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"Position", "[", 
           RowBox[{"lisTable", ",", "ExptID"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], ";", "\n", 
       RowBox[{
        RowBox[{"lisTable", "[", 
         RowBox[{"[", "IDPosition", "]"}], "]"}], "[", 
        RowBox[{"[", "2", "]"}], "]"}]}], "\n", "*)"}], "\n", 
     RowBox[{"lisTable", "[", 
      RowBox[{"[", "3", "]"}], "]"}]}], "\n", "]"}]}], "\n", "*)"}]], "Code"],

Cell[BoxData[""], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"2016.11", ".04", " ", "botingw"}], "*)"}], "\n", 
  RowBox[{"(*", 
   RowBox[{"table", " ", "of", " ", "center", " ", "of", " ", "energy", " ", 
    RowBox[{"(", 
     RowBox[{"Ecm", ",", " ", 
      RowBox[{"sqrt", 
       RowBox[{"(", "S", ")"}]}]}], ")"}], " ", "of", " ", "experiments"}], 
   " ", "*)"}], "\n", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"collect", " ", "expid", " ", "with", " ", "its", " ", "Ecm", " ", 
     RowBox[{"(", 
      RowBox[{"sqrt", 
       RowBox[{"(", "S", ")"}]}], ")"}], " ", "value"}], ",", " ", "201", ",",
     " ", "203", ",", " ", 
    RowBox[{
    "204", " ", "have", " ", "two", " ", "version", " ", "of", " ", "Ecm"}]}],
    "*)"}], "\n", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"input", ":", " ", "ExptID"}], ",", " ", 
    RowBox[{
    "return", " ", "Ecm", " ", "of", " ", "corresponding", " ", "ExptID"}]}], 
   " ", "*)"}], "\n", 
  RowBox[{
   RowBox[{"ExptIDEcm", "[", "ExptIDin_", "]"}], ":=", "\n", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ExptID", "=", "ExptIDin"}], ",", "output", ",", "expidsqrtS", 
       ",", "Ecm", ",", "IDPosition"}], "}"}], ",", "\n", 
     RowBox[{"(*", "\n", 
      RowBox[{
      "the", " ", "table", " ", "of", " ", "Ecm", " ", "of", " ", "exptid", 
       " ", "looks", " ", "like", " ", 
       RowBox[{"this", ":", " ", "\n", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"exptid1", ",", " ", "Ecm1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"exptid2", ",", " ", "Ecm2"}], "}"}], ",", "..."}], 
         "}"}]}]}], "\n", "*)"}], "\n", 
     RowBox[{
      RowBox[{"expidsqrtS", "=", "\n", 
       RowBox[{"{", "\n", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"201", ",", "38.8"}], "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"203", ",", "38.76"}], "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"204", ",", "38.75"}], "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"225", ",", "1800"}], "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"227", ",", "1960"}], "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"234", ",", "1960"}], "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"240", ",", "7000"}], "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"241", ",", "7000"}], "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"260", ",", "1960"}], "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"261", ",", "1960"}], "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"266", ",", "7000"}], "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"267", ",", "7000"}], "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"268", ",", "7000"}], "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"281", ",", "1960"}], "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"504", ",", "1960"}], "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"514", ",", "1960"}], "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"535", ",", "7000"}], "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"538", ",", "7000"}], "}"}], ",", "\n", 
         RowBox[{"(*", 
          RowBox[{
          "20170426", " ", "add", " ", "Ecm", " ", "of", " ", "new", " ", 
           "experiments", " ", "for", " ", "new", " ", "CT14NNLO"}], " ", 
          "*)"}], "\n", 
         RowBox[{"{", 
          RowBox[{"246", ",", "8000"}], "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"542", ",", "7000"}], "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"544", ",", "7000"}], "}"}], ",", "\n", 
         RowBox[{"(*", 
          RowBox[{"20170602", ":", " ", 
           RowBox[{
           "add", " ", "Ecm", " ", "of", " ", "new", " ", "experiments", " ", 
            "245", " ", "249", " ", "250", " ", 
            RowBox[{"565", "~", "568"}]}]}], "*)"}], " ", "\n", 
         RowBox[{"{", 
          RowBox[{"245", ",", "7000"}], "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"249", ",", "8000"}], "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"250", ",", "8000"}], "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"565", ",", "8000"}], "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"566", ",", "8000"}], "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"567", ",", "8000"}], "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"568", ",", "8000"}], "}"}], ",", "\n", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"20170606", ":", " ", 
            RowBox[{
            "add", " ", "Ecm", " ", "of", " ", "new", " ", "experiments", " ",
              "248"}]}], ",", " ", "247"}], "*)"}], " ", "\n", 
         RowBox[{"{", 
          RowBox[{"248", ",", "7000"}], "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"247", ",", "7000"}], "}"}], ",", "\n", 
         RowBox[{"(*", 
          RowBox[{"20171016", ":", " ", 
           RowBox[{"add", " ", "545"}]}], "*)"}], "\n", 
         RowBox[{"{", 
          RowBox[{"545", ",", "8000"}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{"20171208", " ", 
           RowBox[{"TJ", "'"}], "s", " ", "new", " ", "data", " ", "in", " ", 
           "HERA2", " ", "ev02"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"252", ",", "8000"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"253", ",", "8000"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"254", ",", "8000"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"255", ",", "8000"}], "}"}]}], "\n", "}"}]}], ";", "\n", 
      "\n", 
      RowBox[{"(*", 
       RowBox[{"find", " ", "position", " ", "of", " ", "exptID"}], "*)"}], 
      "\n", 
      RowBox[{"Ecm", "=", 
       RowBox[{"-", "1"}]}], ";", "\n", 
      RowBox[{"IDPosition", "=", 
       RowBox[{"Position", "[", 
        RowBox[{"expidsqrtS", ",", "ExptID"}], "]"}]}], ";", "\n", 
      RowBox[{"(*", "\n", 
       RowBox[{
        RowBox[{
        "if", " ", "find", " ", "one", " ", "match", " ", "exptid", " ", "on",
          " ", "the", " ", "list"}], ",", " ", 
        RowBox[{"return", " ", "Ecm", 
         RowBox[{"(", 
          RowBox[{"sqrt", 
           RowBox[{"(", "S", ")"}]}], ")"}], " ", "of", " ", "that", " ", 
         "exptid"}], ",", "\n", 
        RowBox[{
        "if", " ", "#match", " ", "of", " ", "input", " ", "exptID", " ", 
         "to", " ", "expidS", " ", "is", " ", "not", " ", "1"}], ",", " ", 
        RowBox[{"return", " ", "error", " ", "massage"}]}], "\n", "*)"}], 
      "\n", 
      RowBox[{"If", "[", "\n", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", "IDPosition", "]"}], "==", "1"}], ",", "\n", 
        RowBox[{
         RowBox[{"IDPosition", "=", 
          RowBox[{
           RowBox[{"IDPosition", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}]}], ";", "\n", 
         RowBox[{"Ecm", "=", 
          RowBox[{
           RowBox[{"expidsqrtS", "[", 
            RowBox[{"[", "IDPosition", "]"}], "]"}], "[", 
           RowBox[{"[", "2", "]"}], "]"}]}]}], "\n", ",", "\n", 
        RowBox[{"Print", "[", 
         RowBox[{
         "\"\<error (ExptIDEcm), there is no ID match or more than 1 ID match \
to energy table, ID = \>\"", ",", "ExptID"}], "]"}]}], "\n", "]"}], ";", "\n", 
      RowBox[{"(*", "\n", 
       RowBox[{
        RowBox[{"IDPosition", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"Position", "[", 
            RowBox[{"expidsqrtS", ",", "ExptID"}], "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", "\n", 
        RowBox[{"Ecm", "=", 
         RowBox[{
          RowBox[{"expidsqrtS", "[", 
           RowBox[{"[", "IDPosition", "]"}], "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ";"}], "\n", "*)"}], "\n", 
      "Ecm"}]}], "\n", "\n", "]"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7217596885692797`*^9, 3.721759761663732*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ExptIDprocess", "[", "ExptIDin_", "]"}], ":=", "\n", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ExptID", "=", "ExptIDin"}], ",", "output", ",", "expidsqrtS", 
       ",", "Ecm", ",", "IDPosition"}], "}"}], ",", "\n", 
     RowBox[{"(*", "\n", 
      RowBox[{
      "the", " ", "table", " ", "of", " ", "Ecm", " ", "of", " ", "exptid", 
       " ", "looks", " ", "like", " ", 
       RowBox[{"this", ":", " ", "\n", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"exptid1", ",", " ", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"exp", " ", "name1"}], ",", " ", "process1", ",", " ", 
              "observable1", ",", " ", "Ecm1"}], "}"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"exptid2", ",", " ", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"exp", " ", "name2"}], ",", " ", "process2", ",", " ", 
              "observable2", ",", " ", "Ecm2"}], "}"}]}], "}"}], ",", "..."}],
          "}"}]}]}], "\n", "*)"}], "\n", 
     RowBox[{
      RowBox[{"expidsqrtS", "=", "\n", 
       RowBox[{"{", "\n", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"101", ",", " ", 
           RowBox[{"{", 
            RowBox[{
            "\"\<BCDMS\>\"", ",", " ", "\"\<p\[Mu] \[Rule] \[Mu]X\>\"", ",", 
             " ", "\"\<\>\"", ",", "\"\<\>\""}], "}"}]}], "}"}], ",", 
         RowBox[{"(*", 
          RowBox[{"mu", "+", " ", 
           RowBox[{"or", " ", "mu"}], "-"}], "*)"}], "\n", 
         RowBox[{"{", 
          RowBox[{"102", ",", " ", 
           RowBox[{"{", 
            RowBox[{
            "\"\<BCDMS\>\"", ",", " ", "\"\<d\[Mu] \[Rule] \[Mu]X\>\"", ",", 
             " ", "\"\<\>\"", ",", "\"\<\>\""}], "}"}]}], "}"}], ",", 
         RowBox[{"(*", 
          RowBox[{"mu", "+", " ", 
           RowBox[{"or", " ", "mu"}], "-"}], "*)"}], "\n", 
         RowBox[{"{", 
          RowBox[{"104", ",", " ", 
           RowBox[{"{", 
            RowBox[{
            "\"\<NMC-NA37\>\"", ",", " ", "\"\<p(d)\[Mu] \[Rule] \[Mu]X\>\"", 
             ",", " ", "\"\<\>\"", ",", "\"\<\>\""}], "}"}]}], "}"}], ",", 
         RowBox[{"(*", 
          RowBox[{"mu", "+", " ", 
           RowBox[{"or", " ", "mu"}], "-"}], "*)"}], "\n", 
         RowBox[{"{", 
          RowBox[{"106", ",", " ", 
           RowBox[{"{", 
            RowBox[{
            "\"\<NMC-NA37\>\"", ",", " ", "\"\<p\[Mu] \[Rule] \[Mu]X\>\"", 
             ",", " ", "\"\<\>\"", ",", "\"\<\>\""}], "}"}]}], "}"}], ",", 
         RowBox[{"(*", 
          RowBox[{"mu", "+", " ", 
           RowBox[{"or", " ", "mu"}], "-"}], "*)"}], "\n", 
         RowBox[{"{", 
          RowBox[{"108", ",", " ", 
           RowBox[{"{", 
            RowBox[{
            "\"\<CDHSW\>\"", ",", " ", 
             "\"\<\[Nu](\\!\\(\\*OverscriptBox[\\(\[Nu]\\), \\(_\\)]\\))Fe \
\[Rule] \[Mu]X\>\"", ",", " ", "\"\<F2\>\"", ",", "\"\<\>\""}], "}"}]}], 
          "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"109", ",", " ", 
           RowBox[{"{", 
            RowBox[{
            "\"\<CDHSW\>\"", ",", " ", 
             "\"\<\[Nu](\\!\\(\\*OverscriptBox[\\(\[Nu]\\), \\(_\\)]\\))Fe \
\[Rule] \[Mu]X\>\"", ",", " ", "\"\<xF3\>\"", ",", "\"\<\>\""}], "}"}]}], 
          "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"110", ",", " ", 
           RowBox[{"{", 
            RowBox[{
            "\"\<CCFR\>\"", ",", " ", 
             "\"\<\[Nu](\\!\\(\\*OverscriptBox[\\(\[Nu]\\), \\(_\\)]\\))Fe \
\[Rule] \[Mu]X\>\"", ",", " ", "\"\<F2\>\"", ",", "\"\<\>\""}], "}"}]}], 
          "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"111", ",", " ", 
           RowBox[{"{", 
            RowBox[{
            "\"\<CCFR\>\"", ",", " ", 
             "\"\<\[Nu](\\!\\(\\*OverscriptBox[\\(\[Nu]\\), \\(_\\)]\\))Fe \
\[Rule] \[Mu]X\>\"", ",", " ", "\"\<xF3\>\"", ",", "\"\<\>\""}], "}"}]}], 
          "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"124", ",", " ", 
           RowBox[{"{", 
            RowBox[{
            "\"\<NuTeV\>\"", ",", " ", 
             "\"\<\[Nu]N \[Rule] \\!\\(\\*SuperscriptBox[\\(\[Mu]\\), \
\\(+\\)]\\)\\!\\(\\*SuperscriptBox[\\(\[Mu]\\), \\(-\\)]\\)X\>\"", ",", " ", 
             "\"\<\>\"", ",", "\"\<\>\""}], "}"}]}], "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"125", ",", " ", 
           RowBox[{"{", 
            RowBox[{
            "\"\<NuTeV\>\"", ",", " ", 
             "\"\<\\!\\(\\*OverscriptBox[\\(\[Nu]\\), \\(_\\)]\\)N \[Rule] \
\\!\\(\\*SuperscriptBox[\\(\[Mu]\\), \\(+\\)]\\)\\!\\(\\*SuperscriptBox[\\(\
\[Mu]\\), \\(-\\)]\\)X\>\"", ",", " ", "\"\<\>\"", ",", "\"\<\>\""}], "}"}]}],
           "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"126", ",", " ", 
           RowBox[{"{", 
            RowBox[{
            "\"\<CCFR\>\"", ",", " ", 
             "\"\<\[Nu](\\!\\(\\*OverscriptBox[\\(\[Nu]\\), \\(_\\)]\\))Fe \
\[Rule] \\!\\(\\*SuperscriptBox[\\(\[Mu]\\), \
\\(+\\)]\\)\\!\\(\\*SuperscriptBox[\\(\[Mu]\\), \\(-\\)]\\)X\>\"", ",", " ", 
             "\"\<F2\>\"", ",", "\"\<\>\""}], "}"}]}], "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"127", ",", " ", 
           RowBox[{"{", 
            RowBox[{
            "\"\<CCFR\>\"", ",", " ", 
             "\"\<\[Nu](\\!\\(\\*OverscriptBox[\\(\[Nu]\\), \\(_\\)]\\))Fe \
\[Rule] \\!\\(\\*SuperscriptBox[\\(\[Mu]\\), \
\\(+\\)]\\)\\!\\(\\*SuperscriptBox[\\(\[Mu]\\), \\(-\\)]\\)X\>\"", ",", " ", 
             "\"\<xF3\>\"", ",", "\"\<\>\""}], "}"}]}], "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"145", ",", " ", 
           RowBox[{"{", 
            RowBox[{
            "\"\<H1\>\"", ",", " ", 
             "\"\<\[ScriptE]\[ScriptP] -> \
\[ScriptE]\[ScriptB]\\!\\(\\*OverscriptBox[\\(\[ScriptB]\\), \
\\(_\\)]\\)X\>\"", ",", " ", 
             "\"\<reduced Xsec(\[ScriptB]\\!\\(\\*OverscriptBox[\\(\[ScriptB]\
\\), \\(_\\)]\\))\>\"", ",", "\"\<\>\""}], "}"}]}], "}"}], ",", 
         RowBox[{"(*", 
          RowBox[{"e", "+", " ", 
           RowBox[{"or", " ", "e"}], "-"}], "*)"}], "\n", 
         RowBox[{"{", 
          RowBox[{"147", ",", " ", 
           RowBox[{"{", 
            RowBox[{
            "\"\<H1&ZEUS\>\"", ",", " ", 
             "\"\<\[ScriptE]\[ScriptP] -> \
\[ScriptE]\[ScriptC]\\!\\(\\*OverscriptBox[\\(\[ScriptC]\\), \
\\(_\\)]\\)X\>\"", ",", " ", 
             "\"\<reduced Xsec(\[ScriptC]\\!\\(\\*OverscriptBox[\\(\[ScriptC]\
\\), \\(_\\)]\\))\>\"", ",", "\"\<\>\""}], "}"}]}], "}"}], ",", 
         RowBox[{"(*", 
          RowBox[{"e", "+", " ", 
           RowBox[{"or", " ", "e"}], "-"}], "*)"}], "\n", 
         RowBox[{"{", 
          RowBox[{"159", ",", " ", 
           RowBox[{"{", 
            RowBox[{
            "\"\<H1&ZEUS\>\"", ",", " ", 
             "\"\<\\!\\(\\*SuperscriptBox[\\(\[ScriptE]\\), \
\\(+\\)]\\)(\\!\\(\\*SuperscriptBox[\\(\[ScriptE]\\), \\(-\\)]\\))\[ScriptP] \
-> X\>\"", ",", " ", "\"\<\>\"", ",", "\"\<\>\""}], "}"}]}], "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"160", ",", " ", 
           RowBox[{"{", 
            RowBox[{
            "\"\<H1&ZEUS\>\"", ",", " ", 
             "\"\<\\!\\(\\*SuperscriptBox[\\(\[ScriptE]\\), \
\\(+\\)]\\)(\\!\\(\\*SuperscriptBox[\\(\[ScriptE]\\), \\(-\\)]\\))\[ScriptP] \
-> \\!\\(\\*SuperscriptBox[\\(\[ScriptE]\\), \
\\(+\\)]\\)(\\!\\(\\*SuperscriptBox[\\(\[ScriptE]\\), \\(-\\)]\\))X or \[Nu](\
\\!\\(\\*OverscriptBox[\\(\[Nu]\\), \\(_\\)]\\))X\>\"", ",", " ", "\"\<\>\"", 
             ",", "\"\<\>\""}], "}"}]}], "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"169", ",", " ", 
           RowBox[{"{", 
            RowBox[{
            "\"\<H1\>\"", ",", " ", 
             "\"\<\\!\\(\\*SuperscriptBox[\\(\[ScriptE]\\), \
\\(+\\)]\\)(\\!\\(\\*SuperscriptBox[\\(\[ScriptE]\\), \\(-\\)]\\))\[ScriptP] \
-> X (NC)\>\"", ",", " ", "\"\<\>\"", ",", "\"\<\>\""}], "}"}]}], "}"}], ",", 
         "\n", 
         RowBox[{"{", 
          RowBox[{"201", ",", 
           RowBox[{"{", 
            RowBox[{
            "\"\<E605\>\"", ",", " ", 
             "\"\<\[ScriptP]\[ScriptCapitalC]\[ScriptU] \[Rule] \
\\!\\(\\*SuperscriptBox[\\(\[Mu]\\), \\(+\\)]\\)\\!\\(\\*SuperscriptBox[\\(\
\[Mu]\\), \\(-\\)]\\)X\>\"", ",", " ", "\"\<\>\"", ",", " ", "38.8"}], 
            "}"}]}], "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"203", ",", " ", 
           RowBox[{"{", 
            RowBox[{
            "\"\<FNAL E866/NuSea\>\"", ",", " ", 
             "\"\<\[ScriptP]\[ScriptP](d) \[Rule] \\!\\(\\*SuperscriptBox[\\(\
\[Mu]\\), \\(+\\)]\\)\\!\\(\\*SuperscriptBox[\\(\[Mu]\\), \\(-\\)]\\)X\>\"", 
             ",", " ", "\"\<\>\"", ",", "38.76"}], "}"}]}], "}"}], ",", "\n", 
         
         RowBox[{"{", 
          RowBox[{"204", ",", " ", 
           RowBox[{"{", 
            RowBox[{
            "\"\<E866/NuSea\>\"", ",", " ", 
             "\"\<\[ScriptP]\[ScriptP] \[Rule] \\!\\(\\*SuperscriptBox[\\(\
\[Mu]\\), \\(+\\)]\\)\\!\\(\\*SuperscriptBox[\\(\[Mu]\\), \\(-\\)]\\)X\>\"", 
             ",", " ", "\"\<\>\"", ",", " ", "38.75"}], "}"}]}], "}"}], ",", 
         "\n", 
         RowBox[{"{", 
          RowBox[{"225", ",", " ", 
           RowBox[{"{", 
            RowBox[{
            "\"\<CDF run 1\>\"", ",", " ", 
             "\"\<\[ScriptP]\\!\\(\\*OverscriptBox[\\(\[ScriptP]\\), \\(_\\)]\
\\) \[Rule] ??\>\"", ",", " ", "\"\<\>\"", ",", " ", "1800"}], "}"}]}], "}"}],
          ",", 
         RowBox[{"(*", 
          RowBox[{"charge", " ", "asym"}], "*)"}], "\n", 
         RowBox[{"{", 
          RowBox[{"227", ",", " ", 
           RowBox[{"{", 
            RowBox[{
            "\"\<CDF run 2\>\"", ",", " ", 
             "\"\<\[ScriptP]\\!\\(\\*OverscriptBox[\\(\[ScriptP]\\), \\(_\\)]\
\\) \[Rule] WX, W \[Rule] \[ScriptE]\[Nu]\>\"", ",", " ", "\"\<\>\"", ",", 
             " ", "1960"}], "}"}]}], "}"}], ",", 
         RowBox[{"(*", 
          RowBox[{"charge", " ", "asym"}], "*)"}], "\n", 
         RowBox[{"{", 
          RowBox[{"234", ",", " ", 
           RowBox[{"{", 
            RowBox[{
            "\"\<D0 Run IIa & Run IIb\>\"", ",", " ", "\"\<\>\"", ",", " ", 
             "\"\<\>\"", ",", " ", "1960"}], "}"}]}], "}"}], ",", 
         RowBox[{"(*", 
          RowBox[{"CP", " ", "folded", " ", "asym"}], "*)"}], "\n", 
         RowBox[{"{", 
          RowBox[{"240", ",", " ", 
           RowBox[{"{", 
            RowBox[{
            "\"\<LHCb\>\"", ",", " ", 
             "\"\<\[ScriptP]\[ScriptP] \[Rule] ZX, Z \[Rule] \
\\!\\(\\*SuperscriptBox[\\(\[Mu]\\), \\(+\\)]\\)\\!\\(\\*SuperscriptBox[\\(\
\[Mu]\\), \\(\\(-\\)\\(\\\\\\ \\)\\)]\\) or \[ScriptP]\\!\\(\\*OverscriptBox[\
\\(\[ScriptP]\\), \\(_\\)]\\) \[Rule] WX, W \[Rule] \[Mu]\[Nu]\>\"", ",", 
             " ", "\"\<\>\"", ",", " ", "7000"}], "}"}]}], "}"}], ",", 
         RowBox[{"(*", 
          RowBox[{"forward", " ", "VB", " ", "production"}], "*)"}], "\n", 
         RowBox[{"{", 
          RowBox[{"241", ",", " ", 
           RowBox[{"{", 
            RowBox[{
            "\"\<LHCb\>\"", ",", " ", 
             "\"\<\[ScriptP]\[ScriptP] \[Rule] WX, W \[Rule] \[Mu]\[Nu]\>\"", 
             ",", " ", "\"\<\>\"", ",", " ", "7000"}], "}"}]}], "}"}], ",", 
         RowBox[{"(*", 
          RowBox[{"W", "+", " ", 
           RowBox[{"or", " ", "W"}], "-"}], "*)"}], "\n", 
         RowBox[{"{", 
          RowBox[{"260", ",", " ", 
           RowBox[{"{", 
            RowBox[{
            "\"\<D0 Run 2\>\"", ",", " ", 
             "\"\<\[ScriptP]\\!\\(\\*OverscriptBox[\\(\[ScriptP]\\), \\(_\\)]\
\\) \[Rule] Z\>\"", ",", " ", "\"\<\>\"", ",", " ", "1960"}], "}"}]}], "}"}], 
         ",", 
         RowBox[{"(*", 
          RowBox[{"Z", " ", "decay", " ", "??"}], "*)"}], "\n", 
         RowBox[{"{", 
          RowBox[{"261", ",", " ", 
           RowBox[{"{", 
            RowBox[{
            "\"\<CDF Run 2\>\"", ",", " ", 
             "\"\<\[ScriptP]\\!\\(\\*OverscriptBox[\\(\[ScriptP]\\), \\(_\\)]\
\\) \[Rule] Z\>\"", ",", " ", "\"\<\>\"", ",", " ", "1960"}], "}"}]}], "}"}], 
         ",", "\n", 
         RowBox[{"{", 
          RowBox[{"266", ",", " ", 
           RowBox[{"{", 
            RowBox[{
            "\"\<CMS\>\"", ",", " ", 
             "\"\<\[ScriptP]\[ScriptP] \[Rule] WX, W \[Rule] \[Mu]\[Nu]\>\"", 
             ",", " ", "\"\<\>\"", ",", " ", "7000"}], "}"}]}], "}"}], ",", 
         "\n", 
         RowBox[{"{", 
          RowBox[{"267", ",", " ", 
           RowBox[{"{", 
            RowBox[{
            "\"\<CMS\>\"", ",", " ", 
             "\"\<\[ScriptP]\[ScriptP] \[Rule] WX, W \[Rule] \
\[ScriptE]\[Nu]\>\"", ",", " ", "\"\<\>\"", ",", " ", "7000"}], "}"}]}], 
          "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"268", ",", " ", 
           RowBox[{"{", 
            RowBox[{
            "\"\<ATLAS\>\"", ",", " ", 
             "\"\<\[ScriptP]\[ScriptP] \[Rule] \
\[ScriptL]\[Nu]X/\\!\\(\\*SuperscriptBox[\\(\[Mu]\\), \
\\(+\\)]\\)\\!\\(\\*SuperscriptBox[\\(\[Mu]\\), \\(\\(-\\)\\(\\\\\\ \
\\)\\)]\\)X\>\"", ",", " ", "\"\<\>\"", ",", " ", "7000"}], "}"}]}], "}"}], 
         ",", "\n", 
         RowBox[{"{", 
          RowBox[{"281", ",", " ", 
           RowBox[{"{", 
            RowBox[{
            "\"\<D0 Run 2\>\"", ",", " ", 
             "\"\<\[ScriptP]\\!\\(\\*OverscriptBox[\\(\[ScriptP]\\), \\(_\\)]\
\\) \[Rule] WX, W \[Rule] \[ScriptE]\[Nu]\>\"", ",", " ", "\"\<\>\"", ",", 
             " ", "1960"}], "}"}]}], "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"504", ",", " ", 
           RowBox[{"{", 
            RowBox[{
            "\"\<CDF run 2\>\"", ",", " ", 
             "\"\<\[ScriptP]\\!\\(\\*OverscriptBox[\\(\[ScriptP]\\), \\(_\\)]\
\\) \[Rule] \[ScriptJ]X\>\"", ",", " ", "\"\<\>\"", ",", " ", "1960"}], 
            "}"}]}], "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"514", ",", " ", 
           RowBox[{"{", 
            RowBox[{
            "\"\<D0 Run 2\>\"", ",", " ", 
             "\"\<\[ScriptP]\\!\\(\\*OverscriptBox[\\(\[ScriptP]\\), \\(_\\)]\
\\) \[Rule] \[ScriptJ]X\>\"", ",", " ", "\"\<\>\"", ",", " ", "1960"}], 
            "}"}]}], "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"535", ",", " ", 
           RowBox[{"{", 
            RowBox[{
            "\"\<ATLAS\>\"", ",", " ", 
             "\"\<\[ScriptP]\[ScriptP] \[Rule] \[ScriptJ]X\>\"", ",", " ", 
             "\"\<\>\"", ",", " ", "7000"}], "}"}]}], "}"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"538", ",", " ", 
           RowBox[{"{", 
            RowBox[{
            "\"\<CMS\>\"", ",", " ", 
             "\"\<\[ScriptP]\[ScriptP] \[Rule] \[ScriptJ]X\>\"", ",", " ", 
             "\"\<\>\"", ",", " ", "7000"}], "}"}]}], "}"}]}], "\n", "}"}]}], 
      ";", "\n", "\n", "\n", "\n", 
      RowBox[{"(*", 
       RowBox[{"find", " ", "position", " ", "of", " ", "exptID"}], "*)"}], 
      "\n", 
      RowBox[{"Ecm", "=", 
       RowBox[{"-", "1"}]}], ";", "\n", 
      RowBox[{"IDPosition", "=", 
       RowBox[{"Position", "[", 
        RowBox[{"expidsqrtS", ",", "ExptID"}], "]"}]}], ";", "\n", 
      RowBox[{"(*", "\n", 
       RowBox[{
        RowBox[{
        "if", " ", "find", " ", "one", " ", "match", " ", "exptid", " ", "on",
          " ", "the", " ", "list"}], ",", " ", 
        RowBox[{"return", " ", "Ecm", 
         RowBox[{"(", 
          RowBox[{"sqrt", 
           RowBox[{"(", "S", ")"}]}], ")"}], " ", "of", " ", "that", " ", 
         "exptid"}], ",", "\n", 
        RowBox[{
        "if", " ", "#match", " ", "of", " ", "input", " ", "exptID", " ", 
         "to", " ", "expidS", " ", "is", " ", "not", " ", "1"}], ",", " ", 
        RowBox[{"return", " ", "error", " ", "massage"}]}], "\n", "*)"}], 
      "\n", 
      RowBox[{"If", "[", "\n", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", "IDPosition", "]"}], "==", "1"}], ",", "\n", 
        RowBox[{
         RowBox[{"IDPosition", "=", 
          RowBox[{
           RowBox[{"IDPosition", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}]}], ";", "\n", 
         RowBox[{"Ecm", "=", 
          RowBox[{"expidsqrtS", "[", 
           RowBox[{"[", "IDPosition", "]"}], "]"}]}]}], "\n", ",", "\n", 
        RowBox[{"Print", "[", 
         RowBox[{
         "\"\<error (ExptIDprocess), there is no ID match or more than 1 ID \
match to process table, ID = \>\"", ",", "ExptID"}], "]"}]}], "\n", "]"}], 
      ";", "\n", 
      RowBox[{"(*", "\n", 
       RowBox[{
        RowBox[{"IDPosition", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"Position", "[", 
            RowBox[{"expidsqrtS", ",", "ExptID"}], "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", "\n", 
        RowBox[{"Ecm", "=", 
         RowBox[{
          RowBox[{"expidsqrtS", "[", 
           RowBox[{"[", "IDPosition", "]"}], "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ";"}], "\n", "*)"}], "\n", 
      "Ecm"}]}], "\n", "\n", "]"}]}], "\n", "\n"}]], "Code"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Subroutines to read in the .dta files", "Subsection"],

Cell["\<\
ReadDta splits the .dta file into the list ExperimentRecords of the records \
for each individual experiment\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ReadDta", "=", 
   RowBox[{"Function", "[", 
    RowBox[{"DtaFileName", ",", "\n", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"DtaFile", ",", "ExperimentRecords"}], "}"}], ",", "\n", 
       RowBox[{
        RowBox[{"DtaFile", "=", 
         RowBox[{"OpenRead", "[", "DtaFileName", "]"}]}], ";", "\n", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"DtaFile", "==", "$Failed"}], ",", 
          RowBox[{"Abort", "[", "]"}]}], "]"}], ";", "\n", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{
          "The", " ", "first", " ", "line", " ", "is", " ", "the", " ", 
           "name", " ", "of", " ", "the", " ", "file"}], ";", " ", 
          RowBox[{"dump", " ", "it"}]}], " ", "*)"}], "\n", 
        RowBox[{"Read", "[", 
         RowBox[{"DtaFile", ",", "Record", ",", 
          RowBox[{"RecordSeparators", "->", "\"\<DATA SET\>\""}]}], "]"}], 
        ";", "\n", 
        RowBox[{"(*", "\n", 
         RowBox[{
          RowBox[{"ExperimentRecords", "=", 
           RowBox[{"ReadList", "[", 
            RowBox[{"DtaFile", ",", "Record", ",", 
             RowBox[{"RecordSeparators", "\[Rule]", "\"\<DATA SET:\>\""}]}], 
            "]"}]}], ";"}], "\n", "*)"}], "\n", 
        RowBox[{"(*", 
         RowBox[{"2016.11", ".01", " ", "botingw"}], "*)"}], "\n", 
        RowBox[{"ExperimentRecords", "=", 
         RowBox[{"ReadList", "[", 
          RowBox[{"DtaFile", ",", "Record", ",", 
           RowBox[{"RecordSeparators", "->", "\"\<DATA SET\>\""}]}], "]"}]}], 
        ";", "\n", "\n", 
        RowBox[{"Print", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Dimensions", "[", "ExperimentRecords", "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}], ",", 
          "\"\< experiment record(s) read from \>\"", ",", "DtaFileName"}], 
         "]"}], ";", "\n", 
        RowBox[{"Close", "[", "DtaFile", "]"}], ";", "\n", 
        "ExperimentRecords"}]}], "\n", "]"}]}], "\n", "]"}]}], ";"}]], "Input",
 InitializationCell->True],

Cell["\<\
Read all information from the .dta file into the table of the following format:
{experiment ID, experiment name, normalization factor, number of points, \
description of data columns, the data}\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"PrintExpt", "=", "True"}], ";"}], "*)"}], 
  RowBox[{
   RowBox[{"PrintExpt", "=", "False"}], ";"}]}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"ReadExptTable", "=", 
   RowBox[{"Function", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"DtaFileName", ",", "FileFormat"}], "}"}], ",", "\n", 
     RowBox[{"Module", "[", "\n", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "NExperiments", ",", "MyStream", ",", "ExptID", ",", "R2String", ",", 
         "NormFac", ",", "NPoints", ",", "DataDescription", ",", "DataLabel", 
         ",", "DataString", ",", "NDataColumns", ",", "DataList", ",", 
         "tmpTable", ",", "chi2", ",", "S"}], "}"}], ",", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"20161103", " ", 
           RowBox[{"botingw", ":", " ", "S"}]}], "&"}], " ", "chi2", " ", 
         "become", " ", "local", " ", "variable"}], "*)"}], "\n", "\n", 
       RowBox[{"(*", " ", 
        RowBox[{
        "Read", " ", "the", " ", "experiment", " ", "strings", " ", "from", 
         " ", 
         RowBox[{"the", " ", ".", "dta"}], " ", "file"}], " ", "*)"}], "\n", 
       RowBox[{
        RowBox[{"ExperimentRecords", "=", 
         RowBox[{"ReadDta", "[", "DtaFileName", "]"}]}], ";", "\n", "\n", 
        RowBox[{"NExperiments", "=", 
         RowBox[{
          RowBox[{"Dimensions", "[", "ExperimentRecords", "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", "\n", "\n", 
        RowBox[{"(*", " ", 
         RowBox[{
         "Process", " ", "the", " ", "input", " ", "string", " ", "for", " ", 
          "each", " ", "experiment", " ", "and", " ", "write", " ", "into", 
          " ", "a", " ", "temporary", " ", "table"}], "*)"}], "\n", 
        RowBox[{"If", "[", 
         RowBox[{"PrintExpt", ",", 
          RowBox[{
          "Print", "[", 
           "\"\<#  ExptID ExptName  NormFac  #points  #data entries\>\"", 
           "]"}]}], "]"}], ";", "\n", "\n", 
        RowBox[{"tmpTable", "=", 
         RowBox[{"Table", "[", "\n", 
          RowBox[{
           RowBox[{"{", "\n", 
            RowBox[{
             RowBox[{
              RowBox[{"Experiment", "=", 
               RowBox[{"ExperimentRecords", "[", 
                RowBox[{"[", "iExperiment", "]"}], "]"}]}], ";", "\n", "\n", 
              RowBox[{"MyStream", "=", 
               RowBox[{"StringToStream", "[", "Experiment", "]"}]}], ";", 
              "\n", "\n", 
              RowBox[{"Switch", "[", 
               RowBox[{"FileFormat", ",", "\n", 
                RowBox[{"(*", 
                 RowBox[{"2016.11", ".01", " ", "botingw"}], "*)"}], "\n", 
                "\"\<ct2016\>\"", ",", "\n", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                  "ExptID", ",", "dummy", ",", "dummy", ",", "dummy", ",", 
                   "dummy", ",", "NormFac", ",", "dummy", ",", "dummy", ",", 
                   "dummy", ",", "dummy", ",", "dummy", ",", "NPoints", ",", 
                   "dummy", ",", "dummy", ",", "dummy", ",", "chi2", ",", 
                   "dummy", ",", "S"}], "}"}], "=", 
                 RowBox[{"Read", "[", 
                  RowBox[{"MyStream", ",", 
                   RowBox[{"{", 
                    RowBox[{
                    "Number", ",", "Word", ",", "Word", ",", "Word", ",", 
                    "Word", ",", "Number", ",", "Word", ",", "Word", ",", 
                    "Word", ",", "Word", ",", "Word", ",", "Number", ",", 
                    "Word", ",", "Word", ",", "Word", ",", "Number", ",", 
                    "Word", ",", "Number"}], "}"}]}], "]"}]}], ",", "\n", 
                "\"\<ct66\>\"", ",", "\n", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                  "ExptID", ",", "dummy", ",", "dummy", ",", "dummy", ",", 
                   "dummy", ",", "NormFac", ",", "dummy", ",", "dummy", ",", 
                   "dummy", ",", "dummy", ",", "dummy", ",", "NPoints", ",", 
                   "dummy", ",", "dummy", ",", "dummy", ",", "chi2"}], "}"}], 
                 "=", 
                 RowBox[{"Read", "[", 
                  RowBox[{"MyStream", ",", 
                   RowBox[{"{", 
                    RowBox[{
                    "Number", ",", "Word", ",", "Word", ",", "Word", ",", 
                    "Word", ",", "Number", ",", "Word", ",", "Word", ",", 
                    "Word", ",", "Word", ",", "Word", ",", "Number", ",", 
                    "Word", ",", "Word", ",", "Word", ",", "Number"}], 
                    "}"}]}], "]"}]}], ",", "\n", "\"\<ct60\>\"", ",", "\n", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                  "ExptID", ",", "dummy", ",", "dummy", ",", "dummy", ",", 
                   "dummy", ",", "NormFac", ",", "dummy", ",", "dummy", ",", 
                   "dummy", ",", "dummy", ",", "dummy", ",", "NPoints"}], 
                  "}"}], "=", 
                 RowBox[{"Read", "[", 
                  RowBox[{"MyStream", ",", 
                   RowBox[{"{", 
                    RowBox[{
                    "Number", ",", "Word", ",", "Word", ",", "Word", ",", 
                    "Word", ",", "Number", ",", "Word", ",", "Word", ",", 
                    "Word", ",", "Word", ",", "Word", ",", "Number"}], 
                    "}"}]}], "]"}]}], ",", "\n", "_", ",", "\n", 
                RowBox[{"Print", "[", 
                 RowBox[{
                 "\"\<Wrong FileFormat value=\>\"", ",", "FileFormat"}], 
                 "]"}]}], "\n", "]"}], ";", "\n", "\n", 
              RowBox[{"(*", " ", 
               RowBox[{
               "Read", " ", "one", " ", "or", " ", "two", " ", "line", " ", 
                "of", " ", "the", " ", "data", " ", "description"}], " ", 
               "*)"}], "\n", 
              RowBox[{"DataDescription", "=", 
               RowBox[{"Read", "[", 
                RowBox[{"MyStream", ",", "Record"}], "]"}]}], ";", "\n", 
              RowBox[{"(*", 
               RowBox[{
               "Read", " ", "correlated", " ", "systematic", " ", "error", 
                " ", "parameters"}], " ", "*)"}], "\n", 
              RowBox[{"R2String", "=", "\"\<\>\""}], ";", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"StringMatchQ", "[", 
                 RowBox[{"DataDescription", ",", "\"\<*r(k)*\>\""}], "]"}], 
                ",", "\n", 
                RowBox[{"R2String", "=", "DataDescription"}]}], "]"}], ";", 
              RowBox[{"(*", 
               RowBox[{
                RowBox[{
                 RowBox[{"Read", "[", 
                  RowBox[{"MyStream", ",", "Record"}], "]"}], "]"}], ";"}], 
               "*)"}], 
              RowBox[{"(*", " ", 
               RowBox[{
                RowBox[{"Correlated", " ", "systematic", " ", "errors"}], " ",
                 "\[Rule]"}], " ", "*)"}], "\n", 
              RowBox[{"(*", 
               RowBox[{"20170828", ":", " ", 
                RowBox[{
                "add", " ", "the", " ", "info", " ", "of", " ", "column", " ",
                  "labels", " ", "of", " ", "data"}]}], "*)"}], "\n", 
              RowBox[{"DataLabel", "=", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"StringMatchQ", "[", 
                  RowBox[{"DataDescription", ",", "\"\<*r(k)*\>\""}], "]"}], 
                 ",", 
                 RowBox[{"Read", "[", 
                  RowBox[{"MyStream", ",", "Record"}], "]"}], ",", 
                 "DataDescription"}], "]"}]}], ";", "\n", "\n", 
              RowBox[{"(*", " ", 
               RowBox[{
                RowBox[{
                "Read", " ", "in", " ", "the", " ", "data", " ", "string", 
                 " ", "and", " ", "get", " ", "rid", " ", "of", " ", "the", 
                 " ", "intermediary", " ", "comments", " ", "specifying", " ",
                  "the", " ", "value", " ", "of", " ", "x"}], ",", " ", "yj", 
                ",", " ", 
                RowBox[{"etc", "."}]}], "*)"}], "\n", 
              RowBox[{"DataString", "=", 
               RowBox[{"Select", "[", 
                RowBox[{
                 RowBox[{"ReadList", "[", 
                  RowBox[{"MyStream", ",", "Record"}], "]"}], ",", "\n", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"!", 
                    RowBox[{"StringMatchQ", "[", 
                    RowBox[{"#", ",", "\"\<* X *\>\""}], "]"}]}], " ", "&&", 
                   " ", 
                   RowBox[{"!", 
                    RowBox[{"StringMatchQ", "[", 
                    RowBox[{"#", ",", "\"\<*Tau*\>\""}], "]"}]}], "&&", " ", 
                   RowBox[{"!", 
                    RowBox[{"StringMatchQ", "[", 
                    RowBox[{"#", ",", "\"\<*Y*\>\""}], "]"}]}]}], "&"}]}], 
                "]"}]}], ";", "\n", "\n", 
              RowBox[{"(*", " ", 
               RowBox[{
               "Determine", " ", "the", " ", "number", " ", "of", " ", "data",
                 " ", "columns", " ", "by", " ", "sampling", " ", "the", " ", 
                "first", " ", "element", " ", "of", " ", "DataString"}], " ", 
               "*)"}], "\n", 
              RowBox[{"NDataColumns", "=", 
               RowBox[{
                RowBox[{"Dimensions", "[", 
                 RowBox[{"ReadList", "[", 
                  RowBox[{
                   RowBox[{"StringToStream", "[", 
                    RowBox[{"DataString", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", "Number"}], 
                  "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}]}], ";", "\n", "\n", 
              RowBox[{"(*", 
               RowBox[{
               "Append", " ", "a", " ", "blank", " ", "character", " ", "to", 
                " ", "the", " ", "end", " ", "of", " ", "each", " ", "line", 
                " ", "in", " ", "DataString", " ", "to", " ", "separate", " ",
                 "the", " ", "first", " ", "number", " ", "in", " ", "each", 
                " ", "line", " ", "from", " ", "the", " ", "last", " ", 
                "number", " ", "in", " ", "the", " ", "previous", " ", "line",
                 " ", "in", " ", "the", " ", "concatenated", " ", "string"}], 
               " ", "*)"}], "\n", 
              RowBox[{"DataString", "=", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"StringJoin", "[", 
                   RowBox[{"#", ",", "\"\< \>\""}], "]"}], "&"}], "/@", 
                 "DataString"}], ")"}]}], ";", "\n", "\n", 
              RowBox[{"(*", " ", 
               RowBox[{"Finally", ",", " ", 
                RowBox[{"read", " ", "the", " ", "data", " ", "list"}]}], " ",
                "*)"}], "\n", 
              RowBox[{"DataList", "=", 
               RowBox[{"ReadList", "[", 
                RowBox[{
                 RowBox[{"StringToStream", "[", 
                  RowBox[{"StringJoin", "[", "DataString", "]"}], "]"}], ",", 
                 
                 RowBox[{
                  RowBox[{"Table", "[", 
                   RowBox[{"Number", ",", 
                    RowBox[{"{", "NDataColumns", "}"}]}], "]"}], "/.", 
                  RowBox[{"List", "->", "LF"}]}]}], "]"}]}], ";", "\n", "\n", 
              
              RowBox[{"If", "[", 
               RowBox[{"PrintExpt", ",", 
                RowBox[{"Print", "[", 
                 RowBox[{
                 "iExperiment", ",", "\"\<  \>\"", ",", "ExptID", ",", 
                  "\"\<    \>\"", ",", 
                  RowBox[{"ExptIDtoName", "[", "ExptID", "]"}], ",", 
                  "\"\<    \>\"", ",", "NormFac", ",", "\"\<     \>\"", ",", 
                  "NPoints", ",", "\"\<     \>\"", ",", 
                  RowBox[{"Dimensions", "[", "DataList", "]"}]}], "]"}]}], 
               "]"}], ";", "\n", 
              RowBox[{"Close", "[", "MyStream", "]"}], ";", "\n", "ExptID"}], 
             ",", 
             RowBox[{"ExptIDtoName", "[", "ExptID", "]"}], ",", "DataLabel", 
             ",", "NormFac", ",", "NPoints", ",", "DataDescription", ",", 
             "DataList", ",", "S", ",", "R2String"}], "\n", "}"}], ",", "\n", 
           
           RowBox[{"{", 
            RowBox[{"iExperiment", ",", "NExperiments"}], "}"}]}], "]"}]}], 
        ";", 
        RowBox[{"(*", " ", 
         RowBox[{"tmpTable", " ", "\[Rule]"}], " ", "*)"}], "\n", 
        "tmpTable"}]}], "\n", "]"}]}], 
    RowBox[{"(*", " ", 
     RowBox[{"Module", " ", "\[Rule]"}], "*)"}], "\n", "]"}]}], ";", 
  RowBox[{"(*", " ", 
   RowBox[{"Function", " ", "->"}], "*)"}]}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{"EZIDecomposition", "=", 
  RowBox[{"Function", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"InputMatrix", ",", "rank", ",", "eps1", ",", "PrintMode"}], 
     "}"}], ",", "\n", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "\[CapitalLambda]", ",", "U", ",", "Npt", ",", "\[Rho]", ",", 
        "\[Rho]s", ",", "\[CapitalSigma]", ",", "\[Rho]hat", ",", "as", ",", 
        "bs"}], "}"}], ",", "\n", 
      RowBox[{
       RowBox[{"Npt", "=", 
        RowBox[{"Length", "[", "InputMatrix", "]"}]}], ";", "\n", 
       RowBox[{"\[CapitalSigma]", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"InputMatrix", "[", 
            RowBox[{"[", 
             RowBox[{"i", ",", "i"}], "]"}], "]"}], "-", "1"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "Npt"}], "}"}]}], "]"}]}], ";", "\n", 
       RowBox[{"\[Rho]s", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"i", "==", "j"}], ",", "1", ",", 
            RowBox[{"InputMatrix", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "j"}], "]"}], "]"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "Npt"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", "Npt"}], "}"}]}], "]"}]}], ";", "\n", 
       RowBox[{"as", "=", 
        RowBox[{"eps1", "*", "1000"}]}], ";", "\n", 
       RowBox[{"While", "[", 
        RowBox[{
         RowBox[{"as", ">", "eps1"}], ",", "\n", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"\[CapitalLambda]", ",", "U"}], "}"}], "=", 
           RowBox[{"Eigensystem", "[", "\[Rho]s", "]"}]}], ";", "\n", 
          RowBox[{"\[Rho]", "=", 
           RowBox[{
            RowBox[{"Transpose", "[", "U", "]"}], ".", 
            RowBox[{"DiagonalMatrix", "[", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"i", "<=", "rank"}], ",", 
                 RowBox[{"\[CapitalLambda]", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], ",", "0"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"i", ",", "Npt"}], "}"}]}], "]"}], "]"}], ".", 
            "U"}]}], ";", "\n", 
          RowBox[{"as", "=", 
           RowBox[{"Sum", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[Rho]s", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "j"}], "]"}], "]"}], "-", 
                RowBox[{"\[Rho]", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "j"}], "]"}], "]"}]}], ")"}], "^", "2"}], 
             ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "Npt"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"j", ",", "Npt"}], "}"}]}], "]"}]}], ";", "\n", 
          RowBox[{"s", "=", 
           RowBox[{"DiagonalMatrix", "[", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"Sqrt", "[", 
               RowBox[{"\[Rho]", "[", 
                RowBox[{"[", 
                 RowBox[{"i", ",", "i"}], "]"}], "]"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"i", ",", "Npt"}], "}"}]}], "]"}], "]"}]}], ";", "\n", 
          
          RowBox[{"\[Rho]hat", "=", 
           RowBox[{
            RowBox[{"Inverse", "[", "s", "]"}], ".", "\[Rho]", ".", 
            RowBox[{"Inverse", "[", "s", "]"}]}]}], ";", " ", "\n", 
          RowBox[{"\[Rho]s", "=", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"i", "==", "j"}], ",", "1", ",", 
               RowBox[{"\[Rho]", "[", 
                RowBox[{"[", 
                 RowBox[{"i", ",", "j"}], "]"}], "]"}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "Npt"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"j", ",", "Npt"}], "}"}]}], "]"}]}], ";", "\n", 
          RowBox[{"bs", "=", 
           RowBox[{"Sum", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"InputMatrix", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "j"}], "]"}], "]"}], "-", 
                RowBox[{"\[Rho]hat", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "j"}], "]"}], "]"}]}], ")"}], "^", "2"}], 
             ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "Npt"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"j", ",", "Npt"}], "}"}]}], "]"}]}], ";", "\n", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"PrintMode", "==", "1"}], ",", 
            RowBox[{"Print", "[", 
             RowBox[{
             "\"\<as, bs = \>\"", ",", "as", ",", "\"\<   \>\"", ",", "bs"}], 
             "]"}]}], "]"}], ";"}]}], "\n", "]"}], 
       RowBox[{"(*", 
        RowBox[{"While", "\[Rule]"}], "*)"}], ";", 
       RowBox[{"{", 
        RowBox[{"bs", ",", "\[Rho]hat"}], "}"}]}]}], "\n", "]"}]}], 
   RowBox[{"(*", 
    RowBox[{"Module", "\[Rule]"}], "*)"}], "\n", "]"}], 
  RowBox[{"(*", 
   RowBox[{"Function", "\[Rule]"}], "*)"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"2016.11", ".01", " ", "botingw"}], "*)"}], "\n", 
  RowBox[{"(*", 
   RowBox[{
   "read", " ", "specific", " ", "member", " ", "of", " ", "a", " ", 
    "colume"}], "*)"}], "\n", 
  RowBox[{
   RowBox[{
    RowBox[{"selectdatacolume", "[", 
     RowBox[{"datain_", ",", "collistin_"}], "]"}], ":=", "\n", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"data", "=", "datain"}], ",", 
        RowBox[{"collist", "=", "collistin"}], ",", "datatmp", ",", "output", 
        ",", "i"}], "}"}], ",", "\n", 
      RowBox[{"(*", "\n", 
       RowBox[{
        RowBox[{"data", "=", 
         RowBox[{"data", "/.", 
          RowBox[{"List", "\[RuleDelayed]", "LF"}]}]}], ";", "\n", 
        RowBox[{"data", "=", 
         RowBox[{"data", "/.", 
          RowBox[{
           RowBox[{"LF", "[", "x__", "]"}], "\[RuleDelayed]", 
           RowBox[{
            RowBox[{"{", "x", "}"}], "[", 
            RowBox[{"[", "Xindex", "]"}], "]"}]}]}]}], ";", "\n", "data"}], 
       "\n", "*)"}], "\n", 
      RowBox[{"(*", "\n", 
       RowBox[{
        RowBox[{"output", "=", 
         RowBox[{"Table", "[", "\n", 
          RowBox[{
           RowBox[{"datatmp", "=", 
            RowBox[{
             RowBox[{"data", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "/.", 
             RowBox[{"List", "\[RuleDelayed]", "LF"}]}]}], ",", "\n", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", 
             RowBox[{"Length", "[", "data", "]"}]}], "}"}]}], "\n", "]"}]}], 
        ";"}], "\n", "*)"}], "\n", 
      RowBox[{
       RowBox[{"output", "=", 
        RowBox[{
         RowBox[{"data", "/.", 
          RowBox[{
           RowBox[{"LF", "[", "a__", "]"}], ":>", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"{", "a", "}"}], "[", 
              RowBox[{"[", 
               RowBox[{"collist", "[", 
                RowBox[{"[", "i", "]"}], "]"}], " ", "]"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "1", ",", 
               RowBox[{"Length", "[", "collist", "]"}]}], "}"}]}], "]"}]}]}], 
         "/.", 
         RowBox[{"List", ":>", "LF"}]}]}], ";", "\n", "\n", 
       RowBox[{"output", "=", 
        RowBox[{"Table", "[", "\n", 
         RowBox[{
          RowBox[{"datatmp", "=", 
           RowBox[{
            RowBox[{"output", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "/.", 
            RowBox[{"List", ":>", "LF"}]}]}], ",", "\n", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", 
            RowBox[{"Length", "[", "output", "]"}]}], "}"}]}], "\n", "]"}]}], 
       ";", "\n", "\n", "output"}]}], " ", "\n", "]"}]}], ";"}]}]], "Code",
 InitializationCell->False],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ExptIDinfo", "[", "ExptIDin_", "]"}], ":=", "\n", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ExptID", "=", "ExptIDin"}], ",", "output", ",", "expItype", 
       ",", "VBPtype1", ",", "VBPtype2", ",", "VBPtype3", ",", "\n", "JP", 
       ",", "ttbarpT", ",", "ttbarmtt", ",", "ttbary", ",", "ID267", ",", 
       "ID247", ",", "ID252", ",", "ID253", ",", "ID254", ",", "ID255"}], 
      "}"}], ",", "\n", 
     RowBox[{"(*", "\n", 
      RowBox[{
       RowBox[{"1", ":", "DIS"}], ";", "\n", 
       RowBox[{"2", ":", 
        RowBox[{"VBP", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"VectorBosonProd", "."}], ";", 
            RowBox[{
             RowBox[{"real", "/", "virtual"}], " ", "photon"}], ";", "W"}], 
           ",", "Z", ",", "..."}], ")"}], "\n", "3"}], ":", 
        RowBox[{"Direct", " ", "Photon", "\n", "4"}], ":", 
        RowBox[{"Heavy", " ", "Quark", " ", "production", "\n", "5"}], ":", 
        RowBox[{"Jet", " ", "production"}]}]}], "\n", "*)"}], "\n", "\n", 
     RowBox[{"(*", "\n", 
      RowBox[{
       RowBox[{"VBPtype", "\n", 
        RowBox[{"format", ":", "\n", "1", ":", " ", "Q"}]}], ",", " ", 
       RowBox[{
        RowBox[{"tau", "\n", "2"}], ":", " ", "Q"}], ",", " ", "y", ",", " ", 
       
       RowBox[{
        RowBox[{"sqrt", 
         RowBox[{"(", "S", ")"}], "\n", "3"}], ":", " ", 
        RowBox[{"Asym", 
         RowBox[{"(", "yl", ")"}]}]}]}], "\n", "*)"}], "\n", "\n", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"seems", " ", "not", " ", "totally", " ", "right"}], ",", " ", 
       
       RowBox[{"need", " ", "to", " ", "check", " ", "later"}]}], "*)"}], 
     "\n", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{
        "200170426", " ", "new", " ", "CT14NNLO", " ", "add", " ", "new", " ",
          "exptid"}], " ", "=", " ", "245"}], ",", "246", ",", "247", ",", 
       "542", ",", "544"}], "*)"}], "\n", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"20170530", ":", " ", "240"}], ",", "268", ",", 
       RowBox[{
        RowBox[{
         RowBox[{"245", " ", "are", " ", "mix", " ", "of", " ", "W"}], "&"}], 
        "Z"}], ",", " ", 
       RowBox[{
        RowBox[{"it", "'"}], "s", " ", "dangerous", " ", "to", " ", "use", 
        " ", "formula", " ", "of", " ", "VBPtype2"}], ",", " ", 
       RowBox[{
       "3", " ", "on", " ", "these", " ", "processes", "\n", "however"}], ",",
        " ", 
       RowBox[{"since", " ", "VBPtype2"}], ",", " ", 
       RowBox[{"3", " ", "formulas", " ", "are", " ", "the", " ", "same"}], 
       ",", " ", 
       RowBox[{
       "I", " ", "still", " ", "add", " ", "them", " ", "into", " ", 
        "VBPtype2", " ", "for", " ", "researching", " ", "how", " ", "well", 
        " ", "formulas", " ", "works", " ", "on", " ", "them"}]}], " ", 
      "*)"}], "\n", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"20170602", ":", " ", "249", ":", 
        RowBox[{"W", " ", "asym"}]}], ",", " ", 
       RowBox[{"250", ":", " ", 
        RowBox[{
         RowBox[{"W", "/", "Z"}], " ", "mix"}]}], ",", " ", 
       RowBox[{
        RowBox[{"565", "~", "568"}], ":", " ", "ttbbar"}], ",", " ", 
       RowBox[{
        RowBox[{"don", "'"}], "t", " ", "sure", " ", "whether", " ", "them", 
        " ", "work", " ", "on", " ", "JP", " ", "formula"}], ",", " ", 
       RowBox[{
       "but", " ", "still", " ", "add", " ", "them", " ", "into", " ", 
        "it"}]}], "*)"}], "\n", 
     RowBox[{"(*", 
      RowBox[{"20170606", ":", " ", 
       RowBox[{"248", " ", 
        RowBox[{"W", "/", "Z"}], " ", "mix"}]}], "*)"}], "\n", 
     RowBox[{
      RowBox[{"VBPtype1", "=", 
       RowBox[{"{", "}"}]}], ";", "\n", 
      RowBox[{"VBPtype2", "=", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "201", ",", "203", ",", "204", ",", "260", ",", "261", ",", "268", 
          ",", "240"}], "}"}], "~", "Join", "~", 
        RowBox[{"{", 
         RowBox[{"246", ",", "245", ",", "250", ",", "248"}], "}"}]}]}], ";", 
      "\n", 
      RowBox[{"VBPtype3", "=", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"225", ",", "227", ",", "234", ",", 
          RowBox[{"(*", 
           RowBox[{"267", ","}], "*)"}], "281", ",", "241", ",", "266"}], 
         "}"}], "~", "Join", "~", 
        RowBox[{"{", "249", "}"}]}]}], ";", "\n", "\n", 
      RowBox[{"(*", "20171118", "*)"}], "\n", 
      RowBox[{"JP", "=", 
       RowBox[{"{", 
        RowBox[{
        "504", ",", "514", ",", "535", ",", "538", ",", "542", ",", "544", 
         ",", "545"}], "}"}]}], ";", "\n", 
      RowBox[{"ttbarpT", "=", 
       RowBox[{"{", "565", "}"}]}], ";", "\n", 
      RowBox[{"ttbarmtt", "=", 
       RowBox[{"{", "567", "}"}]}], ";", "\n", 
      RowBox[{"ttbary", "=", 
       RowBox[{"{", 
        RowBox[{"566", ",", "568"}], "}"}]}], ";", "\n", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"20171121", ":", " ", 
          RowBox[{
           RowBox[{"it", "'"}], "s", " ", "Q"}]}], " ", "=", " ", "0"}], ",", 
        " ", 
        RowBox[{"set", " ", "it", " ", "as", " ", "W", " ", "mass"}]}], 
       "*)"}], "\n", 
      RowBox[{"ID267", "=", 
       RowBox[{"{", "267", "}"}]}], ";", "\n", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"20171130", ":", " ", "Zpt"}], ",", " ", 
        RowBox[{
         RowBox[{"Q", "^", "2"}], "=", 
         RowBox[{
          RowBox[{
           RowBox[{"Subscript", "[", 
            RowBox[{"M", ",", " ", "Z"}], "]"}], "^", "2"}], "+", 
          RowBox[{"Subscript", "[", 
           RowBox[{
            RowBox[{"p", "^", "2"}], ",", " ", "T"}], "]"}]}]}]}], "*)"}], 
      "\n", 
      RowBox[{"ID247", "=", 
       RowBox[{"{", "247", "}"}]}], ";", "\n", 
      RowBox[{"(*", 
       RowBox[{
       "20171208", " ", "add", " ", "customized", " ", "formulas", " ", "for",
         " ", 
        RowBox[{"252", " ", "~", " ", "255"}]}], "*)"}], "\n", 
      RowBox[{"ID252", "=", 
       RowBox[{"{", "252", "}"}]}], ";", "\n", 
      RowBox[{"ID253", "=", 
       RowBox[{"{", "253", "}"}]}], ";", "\n", 
      RowBox[{"ID254", "=", 
       RowBox[{"{", "254", "}"}]}], ";", "\n", 
      RowBox[{"ID255", "=", 
       RowBox[{"{", "255", "}"}]}], ";", "\n", "\n", 
      RowBox[{"expItype", "=", "\n", 
       RowBox[{"Which", "[", "\n", 
        RowBox[{
         RowBox[{
          RowBox[{"ExptID", ">", "99"}], " ", "&&", " ", 
          RowBox[{"ExptID", "<", "200"}]}], ",", "\n", "\"\<DIS\>\"", ",", 
         "\n", " ", 
         RowBox[{
          RowBox[{"ExptID", ">", "199"}], " ", "&&", " ", 
          RowBox[{"ExptID", "<", "300"}], " ", "&&", " ", 
          RowBox[{"SubsetQ", "[", 
           RowBox[{"VBPtype1", ",", 
            RowBox[{"{", "ExptID", "}"}]}], "]"}]}], ",", "\n", 
         "\"\<VBP1\>\"", ",", "\n", " ", 
         RowBox[{
          RowBox[{"ExptID", ">", "199"}], " ", "&&", " ", 
          RowBox[{"ExptID", "<", "300"}], " ", "&&", " ", 
          RowBox[{"SubsetQ", "[", 
           RowBox[{"VBPtype2", ",", 
            RowBox[{"{", "ExptID", "}"}]}], "]"}]}], ",", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"Z", " ", "\[Rule]", " ", 
            RowBox[{"l", "+", "l", "-"}]}], ",", " ", 
           RowBox[{
            RowBox[{"dXsec", "/", "dy"}], 
            RowBox[{"(", "l", ")"}]}]}], "*)"}], "\n", "\"\<VBP2\>\"", ",", 
         "\n", " ", 
         RowBox[{
          RowBox[{"ExptID", ">", "199"}], " ", "&&", " ", 
          RowBox[{"ExptID", "<", "300"}], " ", "&&", " ", 
          RowBox[{"SubsetQ", "[", 
           RowBox[{"VBPtype3", ",", 
            RowBox[{"{", "ExptID", "}"}]}], "]"}]}], ",", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"W", " ", "\[Rule]", " ", "lv"}], ",", " ", "asym"}], 
          "*)"}], "\n", "\"\<VBP3\>\"", ",", "\n", 
         RowBox[{
          RowBox[{"ExptID", ">", "199"}], " ", "&&", " ", 
          RowBox[{"ExptID", "<", "300"}], " ", "&&", " ", 
          RowBox[{"SubsetQ", "[", 
           RowBox[{"ID267", ",", 
            RowBox[{"{", "ExptID", "}"}]}], "]"}]}], ",", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"W", " ", "\[Rule]", " ", "lv"}], ",", " ", "asym"}], 
          "*)"}], "\n", "\"\<ID267\>\"", ",", "\n", 
         RowBox[{
          RowBox[{"ExptID", ">", "199"}], " ", "&&", " ", 
          RowBox[{"ExptID", "<", "300"}], " ", "&&", " ", 
          RowBox[{"SubsetQ", "[", 
           RowBox[{"ID247", ",", 
            RowBox[{"{", "ExptID", "}"}]}], "]"}]}], ",", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"W", " ", "\[Rule]", " ", "lv"}], ",", " ", "asym"}], 
          "*)"}], "\n", "\"\<ID247\>\"", ",", "\n", 
         RowBox[{
          RowBox[{"ExptID", ">", "199"}], " ", "&&", " ", 
          RowBox[{"ExptID", "<", "300"}], " ", "&&", " ", 
          RowBox[{"SubsetQ", "[", 
           RowBox[{"ID252", ",", 
            RowBox[{"{", "ExptID", "}"}]}], "]"}]}], ",", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"W", " ", "\[Rule]", " ", "lv"}], ",", " ", "asym"}], 
          "*)"}], "\n", "\"\<ID252\>\"", ",", "\n", 
         RowBox[{
          RowBox[{"ExptID", ">", "199"}], " ", "&&", " ", 
          RowBox[{"ExptID", "<", "300"}], " ", "&&", " ", 
          RowBox[{"SubsetQ", "[", 
           RowBox[{"ID253", ",", 
            RowBox[{"{", "ExptID", "}"}]}], "]"}]}], ",", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"W", " ", "\[Rule]", " ", "lv"}], ",", " ", "asym"}], 
          "*)"}], "\n", "\"\<ID253\>\"", ",", "\n", 
         RowBox[{
          RowBox[{"ExptID", ">", "199"}], " ", "&&", " ", 
          RowBox[{"ExptID", "<", "300"}], " ", "&&", " ", 
          RowBox[{"SubsetQ", "[", 
           RowBox[{"ID254", ",", 
            RowBox[{"{", "ExptID", "}"}]}], "]"}]}], ",", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"W", " ", "\[Rule]", " ", "lv"}], ",", " ", "asym"}], 
          "*)"}], "\n", "\"\<ID254\>\"", ",", "\n", 
         RowBox[{
          RowBox[{"ExptID", ">", "199"}], " ", "&&", " ", 
          RowBox[{"ExptID", "<", "300"}], " ", "&&", " ", 
          RowBox[{"SubsetQ", "[", 
           RowBox[{"ID255", ",", 
            RowBox[{"{", "ExptID", "}"}]}], "]"}]}], ",", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"W", " ", "\[Rule]", " ", "lv"}], ",", " ", "asym"}], 
          "*)"}], "\n", "\"\<ID255\>\"", ",", "\n", " ", 
         RowBox[{
          RowBox[{"ExptID", ">", "199"}], " ", "&&", " ", 
          RowBox[{"ExptID", "<", "300"}]}], ",", "\n", "\"\<VBPothers\>\"", 
         ",", "\n", " ", 
         RowBox[{
          RowBox[{"ExptID", ">", "299"}], " ", "&&", " ", 
          RowBox[{"ExptID", "<", "400"}]}], ",", "\n", "\"\<DP\>\"", ",", 
         "\n", " ", 
         RowBox[{
          RowBox[{"ExptID", ">", "399"}], " ", "&&", " ", 
          RowBox[{"ExptID", "<", "500"}]}], ",", "\n", "\"\<HQP\>\"", ",", 
         "\n", " ", 
         RowBox[{
          RowBox[{"ExptID", ">", "499"}], " ", "&&", " ", 
          RowBox[{"ExptID", "<", "600"}], " ", "&&", "  ", 
          RowBox[{"SubsetQ", "[", 
           RowBox[{"JP", ",", 
            RowBox[{"{", "ExptID", "}"}]}], "]"}]}], ",", "\n", "\"\<JP\>\"", 
         ",", "\n", 
         RowBox[{
          RowBox[{"ExptID", ">", "499"}], " ", "&&", " ", 
          RowBox[{"ExptID", "<", "600"}], " ", "&&", "  ", 
          RowBox[{"SubsetQ", "[", 
           RowBox[{"ttbarpT", ",", 
            RowBox[{"{", "ExptID", "}"}]}], "]"}]}], ",", "\n", 
         "\"\<ttbarpT\>\"", ",", "\n", " ", 
         RowBox[{
          RowBox[{"ExptID", ">", "499"}], " ", "&&", " ", 
          RowBox[{"ExptID", "<", "600"}], " ", "&&", "  ", 
          RowBox[{"SubsetQ", "[", 
           RowBox[{"ttbarmtt", ",", 
            RowBox[{"{", "ExptID", "}"}]}], "]"}]}], ",", "\n", 
         "\"\<ttbarmtt\>\"", ",", "\n", " ", 
         RowBox[{
          RowBox[{"ExptID", ">", "499"}], " ", "&&", " ", 
          RowBox[{"ExptID", "<", "600"}], " ", "&&", "  ", 
          RowBox[{"SubsetQ", "[", 
           RowBox[{"ttbary", ",", 
            RowBox[{"{", "ExptID", "}"}]}], "]"}]}], ",", "\n", 
         "\"\<ttbary\>\"", ",", "\n", " ", 
         RowBox[{
          RowBox[{"ExptID", ">", "599"}], " ", "&&", " ", 
          RowBox[{"ExptID", "<", "700"}]}], ",", "\n", "\"\<undefine\>\"", 
         ",", "\n", " ", 
         RowBox[{
          RowBox[{"ExptID", ">", "699"}], " ", "&&", " ", 
          RowBox[{"ExptID", "<", "800"}]}], ",", "\n", "\"\<undefine\>\"", 
         ",", "\n", "_", ",", "\n", 
         RowBox[{
          RowBox[{"Print", "[", 
           RowBox[{"\"\<Wrong ExptID value=\>\"", ",", "ExptID"}], "]"}], 
          ";"}]}], "\n", "]"}]}], ";", "\n", "\n", 
      RowBox[{"(*", "\n", 
       RowBox[{
        RowBox[{"type1a", "\[Equal]", " ", 
         RowBox[{"lp", " ", "scattering"}]}], ",", " ", "DIS", ",", " ", 
        RowBox[{
         RowBox[{"NC", "\n", "type1b"}], "\[Equal]", " ", 
         RowBox[{"lp", " ", "scattering"}]}], ",", " ", "DIS", ",", " ", 
        RowBox[{
         RowBox[{
          RowBox[{"CC", "\n", "type2a"}], "\[Equal]", " ", "lp"}], " ", 
         "\[Rule]", " ", "cX"}], ",", " ", "DIS", ",", " ", 
        RowBox[{
         RowBox[{
          RowBox[{"NC", "\n", "type2b"}], "\[Equal]", " ", "lp"}], " ", 
         "\[Rule]", " ", "bX"}], ",", " ", "DIS", ",", " ", 
        RowBox[{
         RowBox[{
          RowBox[{"NC", "\n", "type3"}], "\[Equal]", " ", "lN"}], " ", 
         "\[Rule]", " ", "X"}], ",", " ", 
        RowBox[{
         RowBox[{
          RowBox[{"DIS", "\n", "type4a"}], "\[Equal]", " ", "nuN"}], " ", 
         "\[Rule]", " ", "X"}], ",", " ", 
        RowBox[{
         RowBox[{
          RowBox[{"DIS", "\n", "type4b"}], "\[Equal]", " ", "nuN"}], " ", 
         "\[Rule]", " ", "cX"}], ",", " ", 
        RowBox[{
         RowBox[{
          RowBox[{"DIS", "\n", "type5"}], "\[Equal]", " ", "pN"}], " ", 
         "\[Rule]", " ", 
         RowBox[{"l", "+", "l", "-", "X"}]}], ",", " ", 
        RowBox[{
         RowBox[{
          RowBox[{"VBP", "\n", "type6"}], "\[Equal]", " ", "ppbar"}], " ", 
         "\[Rule]", " ", 
         RowBox[{"l", "+", "l", "-", "X"}]}], ",", " ", 
        RowBox[{
         RowBox[{
          RowBox[{"VBP", "\n", "type7"}], "\[Equal]", " ", "ppbar"}], " ", 
         "\[Rule]", " ", 
         RowBox[{"l", " ", "nu", " ", "X"}]}], ",", " ", 
        RowBox[{
         RowBox[{
          RowBox[{"VBP", "\n", "type8"}], "\[Equal]", " ", "ppbar"}], " ", 
         "\[Rule]", " ", 
         RowBox[{"jet", " ", "X"}]}], ",", " ", 
        RowBox[{
         RowBox[{"JP", "\n", "type9a"}], "\[Equal]", " ", 
         RowBox[{"ld", " ", "scattering"}]}], ",", " ", "DIS", ",", " ", 
        RowBox[{
         RowBox[{"NC", "\n", "type9b"}], "\[Equal]", " ", 
         RowBox[{"ld", " ", "scattering"}]}], ",", " ", "DIS", ",", " ", 
        RowBox[{
         RowBox[{
          RowBox[{"CC", "\n", "type10a"}], "\[Equal]", " ", "nuFe"}], " ", 
         "\[Rule]", " ", "X"}], ",", " ", 
        RowBox[{
         RowBox[{
          RowBox[{"DIS", "\n", "type10b"}], "\[Equal]", " ", "nuFe"}], " ", 
         "\[Rule]", " ", "cX"}], ",", " ", 
        RowBox[{
         RowBox[{"DIS", "\n", "type11"}], "\[Equal]", " ", 
         RowBox[{"p", " ", "copper", " ", "scattering"}]}], ",", " ", 
        RowBox[{
         RowBox[{
          RowBox[{"VBP", "\n", "type12"}], "==", "pd"}], " ", "\[Rule]", " ", 
         
         RowBox[{"l", "+", "l", "-", "X"}]}], ",", " ", 
        RowBox[{
         RowBox[{"VBP", "\n", "\n", "type9"}], "\[Equal]", " ", 
         RowBox[{
         "combination", " ", "of", " ", "pp", " ", "and", " ", "pN", " ", 
          "scattering", " ", 
          RowBox[{"(", 
           RowBox[{"pd", ",", " ", 
            RowBox[{"p", " ", "copper"}], ",", " ", 
            RowBox[{"nu", " ", "Fe"}]}], ")"}]}]}]}], "\n", "*)"}], "\n", 
      "\n", 
      RowBox[{"(*", "\n", 
       RowBox[{
        RowBox[{"type1a", "=", 
         RowBox[{"{", 
          RowBox[{"101", ",", "106", ",", "169"}], "}"}]}], ";", "\n", 
        RowBox[{"type1b", "=", 
         RowBox[{"{", 
          RowBox[{"145", ",", "147"}], "}"}]}], ";", "\n", 
        RowBox[{"type2a", "=", 
         RowBox[{"{", "}"}]}], ";", "\n", 
        RowBox[{"type2b", "=", 
         RowBox[{"{", "}"}]}], ";", "\n", 
        RowBox[{"type3", "=", 
         RowBox[{"{", "}"}]}], ";", "\n", 
        RowBox[{"type4a", "=", 
         RowBox[{"{", "}"}]}], ";", "\n", 
        RowBox[{"type4b", "=", 
         RowBox[{"{", 
          RowBox[{"124", ",", "125"}], "}"}]}], ";", "\n", 
        RowBox[{"type5", "=", 
         RowBox[{"{", "}"}]}], ";", "\n", 
        RowBox[{"type6", "=", 
         RowBox[{"{", 
          RowBox[{"260", ",", "261"}], "}"}]}], ";", "\n", 
        RowBox[{"type7", "=", 
         RowBox[{"{", 
          RowBox[{
          "225", ",", "227", ",", "234", ",", "241", ",", "266", ",", "267", 
           ",", "268", ",", "281"}], "}"}]}], ";", "\n", 
        RowBox[{"type8", "=", 
         RowBox[{"{", 
          RowBox[{"514", ",", "535", ",", "538"}], "}"}]}], ";", "\n", 
        RowBox[{"type9a", "=", 
         RowBox[{"{", 
          RowBox[{"102", ",", "104"}], "}"}]}], ";", "\n", 
        RowBox[{"type9b", "=", 
         RowBox[{"{", "}"}]}], ";", "\n", 
        RowBox[{"type10a", "=", 
         RowBox[{"{", 
          RowBox[{"108", ",", "109", ",", "110", ",", "111"}], "}"}]}], ";", 
        "\n", 
        RowBox[{"type10b", "=", 
         RowBox[{"{", 
          RowBox[{"126", ",", "127"}], "}"}]}], ";", "\n", 
        RowBox[{"type11", "=", 
         RowBox[{"{", "201", "}"}]}], ";", "\n", 
        RowBox[{"type12", "=", 
         RowBox[{"{", 
          RowBox[{"203", ",", "204"}], "}"}]}], ";"}], "\n", "*)"}], "\n", 
      "\n", 
      RowBox[{"output", " ", "=", "expItype"}]}]}], "\n", "]"}]}], 
  ";"}]], "Code",
 CellChangeTimes->{{3.72176107059964*^9, 3.7217611521967173`*^9}, {
  3.721761196885932*^9, 3.72176122333927*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"input", " ", "data", " ", 
      RowBox[{"(", 
       RowBox[{"(", 
        RowBox[{"output", " ", "of", " ", 
         RowBox[{"ReadExptTable", "[", 
          RowBox[{"[", 
           RowBox[{"iExperiment", ",", " ", "7"}], "]"}], "]"}]}], ")"}], 
       ")"}]}], "&"}], " ", "ExptID", "\n", "output", " ", "the", " ", 
    RowBox[{"(", 
     RowBox[{"x", ",", "Q"}], ")"}], " ", "list", " ", "of", " ", "it"}], 
   "\n", "*)"}], "\n", 
  RowBox[{
   RowBox[{
    RowBox[{"selectExptxQ", "[", 
     RowBox[{"ExptIDin_", ",", "datain_", ",", "Sin_"}], "]"}], ":=", "\n", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ExptID", "=", "ExptIDin"}], ",", 
        RowBox[{"data", "=", "datain"}], ",", 
        RowBox[{"S", "=", "Sin"}], ",", "sqrtS", ",", "expItype", ",", 
        "datatmp", ",", "output", ",", "i"}], "}"}], ",", "\n", 
      RowBox[{"(*", "\n", 
       RowBox[{
        RowBox[{"data", "=", 
         RowBox[{"data", "/.", 
          RowBox[{"List", "\[RuleDelayed]", "LF"}]}]}], ";", "\n", 
        RowBox[{"data", "=", 
         RowBox[{"data", "/.", 
          RowBox[{
           RowBox[{"LF", "[", "x__", "]"}], "\[RuleDelayed]", 
           RowBox[{
            RowBox[{"{", "x", "}"}], "[", 
            RowBox[{"[", "Xindex", "]"}], "]"}]}]}]}], ";", "\n", "data"}], 
       "\n", "*)"}], "\n", 
      RowBox[{"(*", "\n", 
       RowBox[{
        RowBox[{"output", "=", 
         RowBox[{"Table", "[", "\n", 
          RowBox[{
           RowBox[{"datatmp", "=", 
            RowBox[{
             RowBox[{"data", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "/.", 
             RowBox[{"List", "\[RuleDelayed]", "LF"}]}]}], ",", "\n", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", 
             RowBox[{"Length", "[", "data", "]"}]}], "}"}]}], "\n", "]"}]}], 
        ";"}], "\n", "*)"}], "\n", "\n", 
      RowBox[{
       RowBox[{"expItype", "=", 
        RowBox[{"ExptIDinfo", "[", "ExptID", "]"}]}], ";", "\n", 
       RowBox[{"sqrtS", "=", 
        RowBox[{"ExptIDEcm", "[", "ExptID", "]"}]}], ";", "\n", 
       RowBox[{"S", "=", 
        RowBox[{"sqrtS", "^", "2"}]}], ";", "\n", "\n", 
       RowBox[{"output", "=", "\n", 
        RowBox[{"Switch", "[", 
         RowBox[{"expItype", ",", "\n", "\"\<DIS\>\"", ",", "\n", 
          RowBox[{"data", "/.", 
           RowBox[{
            RowBox[{"LF", "[", "a__", "]"}], ":>", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"{", "a", "}"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}], ",", 
              RowBox[{
               RowBox[{"{", "a", "}"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}]}], "}"}]}]}], ",", "\n", 
          "\"\<VBP1\>\"", ",", "\n", 
          RowBox[{"data", "/.", 
           RowBox[{
            RowBox[{"LF", "[", "a__", "]"}], ":>", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"{", "a", "}"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}], "/", 
               RowBox[{"Sqrt", "[", "S", "]"}]}], ",", 
              RowBox[{
               RowBox[{"{", "a", "}"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}]}], ",", "\n", 
          "\"\<VBP2\>\"", ",", "\n", 
          RowBox[{"Join", "[", 
           RowBox[{
            RowBox[{"data", "/.", 
             RowBox[{
              RowBox[{"LF", "[", "a__", "]"}], ":>", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "/", 
                   RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", "\n", "\n", 
                 "\n", "\n", "\n", "\n", "\n", "\n", "\n", "\n", "\n", "\n", 
                 "\n", 
                 SuperscriptBox["\[ExponentialE]", 
                  RowBox[{
                   RowBox[{"{", "a", "}"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}]]}], ",", 
                RowBox[{
                 RowBox[{"{", "a", "}"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}]}], ",", 
            RowBox[{"data", "/.", 
             RowBox[{
              RowBox[{"LF", "[", "a__", "]"}], ":>", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "/", 
                   RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                 RowBox[{"E", "^", 
                  RowBox[{"-", 
                   RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}]}]}], ",", 
                RowBox[{
                 RowBox[{"{", "a", "}"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}]}]}], "]"}], ",", 
          RowBox[{"(*", " ", 
           RowBox[{"x1", " ", "=", " ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"Q", "/", "sqrt"}], 
               RowBox[{"(", "S", ")"}]}], ")"}], "*", "exp", 
             RowBox[{"(", 
              RowBox[{"+", 
               RowBox[{"-", "y"}]}], ")"}]}]}], " ", "*)"}], "\n", 
          "\"\<VBP3\>\"", ",", "\n", 
          RowBox[{"Join", "[", 
           RowBox[{
            RowBox[{"data", "/.", 
             RowBox[{
              RowBox[{"LF", "[", "a__", "]"}], ":>", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "/", 
                   RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", "\n", "\n", 
                 "\n", "\n", "\n", "\n", "\n", "\n", "\n", "\n", "\n", "\n", 
                 "\n", 
                 SuperscriptBox["\[ExponentialE]", 
                  RowBox[{
                   RowBox[{"{", "a", "}"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}]]}], ",", 
                RowBox[{
                 RowBox[{"{", "a", "}"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}]}], ",", 
            RowBox[{"data", "/.", 
             RowBox[{
              RowBox[{"LF", "[", "a__", "]"}], ":>", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "/", 
                   RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                 RowBox[{"E", "^", 
                  RowBox[{"-", 
                   RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}]}]}], ",", 
                RowBox[{
                 RowBox[{"{", "a", "}"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}]}]}], "]"}], ",", 
          RowBox[{"(*", " ", 
           RowBox[{"formula", " ", "not", " ", "decided", " ", "yet"}], " ", 
           "*)"}], "\n", "\"\<JP\>\"", ",", "\n", 
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{
             RowBox[{
             "this", " ", "form", " ", "is", " ", "for", " ", "q1q2"}], " ", 
             "\[Rule]", " ", "j1j2"}], ",", " ", 
            RowBox[{"estimate", " ", "x1"}], ",", " ", 
            RowBox[{
            "x2", " ", "of", " ", "jet", " ", "as", " ", "peak", " ", "of", 
             " ", "y", 
             RowBox[{"(", "j1", ")"}]}], ",", " ", 
            RowBox[{"y", 
             RowBox[{"(", "j2", ")"}]}]}], "*)"}], "\n", "\n", 
          RowBox[{"Join", "[", 
           RowBox[{
            RowBox[{"data", "/.", 
             RowBox[{
              RowBox[{"LF", "[", "a__", "]"}], ":>", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"2", "*", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{"Sqrt", "[", "S", "]"}], ")"}]}], ")"}], "*", 
                 RowBox[{"E", "^", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "-", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], ")"}], "/", "2.0"}], 
                   ")"}]}]}], ",", 
                RowBox[{
                 RowBox[{"{", "a", "}"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}]}], "}"}]}]}], ",", 
            RowBox[{"data", "/.", 
             RowBox[{
              RowBox[{"LF", "[", "a__", "]"}], ":>", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"2", "*", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{"Sqrt", "[", "S", "]"}], ")"}]}], ")"}], "*", 
                 RowBox[{"E", "^", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "-", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}], ")"}], "/", "2.0"}], 
                   ")"}]}]}], ",", 
                RowBox[{
                 RowBox[{"{", "a", "}"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}]}], "}"}]}]}]}], "]"}], ",", 
          RowBox[{"(*", 
           RowBox[{"x1", "=", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"Subscript", "[", 
                RowBox[{"p", ",", " ", "Tj"}], "]"}], "/", 
               RowBox[{"(", 
                RowBox[{"2", 
                 RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}]}], ")"}], "*", 
             RowBox[{"e", "^", 
              RowBox[{"Subscript", "[", 
               RowBox[{"y", ",", " ", "j"}], "]"}]}]}]}], "*)"}], "\n", "\n", 
          
          RowBox[{"(*", 
           RowBox[{
            RowBox[{
             RowBox[{
             "this", " ", "form", " ", "is", " ", "for", " ", "q1q2"}], " ", 
             "\[Rule]", " ", "W"}], ",", " ", 
            RowBox[{"Z", " ", "or", " ", "something"}], ",", " ", 
            RowBox[{"so", " ", "rapidity", " ", "is", " ", "yjj"}], ",", " ", 
            
            RowBox[{
            "estimating", " ", "x", " ", "as", " ", "peak", " ", "of", " ", 
             "yjj"}]}], "*)"}], "\n", 
          RowBox[{"(*", "\n", 
           RowBox[{
            RowBox[{"data", "/.", 
             RowBox[{
              RowBox[{"LF", "[", "a__", "]"}], "\[RuleDelayed]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"2", "\[Times]", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{"Sqrt", "[", "S", "]"}], ")"}]}], ")"}], ",", 
                RowBox[{"2", "\[Times]", 
                 RowBox[{
                  RowBox[{"{", "a", "}"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}]}]}], "}"}]}]}], ","}], "\n", 
           "*)"}], "\n", "_", ",", "\n", 
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<Wrong expItype value, \>\"", ",", "expItype", ",", 
            "\"\<, \>\"", ",", "ExptID"}], "]"}]}], " ", 
         RowBox[{"(*", 
          RowBox[{"data", "/.", 
           RowBox[{
            RowBox[{"LF", "[", "a__", "]"}], "\[RuleDelayed]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"{", "a", "}"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], ",", 
              RowBox[{
               RowBox[{"{", "a", "}"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}]}], "*)"}], "\n", 
         "]"}]}], ";", "\n", "\n", 
       RowBox[{"(*", "\n", 
        RowBox[{
         RowBox[{"output", "=", 
          RowBox[{"Table", "[", "\n", 
           RowBox[{
            RowBox[{"datatmp", "=", 
             RowBox[{
              RowBox[{"output", "[", 
               RowBox[{"[", "i", "]"}], "]"}], "/.", 
              RowBox[{"List", "\[RuleDelayed]", "LF"}]}]}], ",", "\n", 
            RowBox[{"{", 
             RowBox[{"i", ",", "1", ",", 
              RowBox[{"Length", "[", "output", "]"}]}], "}"}]}], "\n", 
           "]"}]}], ";"}], "\n", "*)"}], "\n", "\n", "output"}]}], " ", "\n", 
     "]"}]}], ";"}]}]], "Code",
 InitializationCell->False],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"2017.01", ".15"}], ",", " ", 
    RowBox[{"like", " ", "selectExptxQ"}], ",", " ", 
    RowBox[{"but", " ", "keep", " ", "other", " ", "data"}]}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
     RowBox[{
     "temporary", " ", "use", " ", "the", " ", "old", " ", "bin", " ", 
      "center", " ", "formula", "\n", 
      RowBox[{"selectExptxQv2", "[", 
       RowBox[{"ExptIDin_", ",", "datain_", ",", "Sin_"}], "]"}]}], ":=", 
     "\n", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ExptID", "=", "ExptIDin"}], ",", 
         RowBox[{"data", "=", "datain"}], ",", 
         RowBox[{"S", "=", "Sin"}], ",", "sqrtS", ",", "expItype", ",", 
         "datatmp", ",", "output", ",", "i", ",", "\[IndentingNewLine]", 
         "GetAveByBinUp", ",", "GetAveByBinLow", ",", "mllrange", ",", 
         "yrange", ",", "\[IndentingNewLine]", "WeightBinAveBySpectrumPeak", 
         ",", "peakposin", ",", "weightcloserin"}], "}"}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{"20171210", ":", " ", 
         RowBox[{
         "use", " ", "peak", " ", "of", " ", "the", " ", "kinematical", " ", 
          "spectrum", " ", "to", " ", "estimate", " ", "the", " ", "dominate",
           " ", "kinematical", " ", "region", " ", "in", " ", "bins"}]}], 
        "*)"}], "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"input", " ", "the", " ", "binlow"}], ",", " ", "binup", ",",
          " ", 
         RowBox[{
         "and", " ", "peak", " ", "position", " ", "of", " ", "the", " ", 
          "spectrum", " ", "described", " ", "by", " ", "bins"}], ",", " ", 
         RowBox[{
         "this", " ", "function", " ", "weight", " ", "binup", " ", "and", 
          " ", "binlow", " ", "with", " ", "different", " ", "weight", " ", 
          "with", " ", "the", " ", "one", " ", "who", " ", "closer", " ", 
          "to", " ", "the", " ", "peak", " ", "get", " ", "the", " ", "more", 
          " ", "weight"}]}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
         "define", " ", "the", " ", "standard", " ", "weight", " ", "be", " ",
           "binlow"}], ",", " ", 
         RowBox[{"binup", " ", "=", " ", "1"}], ",", " ", 
         RowBox[{"1", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
            "which", " ", "will", " ", "get", " ", "bin", " ", "average"}], 
            " ", "=", " ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"binup", " ", "+", " ", "binlow"}], ")"}], "/", "2"}]}],
            ")"}]}]}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
         "the", " ", "weight", " ", "in", " ", "this", " ", "function", " ", 
          "will", " ", "be", " ", "bin", " ", "average"}], " ", "=", " ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"weightcloser", "*", "bincloser"}], " ", "+", " ", 
            RowBox[{"1", "*", "binfar"}]}], ")"}], "/", 
          RowBox[{"(", 
           RowBox[{"weightcloser", "+", "1"}], ")"}]}]}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"(*", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"e", ".", "g", ".", " ", "rapidity"}], " ", "peak", " ", 
          "is", " ", "usually", " ", "0"}], ",", " ", 
         RowBox[{"binlow", " ", "=", " ", "1.2"}], ",", " ", 
         RowBox[{"binup", " ", "=", " ", 
          RowBox[{
          "1.6", "\[IndentingNewLine]", "so", " ", "the", " ", "binlow", " ", 
           "is", " ", "closer", " ", "to", " ", "the", " ", "peak"}]}], ",", 
         " ", 
         RowBox[{
          RowBox[{"so", " ", "the", " ", "bin", " ", "average"}], " ", "=", 
          " ", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"weightcloser", "*", "binlow"}], " ", "+", " ", 
             RowBox[{"1", "*", "binup"}]}], ")"}], "/", 
           RowBox[{"(", 
            RowBox[{"weightcloser", "+", "1"}], ")"}]}]}]}], 
        "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"WeightBinAveBySpectrumPeak", "[", 
          RowBox[{
          "binlowin_", ",", "binupin_", ",", "peakposin_", ",", 
           "weightcloserin_"}], "]"}], ":=", "\[IndentingNewLine]", 
         RowBox[{"Module", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"binlow", "=", "binlowin"}], ",", 
             RowBox[{"binup", "=", "binupin"}], ",", 
             RowBox[{"peakpos", "=", "peakposin"}], ",", 
             RowBox[{"weightcloser", "=", "weightcloserin"}], ",", 
             "\[IndentingNewLine]", "BinClose", ",", "BinFar", ",", 
             "BinAve"}], "}"}], ",", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{
             "if", " ", "one", " ", "side", " ", "of", " ", "bins", " ", "is",
               " ", "closer", " ", "to", " ", "the", " ", "peak"}], ",", " ", 
             
             RowBox[{
             "define", " ", "it", " ", "as", " ", "close", " ", "bin"}]}], 
            "*)"}], "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"Abs", "[", 
                RowBox[{"peakpos", "-", "binup"}], "]"}], ">", 
               RowBox[{"Abs", "[", 
                RowBox[{"peakpos", "-", "binlow"}], "]"}]}], ",", 
              RowBox[{
               RowBox[{"BinClose", "=", "binlow"}], ";", 
               RowBox[{"BinFar", "=", "binup"}]}], ",", 
              RowBox[{
               RowBox[{"BinClose", "=", "binup"}], ";", 
               RowBox[{"BinFar", "=", "binlow"}]}]}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"BinAve", "=", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"weightcloser", "*", "BinClose"}], "+", 
                RowBox[{"1.0", "*", "BinFar"}]}], ")"}], "/", 
              RowBox[{"(", 
               RowBox[{"weightcloser", "+", "1.0"}], ")"}]}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{
              RowBox[{
              "if", " ", "peak", " ", "in", " ", "between", " ", "the", " ", 
               "range"}], ",", " ", 
              RowBox[{
              "the", " ", "dominant", " ", "value", " ", "should", " ", "be", 
               " ", "at", " ", "the", " ", "peak"}]}], "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"peakpos", ">=", "binlow"}], " ", "&&", " ", 
               RowBox[{"peakpos", "<=", "binup"}]}], ",", 
              RowBox[{"BinAve", "=", "peakpos"}]}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{"return", " ", "bin", " ", "average"}], "*)"}], 
            "\[IndentingNewLine]", "BinAve"}]}], "\[IndentingNewLine]", 
          "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"20171208", ":", " ", 
           RowBox[{"for", " ", "some", " ", "input", " ", "values", " ", 
            RowBox[{"from", " ", ".", "dta"}], " ", "files", " ", "are", " ", 
            "max"}]}], ",", " ", 
          RowBox[{
          "min", " ", "rather", " ", "than", " ", "the", " ", "average", " ", 
           "values"}], ",", " ", 
          RowBox[{
          "use", " ", "following", " ", "two", " ", "functions", " ", "to", 
           " ", "get", " ", "the", " ", "average", " ", "values"}]}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
          "we", " ", "need", " ", "to", " ", "know", " ", "1.", " ", "the", 
           " ", "input", " ", "value", " ", "is", " ", "binup", " ", "or", 
           " ", "binlow"}], ",", " ", 
          RowBox[{
          "2.", " ", "we", " ", "need", " ", "to", " ", "have", " ", "values",
            " ", "of", " ", "each", " ", "bin", " ", "ticks"}]}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
          "we", " ", "find", " ", "the", " ", "bin", " ", "tick", " ", 
           "index", " ", "for", " ", "the", " ", "input", " ", 
           RowBox[{"binup", "/", "binlow"}]}], ",", " ", 
          RowBox[{
          "then", " ", "we", " ", "output", " ", "the", " ", "bin", " ", 
           "center", " ", "as", " ", "the", " ", "average", " ", "value", " ",
            "we", " ", "need"}]}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"GetAveByBinUp", "[", 
          RowBox[{
          "binupin_", ",", "binsin_", ",", "peakposin_", ",", 
           "weightcloserin_"}], "]"}], ":=", "\[IndentingNewLine]", 
         RowBox[{"Module", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"binup", "=", "binupin"}], ",", 
             RowBox[{"bins", "=", "binsin"}], ",", "Posbinup", ",", 
             "BoolYmaxExist", ",", "binave"}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"BoolYmaxExist", "=", "False"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{
             "check", " ", "the", " ", "input", " ", "is", " ", "the", " ", 
              "uplimit", " ", "of", " ", "one", " ", "of", " ", "the", " ", 
              "bin"}], "*)"}], "\[IndentingNewLine]", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"binup", "==", 
                 RowBox[{"bins", "[", 
                  RowBox[{"[", "i", "]"}], "]"}]}], ",", 
                RowBox[{
                 RowBox[{"Posbinup", "=", "i"}], ";", 
                 RowBox[{"BoolYmaxExist", "=", "True"}]}]}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"i", ",", 
                RowBox[{"Length", "[", "bins", "]"}]}], "}"}]}], "]"}], ";", 
            " ", "\[IndentingNewLine]", 
            RowBox[{"If", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"BoolYmaxExist", "\[Equal]", "False"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
               "Print", "[", 
                "\"\<GetAveByBinUp: error, the input binup is not in the list \
of bin list, the average bin value could not be calculated \>\"", "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"Print", "[", 
                RowBox[{"\"\<binup value: \>\"", ",", "binup"}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"Print", "[", 
                RowBox[{"\"\<bin list: \>\"", ",", "bins"}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"Abort", "[", "]"}]}]}], " ", "\[IndentingNewLine]", 
             "]"}], ";", "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{
             "input", " ", "can", " ", "not", " ", "be", " ", "the", " ", 
              "smallest", " ", "bin", " ", "edge"}], "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{"If", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Posbinup", "\[Equal]", "1"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
               "Print", "[", 
                "\"\<GetAveByBinUp: error, the input binup could not be the \
first element of the input bin list \>\"", "]"}], ";", "\[IndentingNewLine]", 
               
               RowBox[{"Print", "[", 
                RowBox[{"\"\<binup value: \>\"", ",", "binup"}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"Print", "[", 
                RowBox[{"\"\<bin list: \>\"", ",", "bins"}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"Abort", "[", "]"}]}]}], " ", "\[IndentingNewLine]", 
             "]"}], ";", "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{"average", " ", "the", " ", "bin", " ", "center"}], 
             "*)"}], "\[IndentingNewLine]", 
            RowBox[{"binave", "=", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"bins", "[", 
                 RowBox[{"[", "Posbinup", "]"}], "]"}], "+", 
                RowBox[{"bins", "[", 
                 RowBox[{"[", 
                  RowBox[{"Posbinup", "-", "1"}], "]"}], "]"}]}], ")"}], "/", 
              "2.0"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{
             "weight", " ", "bin", " ", "center", " ", "by", " ", "the", " ", 
              "peak", " ", "of", " ", "the", " ", "kinematical", " ", 
              "spectrum"}], "*)"}], "\[IndentingNewLine]", 
            RowBox[{"binave", "=", 
             RowBox[{"WeightBinAveBySpectrumPeak", "[", 
              RowBox[{
               RowBox[{"bins", "[", 
                RowBox[{"[", 
                 RowBox[{"Posbinup", "-", "1"}], "]"}], "]"}], ",", 
               RowBox[{"bins", "[", 
                RowBox[{"[", "Posbinup", "]"}], "]"}], ",", "peakposin", ",", 
               "weightcloserin"}], "]"}]}], ";", "\[IndentingNewLine]", 
            "binave"}]}], "\[IndentingNewLine]", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"GetAveByBinLow", "[", 
          RowBox[{
          "binlowin_", ",", "binsin_", ",", "peakposin_", ",", 
           "weightcloserin_"}], "]"}], ":=", "\[IndentingNewLine]", 
         RowBox[{"Module", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"binlow", "=", "binlowin"}], ",", 
             RowBox[{"bins", "=", "binsin"}], ",", "Posbinlow", ",", 
             "BoolYmaxExist", ",", "binave"}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
            "check", " ", "the", " ", "input", " ", "is", " ", "the", " ", 
             "uplimit", " ", "of", " ", "one", " ", "of", " ", "the", " ", 
             "bin"}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"BoolYmaxExist", "=", "False"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"binlow", "==", 
                 RowBox[{"bins", "[", 
                  RowBox[{"[", "i", "]"}], "]"}]}], ",", 
                RowBox[{
                 RowBox[{"Posbinlow", "=", "i"}], ";", 
                 RowBox[{"BoolYmaxExist", "=", "True"}]}]}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"i", ",", 
                RowBox[{"Length", "[", "bins", "]"}]}], "}"}]}], "]"}], ";", 
            " ", "\[IndentingNewLine]", 
            RowBox[{"If", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"BoolYmaxExist", "\[Equal]", "False"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
               "Print", "[", 
                "\"\<GetAveByBinLow: error, the input binlow is not in the \
list of bin list, the average bin value could not be calculated \>\"", "]"}], 
               ";", "\[IndentingNewLine]", 
               RowBox[{"Print", "[", 
                RowBox[{"\"\<binlow value: \>\"", ",", "binlow"}], "]"}], ";",
                "\[IndentingNewLine]", 
               RowBox[{"Print", "[", 
                RowBox[{"\"\<bin list: \>\"", ",", "bins"}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"Abort", "[", "]"}]}]}], " ", "\[IndentingNewLine]", 
             "]"}], ";", "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{
             "input", " ", "can", " ", "not", " ", "be", " ", "the", " ", 
              "largest", " ", "bin", " ", "edge"}], "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{"If", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Posbinlow", "\[Equal]", 
               RowBox[{"Length", "[", "bins", "]"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
               "Print", "[", 
                "\"\<GetAveByBinLow: error, the input binlow could not be the \
last element of the input bin list \>\"", "]"}], ";", "\[IndentingNewLine]", 
               RowBox[{"Print", "[", 
                RowBox[{"\"\<binlow value: \>\"", ",", "binlow"}], "]"}], ";",
                "\[IndentingNewLine]", 
               RowBox[{"Print", "[", 
                RowBox[{"\"\<bin list: \>\"", ",", "bins"}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"Abort", "[", "]"}]}]}], " ", "\[IndentingNewLine]", 
             "]"}], ";", "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{"average", " ", "the", " ", "bin", " ", "center"}], 
             "*)"}], "\[IndentingNewLine]", 
            RowBox[{"binave", "=", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"bins", "[", 
                 RowBox[{"[", "Posbinlow", "]"}], "]"}], "+", 
                RowBox[{"bins", "[", 
                 RowBox[{"[", 
                  RowBox[{"Posbinlow", "+", "1"}], "]"}], "]"}]}], ")"}], "/",
               "2.0"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{
             "weight", " ", "bin", " ", "center", " ", "by", " ", "the", " ", 
              "peak", " ", "of", " ", "the", " ", "kinematical", " ", 
              "spectrum"}], "*)"}], "\[IndentingNewLine]", 
            RowBox[{"binave", "=", 
             RowBox[{"WeightBinAveBySpectrumPeak", "[", 
              RowBox[{
               RowBox[{"bins", "[", 
                RowBox[{"[", "Posbinlow", "]"}], "]"}], ",", 
               RowBox[{"bins", "[", 
                RowBox[{"[", 
                 RowBox[{"Posbinlow", "+", "1"}], "]"}], "]"}], ",", 
               "peakposin", ",", "weightcloserin"}], "]"}]}], ";", 
            "\[IndentingNewLine]", "binave"}]}], "\[IndentingNewLine]", 
          "]"}]}], ";", "\n", 
        RowBox[{"(*", "\n", 
         RowBox[{
          RowBox[{"data", "=", 
           RowBox[{"data", "/.", 
            RowBox[{"List", "\[RuleDelayed]", "LF"}]}]}], ";", "\n", 
          RowBox[{"data", "=", 
           RowBox[{"data", "/.", 
            RowBox[{
             RowBox[{"LF", "[", "x__", "]"}], "\[RuleDelayed]", 
             RowBox[{
              RowBox[{"{", "x", "}"}], "[", 
              RowBox[{"[", "Xindex", "]"}], "]"}]}]}]}], ";", "\n", "data"}], 
         "\n", "*)"}], "\n", 
        RowBox[{"(*", "\n", 
         RowBox[{
          RowBox[{"output", "=", 
           RowBox[{"Table", "[", "\n", 
            RowBox[{
             RowBox[{"datatmp", "=", 
              RowBox[{
               RowBox[{"data", "[", 
                RowBox[{"[", "i", "]"}], "]"}], "/.", 
               RowBox[{"List", "\[RuleDelayed]", "LF"}]}]}], ",", "\n", 
             RowBox[{"{", 
              RowBox[{"i", ",", "1", ",", 
               RowBox[{"Length", "[", "data", "]"}]}], "}"}]}], "\n", "]"}]}],
           ";"}], "\n", "*)"}], "\n", "\n", 
        RowBox[{"expItype", "=", 
         RowBox[{"ExptIDinfo", "[", "ExptID", "]"}]}], ";", "\n", 
        RowBox[{"sqrtS", "=", 
         RowBox[{"ExptIDEcm", "[", "ExptID", "]"}]}], ";", "\n", 
        RowBox[{"S", "=", 
         RowBox[{"sqrtS", "^", "2"}]}], ";", "\n", "\n", 
        RowBox[{"(*", 
         RowBox[{"test", " ", "mathematica", " ", "symbols"}], "*)"}], "\n", 
        SqrtBox["S"], ";", 
        SuperscriptBox["\[ExponentialE]", "1.5"], ";", 
        RowBox[{"Log", "[", "39", "]"}], ";", 
        FractionBox["8", "1"], ";", 
        FractionBox["5", "3"], ";", 
        FractionBox["5", 
         SqrtBox["S"]], ";", "\n", "\n", "\n", 
        RowBox[{"output", "=", "\n", 
         RowBox[{"Switch", "[", 
          RowBox[{"expItype", ",", "\n", "\"\<DIS\>\"", ",", "\n", 
           RowBox[{"data", "/.", 
            RowBox[{
             RowBox[{"LF", "[", "a__", "]"}], ":>", 
             RowBox[{"LF", "@@", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Sequence", "@@", 
                 RowBox[{"{", "a", "}"}]}], ",", 
                RowBox[{
                 RowBox[{"{", "a", "}"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}], ",", 
                RowBox[{
                 RowBox[{"{", "a", "}"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}]}], "}"}]}]}]}], ",", "\n", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"20171130", ":", " ", 
              RowBox[{"VBP1", " ", "no", " ", "data", " ", "set"}]}], ",", 
             " ", 
             RowBox[{
             "formula", " ", "will", " ", "not", " ", "affect", " ", "the", 
              " ", "result"}]}], "*)"}], "\n", "\"\<VBP1\>\"", ",", "\n", 
           RowBox[{"data", "/.", 
            RowBox[{
             RowBox[{"LF", "[", "a__", "]"}], ":>", 
             RowBox[{"LF", "@@", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Sequence", "@@", 
                 RowBox[{"{", "a", "}"}]}], ",", 
                RowBox[{"(*", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "/", 
                   RowBox[{"Sqrt", "[", "S", "]"}]}], ","}], "*)"}], 
                RowBox[{
                 RowBox[{
                  RowBox[{"{", "a", "}"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "/", 
                 RowBox[{"Sqrt", "[", "S", "]"}]}], ",", 
                RowBox[{
                 RowBox[{"{", "a", "}"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}]}]}], ",", "\n", 
           "\"\<VBP2\>\"", ",", "\n", 
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"data", "/.", 
              RowBox[{
               RowBox[{"LF", "[", "a__", "]"}], ":>", 
               RowBox[{"LF", "@@", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Sequence", "@@", 
                   RowBox[{"{", "a", "}"}]}], ",", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", "\n", "\n",
                    "\n", "\n", 
                   SuperscriptBox["\[ExponentialE]", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]]}], ",", 
                  RowBox[{
                   RowBox[{"{", "a", "}"}], "[", 
                   RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}]}]}], ",", 
             RowBox[{"data", "/.", 
              RowBox[{
               RowBox[{"LF", "[", "a__", "]"}], ":>", 
               RowBox[{"LF", "@@", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Sequence", "@@", 
                   RowBox[{"{", "a", "}"}]}], ",", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", "\n", "\n", 
                   RowBox[{"E", "^", 
                    RowBox[{"-", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}]}]}], ",", 
                  RowBox[{
                   RowBox[{"{", "a", "}"}], "[", 
                   RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}]}]}]}], "]"}], 
           ",", 
           RowBox[{"(*", " ", 
            RowBox[{"x1", " ", "=", " ", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"Q", "/", "sqrt"}], 
                RowBox[{"(", "S", ")"}]}], ")"}], "*", "exp", 
              RowBox[{"(", 
               RowBox[{"+", 
                RowBox[{"-", "y"}]}], ")"}]}]}], " ", "*)"}], "\n", 
           "\"\<VBP3\>\"", ",", "\n", 
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"data", "/.", 
              RowBox[{
               RowBox[{"LF", "[", "a__", "]"}], ":>", 
               RowBox[{"LF", "@@", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Sequence", "@@", 
                   RowBox[{"{", "a", "}"}]}], ",", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", "\n", "\n",
                    "\n", "\n", 
                   SuperscriptBox["\[ExponentialE]", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]]}], ",", 
                  RowBox[{
                   RowBox[{"{", "a", "}"}], "[", 
                   RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}]}]}], ",", 
             RowBox[{"data", "/.", 
              RowBox[{
               RowBox[{"LF", "[", "a__", "]"}], ":>", 
               RowBox[{"LF", "@@", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Sequence", "@@", 
                   RowBox[{"{", "a", "}"}]}], ",", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                   RowBox[{"E", "^", 
                    RowBox[{"-", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}]}]}], ",", 
                  RowBox[{
                   RowBox[{"{", "a", "}"}], "[", 
                   RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}]}]}]}], "]"}], 
           ",", 
           RowBox[{"(*", " ", 
            RowBox[{"formula", " ", "not", " ", "decided", " ", "yet"}], " ", 
            "*)"}], "\n", "\"\<ID267\>\"", ",", "\n", 
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"data", "/.", 
              RowBox[{
               RowBox[{"LF", "[", "a__", "]"}], ":>", 
               RowBox[{"LF", "@@", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Sequence", "@@", 
                   RowBox[{"{", "a", "}"}]}], ",", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"80.39", "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", "\n", "\n",
                    "\n", "\n", 
                   SuperscriptBox["\[ExponentialE]", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]]}], ",", "80.39"}], 
                 "}"}]}]}]}], ",", 
             RowBox[{"data", "/.", 
              RowBox[{
               RowBox[{"LF", "[", "a__", "]"}], ":>", 
               RowBox[{"LF", "@@", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Sequence", "@@", 
                   RowBox[{"{", "a", "}"}]}], ",", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"80.39", "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                   RowBox[{"E", "^", 
                    RowBox[{"-", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}]}]}], ",", "80.39"}], 
                 "}"}]}]}]}]}], "]"}], ",", 
           RowBox[{"(*", " ", 
            RowBox[{"formula", " ", "not", " ", "decided", " ", "yet"}], " ", 
            "*)"}], "\n", "\"\<ID247\>\"", ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"peakposin", "=", "91.19"}], ";", 
            RowBox[{"weightcloserin", "=", "2.0"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"WeightBinAveBySpectrumPeak", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"{", "a", "}"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}], ",", 
              RowBox[{
               RowBox[{"{", "a", "}"}], "[", 
               RowBox[{"[", "3", "]"}], "]"}], ",", "peakposin", ",", 
              "weightcloserin"}], "]"}], ";", "\n", 
            RowBox[{"data", "/.", 
             RowBox[{
              RowBox[{"LF", "[", "a__", "]"}], ":>", 
              RowBox[{"LF", "@@", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Sequence", "@@", 
                  RowBox[{"{", "a", "}"}]}], ",", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"Sqrt", "[", 
                    RowBox[{
                    RowBox[{"91.19", "^", "2"}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"WeightBinAveBySpectrumPeak", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "peakposin", ",", 
                    "weightcloserin"}], "]"}], ")"}], "^", "2"}]}], "]"}], 
                   "/", 
                   RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], ",", 
                 RowBox[{"Sqrt", "[", 
                  RowBox[{
                   RowBox[{"91.19", "^", "2"}], "+", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"WeightBinAveBySpectrumPeak", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "peakposin", ",", 
                    "weightcloserin"}], "]"}], ")"}], "^", "2"}]}], "]"}]}], 
                "}"}]}]}]}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{"20171208", " ", "new", " ", "data", " ", "from", " ", 
             RowBox[{"TJ", "'"}], "s", " ", "HERA2", " ", "ev02"}], " ", 
            "*)"}], "\[IndentingNewLine]", "\"\<ID252\>\"", ",", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"d\[Sigma]", "/", 
              SubscriptBox["dm", "ll"]}], "dy"}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{
              RowBox[{"pT", 
               RowBox[{"(", "l1", ")"}]}], ">", 
              RowBox[{"40", " ", "GeV"}]}], ",", " ", 
             RowBox[{
              RowBox[{"pT", 
               RowBox[{"(", "l2", ")"}]}], ">", 
              RowBox[{"30", " ", "GeV"}]}], ",", " ", 
             RowBox[{
              RowBox[{"so", " ", "mll"}], " ", ">", " ", 
              RowBox[{
              "70", " ", "GeV", " ", "for", " ", "the", " ", "formula"}]}]}], 
            "*)"}], "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{
              RowBox[{"in", " ", ".", "dta"}], " ", 
              RowBox[{"files", ":", " ", 
               RowBox[{"col1", " ", "\[Equal]", " ", "<", "y", ">"}]}]}], ",",
              " ", 
             RowBox[{"col2", " ", "\[Equal]", " ", 
              SubscriptBox["mll", "min"]}], ",", " ", 
             RowBox[{"col3", " ", "\[Equal]", " ", "unset"}]}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"mllrange", "=", 
             RowBox[{"{", 
              RowBox[{
              "116.0", ",", "150.0", ",", "200.0", ",", "300.0", ",", "500.0",
                ",", "1500.0"}], "}"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"peakposin", "=", "91.19"}], ";", 
            RowBox[{"weightcloserin", "=", "2.0"}], ";", "\n", 
            RowBox[{"Select", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Join", "[", 
               RowBox[{
                RowBox[{"data", "/.", 
                 RowBox[{
                  RowBox[{"LF", "[", "a__", "]"}], "\[RuleDelayed]", 
                  RowBox[{"LF", "@@", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Sequence", "@@", 
                    RowBox[{"{", "a", "}"}]}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"GetAveByBinLow", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "mllrange", ",", 
                    "peakposin", ",", "weightcloserin"}], "]"}], "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ")"}]}]}], ",", 
                    RowBox[{"GetAveByBinLow", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "mllrange", ",", 
                    "peakposin", ",", "weightcloserin"}], "]"}]}], 
                    "}"}]}]}]}], ",", "\[IndentingNewLine]", 
                RowBox[{"data", "/.", 
                 RowBox[{
                  RowBox[{"LF", "[", "a__", "]"}], "\[RuleDelayed]", 
                  RowBox[{"LF", "@@", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Sequence", "@@", 
                    RowBox[{"{", "a", "}"}]}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"GetAveByBinLow", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "mllrange", ",", 
                    "peakposin", ",", "weightcloserin"}], "]"}], "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                    RowBox[{"E", "^", 
                    RowBox[{"-", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ")"}]}]}]}], ",", 
                    RowBox[{"GetAveByBinLow", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "mllrange", ",", 
                    "peakposin", ",", "weightcloserin"}], "]"}]}], 
                    "}"}]}]}]}]}], "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"(", " ", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"GetAveByBinLow", "[", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "mllrange", ",", 
                    "peakposin", ",", "weightcloserin"}], "]"}], ">", 
                   "70.0"}], ")"}], " ", "&&", " ", "\[IndentingNewLine]", 
                 RowBox[{"(", " ", 
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"GetAveByBinLow", "[", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "mllrange", ",", 
                    "peakposin", ",", "weightcloserin"}], "]"}], "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ")"}]}]}], "<", "1.0"}], 
                   " ", "&&", " ", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"GetAveByBinLow", "[", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "mllrange", ",", 
                    "peakposin", ",", "weightcloserin"}], "]"}], "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ")"}]}]}], ">", " ", 
                    SuperscriptBox["10.0", 
                    RowBox[{"-", "10"}]]}], " ", "&&", " ", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"GetAveByBinLow", "[", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "mllrange", ",", 
                    "peakposin", ",", "weightcloserin"}], "]"}], "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                    RowBox[{"E", "^", 
                    RowBox[{"-", 
                    RowBox[{"(", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ")"}]}]}]}], "<", "1.0"}],
                    " ", "&&", " ", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"GetAveByBinLow", "[", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "mllrange", ",", 
                    "peakposin", ",", "weightcloserin"}], "]"}], "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                    RowBox[{"E", "^", 
                    RowBox[{"-", 
                    RowBox[{"(", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ")"}]}]}]}], ">", 
                    SuperscriptBox["10.0", 
                    RowBox[{"-", "10"}]]}]}], ")"}]}], " ", 
                "\[IndentingNewLine]", ")"}], "&"}]}], "\[IndentingNewLine]", 
             "]"}]}], ",", "\[IndentingNewLine]", "\"\<ID253\>\"", ",", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{"mll", " ", "ZpT", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"d\[Sigma]", "/", 
                SubscriptBox["dp", "T"]}], " ", "in", " ", "ranges", " ", 
               "of", " ", 
               SubscriptBox["m", "ll"]}], ")"}]}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{
              RowBox[{"in", " ", ".", "dta"}], " ", 
              RowBox[{"files", ":", " ", 
               RowBox[{
                RowBox[{"column", " ", "1"}], " ", "\[Equal]", " ", 
                SubscriptBox["mll", "max"]}]}]}], ",", " ", 
             RowBox[{"col2", " ", "\[Equal]", " ", "ptmin"}], ",", " ", 
             RowBox[{"col3", " ", "\[Equal]", " ", "ptmax"}]}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"mllrange", "=", 
             RowBox[{"{", 
              RowBox[{
              "12.0", ",", "20.0", ",", "30.0", ",", "46.0", ",", "66.0", ",",
                "116.0", ",", "150.0"}], "}"}]}], ";", "\[IndentingNewLine]", 
            
            RowBox[{"peakposin", "=", "91.19"}], ";", 
            RowBox[{"weightcloserin", "=", "2.0"}], ";", "\n", 
            RowBox[{"data", "/.", 
             RowBox[{
              RowBox[{"LF", "[", "a__", "]"}], ":>", 
              RowBox[{"LF", "@@", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Sequence", "@@", 
                  RowBox[{"{", "a", "}"}]}], ",", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"Sqrt", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"GetAveByBinUp", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", "mllrange", ",", 
                    "peakposin", ",", "weightcloserin"}], "]"}], "^", "2"}], 
                    "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "+", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}], ")"}], "/", "2.0"}], 
                    ")"}], "^", "2"}]}], "]"}], "/", 
                   RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], ",", 
                 RowBox[{"Sqrt", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"GetAveByBinUp", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", "mllrange", ",", 
                    "peakposin", ",", "weightcloserin"}], "]"}], "^", "2"}], 
                   "+", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "+", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}], ")"}], "/", "2.0"}], 
                    ")"}], "^", "2"}]}], "]"}]}], "}"}]}]}]}]}], ",", 
           "\[IndentingNewLine]", "\"\<ID254\>\"", ",", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"d\[Sigma]", "/", 
              SubscriptBox["dp", "T"]}], "dy"}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{
              RowBox[{"in", " ", ".", "dta"}], " ", 
              RowBox[{"files", ":", " ", 
               RowBox[{"col1", " ", "\[Equal]", " ", 
                SubscriptBox["y", "max"]}]}]}], ",", " ", 
             RowBox[{"col2", " ", "\[Equal]", " ", 
              SubscriptBox["pT", "min"]}], ",", " ", 
             RowBox[{"col3", " ", "\[Equal]", " ", 
              SubscriptBox["pT", "max"]}]}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"yrange", "=", 
             RowBox[{"{", 
              RowBox[{
              "0.0", ",", "0.4", ",", "0.8", ",", "1.2", ",", "1.6", ",", 
               "2.0"}], "}"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"peakposin", "=", "0.0"}], ";", 
            RowBox[{"weightcloserin", "=", "2.0"}], ";", "\n", 
            RowBox[{"Join", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"data", "/.", 
               RowBox[{
                RowBox[{"LF", "[", "a__", "]"}], "\[RuleDelayed]", 
                RowBox[{"LF", "@@", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"Sequence", "@@", 
                    RowBox[{"{", "a", "}"}]}], ",", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Sqrt", "[", 
                    RowBox[{
                    RowBox[{"91.19", "^", "2"}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "+", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}], ")"}], "/", "2.0"}], 
                    ")"}], "^", "2"}]}], "]"}], "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"GetAveByBinUp", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", "yrange", ",", 
                    "peakposin", ",", "weightcloserin"}], "]"}], ")"}]}]}], 
                   ",", 
                   RowBox[{"Sqrt", "[", 
                    RowBox[{
                    RowBox[{"91.19", "^", "2"}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "+", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}], ")"}], "/", "2.0"}], 
                    ")"}], "^", "2"}]}], "]"}]}], "}"}]}]}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"data", "/.", 
               RowBox[{
                RowBox[{"LF", "[", "a__", "]"}], "\[RuleDelayed]", 
                RowBox[{"LF", "@@", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"Sequence", "@@", 
                    RowBox[{"{", "a", "}"}]}], ",", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Sqrt", "[", 
                    RowBox[{
                    RowBox[{"91.19", "^", "2"}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "+", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}], ")"}], "/", "2.0"}], 
                    ")"}], "^", "2"}]}], "]"}], "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                    RowBox[{"E", "^", 
                    RowBox[{"-", 
                    RowBox[{"(", 
                    RowBox[{"GetAveByBinUp", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", "yrange", ",", 
                    "peakposin", ",", "weightcloserin"}], "]"}], ")"}]}]}]}], 
                   ",", 
                   RowBox[{"Sqrt", "[", 
                    RowBox[{
                    RowBox[{"91.19", "^", "2"}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "+", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}], ")"}], "/", "2.0"}], 
                    ")"}], "^", "2"}]}], "]"}]}], "}"}]}]}]}]}], 
             "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
           "\"\<ID255\>\"", ",", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"d\[Sigma]", "/", "pT"}], 
             RowBox[{"(", 
              RowBox[{"W", "/", "Z"}], ")"}]}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{
              RowBox[{"in", " ", ".", "dta"}], " ", 
              RowBox[{"files", ":", " ", 
               RowBox[{
                RowBox[{"column", " ", "1"}], " ", "\[Equal]", " ", "ycut", 
                " ", "<", " ", "2.5"}]}]}], ",", " ", 
             RowBox[{"col2", " ", "\[Equal]", " ", "ptmin"}], ",", " ", 
             RowBox[{"col3", " ", "\[Equal]", " ", "ptmax"}]}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"in", " ", "HERA2", " ", "ev02"}], ",", " ", 
             RowBox[{
             "the", " ", "first", " ", "4", " ", "points", " ", "are", " ", 
              "W", " ", "process", " ", "events"}], ",", " ", 
             RowBox[{
             "the", " ", "last", " ", "5", " ", "points", " ", "are", " ", 
              "Z", " ", "process", " ", "events"}]}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"peakposin", "=", "30.0"}], ";", 
            RowBox[{"(*", 
             RowBox[{"ptmu", " ", ">", " ", 
              RowBox[{"15", " ", "GeV"}]}], "*)"}], 
            RowBox[{"weightcloserin", "=", "2.0"}], ";", "\n", 
            RowBox[{"Join", "[", "\[IndentingNewLine]", 
             RowBox[{"(*", "W", "*)"}], "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"Take", "[", 
                RowBox[{"data", ",", "4"}], "]"}], "/.", 
               RowBox[{
                RowBox[{"LF", "[", "a__", "]"}], "\[RuleDelayed]", 
                RowBox[{"LF", "@@", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"Sequence", "@@", 
                    RowBox[{"{", "a", "}"}]}], ",", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Sqrt", "[", 
                    RowBox[{
                    RowBox[{"80.39", "^", "2"}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"WeightBinAveBySpectrumPeak", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "peakposin", ",", 
                    "weightcloserin"}], "]"}], ")"}], "^", "2"}]}], "]"}], 
                    "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], ",", 
                   RowBox[{"Sqrt", "[", 
                    RowBox[{
                    RowBox[{"80.39", "^", "2"}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"WeightBinAveBySpectrumPeak", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "peakposin", ",", 
                    "weightcloserin"}], "]"}], ")"}], "^", "2"}]}], "]"}]}], 
                  "}"}]}]}]}], ",", "\[IndentingNewLine]", 
              RowBox[{"(*", "Z", "*)"}], "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"Take", "[", 
                RowBox[{"data", ",", 
                 RowBox[{"-", "5"}]}], "]"}], "/.", 
               RowBox[{
                RowBox[{"LF", "[", "a__", "]"}], "\[RuleDelayed]", 
                RowBox[{"LF", "@@", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"Sequence", "@@", 
                    RowBox[{"{", "a", "}"}]}], ",", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Sqrt", "[", 
                    RowBox[{
                    RowBox[{"91.19", "^", "2"}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"WeightBinAveBySpectrumPeak", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "peakposin", ",", 
                    "weightcloserin"}], "]"}], ")"}], "^", "2"}]}], "]"}], 
                    "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], ",", 
                   RowBox[{"Sqrt", "[", 
                    RowBox[{
                    RowBox[{"91.19", "^", "2"}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"WeightBinAveBySpectrumPeak", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "peakposin", ",", 
                    "weightcloserin"}], "]"}], ")"}], "^", "2"}]}], "]"}]}], 
                  "}"}]}]}]}]}], "\[IndentingNewLine]", "]"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{"formula", " ", "not", " ", "decided", " ", "yet"}], " ", 
            "*)"}], "\n", "\"\<JP\>\"", ",", "\n", 
           RowBox[{"(*", " ", 
            RowBox[{
             RowBox[{
              RowBox[{
              "this", " ", "form", " ", "is", " ", "for", " ", "q1q2"}], " ", 
              "\[Rule]", " ", "j1j2"}], ",", " ", 
             RowBox[{"estimate", " ", "x1"}], ",", " ", 
             RowBox[{
             "x2", " ", "of", " ", "jet", " ", "as", " ", "peak", " ", "of", 
              " ", "y", 
              RowBox[{"(", "j1", ")"}]}], ",", " ", 
             RowBox[{"y", 
              RowBox[{"(", "j2", ")"}]}]}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"peakposin", "=", "0.0"}], ";", 
            RowBox[{"weightcloserin", "=", "2.0"}], ";", 
            RowBox[{"(*", 
             RowBox[{"test", " ", "strong", " ", "weight"}], "*)"}], "\n", 
            RowBox[{"Select", "[", "\n", 
             RowBox[{
              RowBox[{"Join", "[", 
               RowBox[{
                RowBox[{"data", "/.", 
                 RowBox[{
                  RowBox[{"LF", "[", "a__", "]"}], ":>", 
                  RowBox[{"LF", "@@", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Sequence", "@@", 
                    RowBox[{"{", "a", "}"}]}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"2", "*", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ")"}], "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"WeightBinAveBySpectrumPeak", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "peakposin", ",", 
                    "weightcloserin"}], "]"}], ")"}]}]}], ",", 
                    RowBox[{"2", "*", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}]}], "}"}]}]}]}], ",", 
                RowBox[{"data", "/.", 
                 RowBox[{
                  RowBox[{"LF", "[", "a__", "]"}], ":>", 
                  RowBox[{"LF", "@@", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Sequence", "@@", 
                    RowBox[{"{", "a", "}"}]}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"2", "*", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ")"}], "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                    RowBox[{"E", "^", 
                    RowBox[{"-", 
                    RowBox[{"(", 
                    RowBox[{"WeightBinAveBySpectrumPeak", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "peakposin", ",", 
                    "weightcloserin"}], "]"}], ")"}]}]}]}], ",", 
                    RowBox[{"2", "*", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}]}], "}"}]}]}]}]}], "]"}], 
              ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"(", " ", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"2", "*", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ")"}], "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                   RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"WeightBinAveBySpectrumPeak", "[", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "peakposin", ",", 
                    "weightcloserin"}], "]"}], ")"}]}]}], "<", "1.0"}], " ", "&&",
                  " ", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"2", "*", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ")"}], "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                   RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"WeightBinAveBySpectrumPeak", "[", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "peakposin", ",", 
                    "weightcloserin"}], "]"}], ")"}]}]}], ">", 
                  SuperscriptBox["10.0", 
                   RowBox[{"-", "10"}]]}], " ", "&&", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"2", "*", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ")"}], "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                   RowBox[{"E", "^", 
                    RowBox[{"-", 
                    RowBox[{"(", 
                    RowBox[{"WeightBinAveBySpectrumPeak", "[", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "peakposin", ",", 
                    "weightcloserin"}], "]"}], ")"}]}]}]}], "<", "1.0"}], " ",
                  "&&", " ", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"2", "*", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ")"}], "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                   RowBox[{"E", "^", 
                    RowBox[{"-", 
                    RowBox[{"(", 
                    RowBox[{"WeightBinAveBySpectrumPeak", "[", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "peakposin", ",", 
                    "weightcloserin"}], "]"}], ")"}]}]}]}], ">", 
                  SuperscriptBox["10.0", 
                   RowBox[{"-", "10"}]]}]}], " ", ")"}], "&"}]}], 
             "\[IndentingNewLine]", "]"}]}], ",", 
           RowBox[{"(*", 
            RowBox[{"x1", "=", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"Subscript", "[", 
                 RowBox[{"p", ",", " ", "Tj"}], "]"}], "/", 
                RowBox[{"(", 
                 RowBox[{"2", 
                  RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}]}], ")"}], "*", 
              RowBox[{"e", "^", 
               RowBox[{"Subscript", "[", 
                RowBox[{"y", ",", " ", "j"}], "]"}]}]}]}], "*)"}], "\n", "\n", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{
              RowBox[{
              "this", " ", "form", " ", "is", " ", "for", " ", "q1q2"}], " ", 
              "\[Rule]", " ", "W"}], ",", " ", 
             RowBox[{"Z", " ", "or", " ", "something"}], ",", " ", 
             RowBox[{"so", " ", "rapidity", " ", "is", " ", "yjj"}], ",", " ", 
             RowBox[{
             "estimating", " ", "x", " ", "as", " ", "peak", " ", "of", " ", 
              "yjj"}]}], "*)"}], "\n", 
           RowBox[{"(*", "\n", 
            RowBox[{
             RowBox[{"data", "/.", 
              RowBox[{
               RowBox[{"LF", "[", "a__", "]"}], "\[RuleDelayed]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"2", "\[Times]", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{"Sqrt", "[", "S", "]"}], ")"}]}], ")"}], ",", 
                 RowBox[{"2", "\[Times]", 
                  RowBox[{
                   RowBox[{"{", "a", "}"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}]}]}], "}"}]}]}], ","}], "\n",
             "*)"}], "\n", 
           RowBox[{"(*", 
            RowBox[{"20171118", ":", " ", 
             RowBox[{"add", " ", 
              RowBox[{"565", " ", "~", "568"}], " ", 
              RowBox[{"(", 
               RowBox[{"ttbar", " ", "production"}], ")"}], " ", 
              "formulas"}]}], "*)"}], "\n", 
           RowBox[{"(*", 
            RowBox[{"pT", ",", " ", 
             RowBox[{
             "the", " ", "same", " ", "as", " ", "the", " ", "formula", " ", 
              "of", " ", "JP"}]}], "*)"}], "\n", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"20171126", ":", " ", 
              RowBox[{"pt", " ", "events"}]}], ",", " ", 
             RowBox[{
              RowBox[{"<", "y", ">"}], " ", "=", " ", "0"}]}], "*)"}], "\n", 
           "\"\<ttbarpT\>\"", ",", "\[IndentingNewLine]", 
           RowBox[{"Select", "[", "\n", 
            RowBox[{
             RowBox[{"data", "/.", 
              RowBox[{
               RowBox[{"LF", "[", "a__", "]"}], ":>", 
               RowBox[{"LF", "@@", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Sequence", "@@", 
                   RowBox[{"{", "a", "}"}]}], ",", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"2", "*", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ")"}], "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], ",", 
                  RowBox[{"2", "*", 
                   RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}]}], "}"}]}]}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"(", " ", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"2", "*", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ")"}], "/", 
                   RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "<", "1.0"}], 
                " ", "&&", " ", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"2", "*", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ")"}], "/", 
                   RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], ">", 
                 SuperscriptBox["10.0", 
                  RowBox[{"-", "10"}]]}]}], " ", ")"}], "&"}]}], 
            "\[IndentingNewLine]", "]"}], ",", "\n", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"mu", " ", "=", " ", "mtt"}], ",", " ", 
             RowBox[{"x", " ", "=", " ", 
              RowBox[{"mtt", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"since", " ", "y"}], " ", "=", " ", 
                 RowBox[{"0", " ", "for", " ", "this", " ", "case"}]}], 
                ")"}]}]}]}], "*)"}], "\n", "\"\<ttbarmtt\>\"", ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Select", "[", "\n", 
            RowBox[{
             RowBox[{"data", "/.", 
              RowBox[{
               RowBox[{"LF", "[", "a__", "]"}], ":>", 
               RowBox[{"LF", "@@", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Sequence", "@@", 
                   RowBox[{"{", "a", "}"}]}], ",", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], ",", 
                  RowBox[{
                   RowBox[{"{", "a", "}"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}]}], "}"}]}]}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"(", " ", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "/", 
                   RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "<", "1.0"}], 
                " ", "&&", " ", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "/", 
                   RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], ">", 
                 SuperscriptBox["10.0", 
                  RowBox[{"-", "10"}]]}]}], " ", ")"}], "&"}]}], 
            "\[IndentingNewLine]", "]"}], ",", "\n", 
           RowBox[{"(*", 
            RowBox[{"ytt", ",", " ", 
             RowBox[{
              RowBox[{
               RowBox[{"ya", "==", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"yt", "+", "ytbar"}], ")"}], "/", "2"}]}], ":", " ", 
               RowBox[{
                RowBox[{
                 RowBox[{"mu", "~", " ", "2"}], "mt"}], "+", 
                RowBox[{"100", "GeV"}]}]}], " ", "=", " ", 
              RowBox[{"450", " ", "GeV"}]}], ",", " ", 
             RowBox[{"x", " ", "=", " ", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"Q", "/", 
                 RowBox[{"\[Sqrt]", "S"}]}], ")"}], "*", 
               RowBox[{"e", "^", 
                RowBox[{"+", 
                 RowBox[{"-", "y"}]}]}]}]}]}], "*)"}], "\n", "\"\<ttbary\>\"",
            ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"peakposin", "=", "0.0"}], ";", 
            RowBox[{"weightcloserin", "=", "2.0"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"Select", "[", "\n", 
             RowBox[{
              RowBox[{"Join", "[", 
               RowBox[{
                RowBox[{"data", "/.", 
                 RowBox[{
                  RowBox[{"LF", "[", "a__", "]"}], ":>", 
                  RowBox[{"LF", "@@", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Sequence", "@@", 
                    RowBox[{"{", "a", "}"}]}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"400.0", "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"WeightBinAveBySpectrumPeak", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "peakposin", ",", 
                    "weightcloserin"}], "]"}], ")"}]}]}], ",", "400.0"}], 
                    "}"}]}]}]}], ",", 
                RowBox[{"data", "/.", 
                 RowBox[{
                  RowBox[{"LF", "[", "a__", "]"}], ":>", 
                  RowBox[{"LF", "@@", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Sequence", "@@", 
                    RowBox[{"{", "a", "}"}]}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"400.0", "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                    RowBox[{"E", "^", 
                    RowBox[{"-", 
                    RowBox[{"(", 
                    RowBox[{"WeightBinAveBySpectrumPeak", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "peakposin", ",", 
                    "weightcloserin"}], "]"}], ")"}]}]}]}], ",", "400.0"}], 
                    "}"}]}]}]}]}], "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"(", " ", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"400.0", "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                   RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"WeightBinAveBySpectrumPeak", "[", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "peakposin", ",", 
                    "weightcloserin"}], "]"}], ")"}]}]}], "<", "1.0"}], " ", "&&",
                  " ", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"400.0", "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                   RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"WeightBinAveBySpectrumPeak", "[", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "peakposin", ",", 
                    "weightcloserin"}], "]"}], ")"}]}]}], ">", 
                  RowBox[{
                   SuperscriptBox["10.0", 
                    RowBox[{"-", "10"}]], "\[IndentingNewLine]", 
                   RowBox[{"(", 
                    RowBox[{"400.0", "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                   RowBox[{"E", "^", 
                    RowBox[{"-", 
                    RowBox[{"(", 
                    RowBox[{"WeightBinAveBySpectrumPeak", "[", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "peakposin", ",", 
                    "weightcloserin"}], "]"}], ")"}]}]}]}], "<", "1.0"}], " ",
                  "&&", " ", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"400.0", "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                   RowBox[{"E", "^", 
                    RowBox[{"-", 
                    RowBox[{"(", 
                    RowBox[{"WeightBinAveBySpectrumPeak", "[", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "peakposin", ",", 
                    "weightcloserin"}], "]"}], ")"}]}]}]}], ">", 
                  SuperscriptBox["10.0", 
                   RowBox[{"-", "10"}]]}]}], " ", ")"}], "&"}]}], 
             "\[IndentingNewLine]", "]"}]}], ",", "\n", "_", ",", "\n", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<Wrong expItype value, \>\"", ",", "expItype", ",", 
             "\"\<, \>\"", ",", "ExptID"}], "]"}]}], " ", 
          RowBox[{"(*", 
           RowBox[{"data", "/.", 
            RowBox[{
             RowBox[{"LF", "[", "a__", "]"}], "\[RuleDelayed]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"{", "a", "}"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"{", "a", "}"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}]}], "*)"}], "\n", 
          "]"}]}], ";", "\n", "\n", 
        RowBox[{"(*", "\n", 
         RowBox[{
          RowBox[{"output", "=", 
           RowBox[{"Table", "[", "\n", 
            RowBox[{
             RowBox[{"datatmp", "=", 
              RowBox[{
               RowBox[{"output", "[", 
                RowBox[{"[", "i", "]"}], "]"}], "/.", 
               RowBox[{"List", "\[RuleDelayed]", "LF"}]}]}], ",", "\n", 
             RowBox[{"{", 
              RowBox[{"i", ",", "1", ",", 
               RowBox[{"Length", "[", "output", "]"}]}], "}"}]}], "\n", 
            "]"}]}], ";"}], "\n", "*)"}], "\n", "\n", "output"}]}], " ", "\n",
       "]"}]}], ";"}], "\n", "*)"}], "\n", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"old", " ", "bin", " ", "center", " ", 
     RowBox[{"formula", ":", " ", 
      RowBox[{"bin", " ", "center"}]}]}], " ", "=", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"binup", " ", "+", " ", "binlow"}], ")"}], "/", "2"}]}], "*)"}],
   "\n", 
  RowBox[{
   RowBox[{
    RowBox[{"selectExptxQv2", "[", 
     RowBox[{"ExptIDin_", ",", "datain_", ",", "Sin_"}], "]"}], ":=", "\n", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ExptID", "=", "ExptIDin"}], ",", 
        RowBox[{"data", "=", "datain"}], ",", 
        RowBox[{"S", "=", "Sin"}], ",", "sqrtS", ",", "expItype", ",", 
        "datatmp", ",", "output", ",", "i", ",", "\[IndentingNewLine]", 
        "GetAveByBinUp", ",", "GetAveByBinLow", ",", "mllrange", ",", 
        "yrange", ",", "\[IndentingNewLine]", "WeightBinAveBySpectrumPeak", 
        ",", "peakposin", ",", "weightcloserin"}], "}"}], ",", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{"20171210", ":", " ", 
        RowBox[{
        "use", " ", "peak", " ", "of", " ", "the", " ", "kinematical", " ", 
         "spectrum", " ", "to", " ", "estimate", " ", "the", " ", "dominate", 
         " ", "kinematical", " ", "region", " ", "in", " ", "bins"}]}], 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"input", " ", "the", " ", "binlow"}], ",", " ", "binup", ",", 
        " ", 
        RowBox[{
        "and", " ", "peak", " ", "position", " ", "of", " ", "the", " ", 
         "spectrum", " ", "described", " ", "by", " ", "bins"}], ",", " ", 
        RowBox[{
        "this", " ", "function", " ", "weight", " ", "binup", " ", "and", " ",
          "binlow", " ", "with", " ", "different", " ", "weight", " ", "with",
          " ", "the", " ", "one", " ", "who", " ", "closer", " ", "to", " ", 
         "the", " ", "peak", " ", "get", " ", "the", " ", "more", " ", 
         "weight"}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
        "define", " ", "the", " ", "standard", " ", "weight", " ", "be", " ", 
         "binlow"}], ",", " ", 
        RowBox[{"binup", " ", "=", " ", "1"}], ",", " ", 
        RowBox[{"1", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
           "which", " ", "will", " ", "get", " ", "bin", " ", "average"}], 
           " ", "=", " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"binup", " ", "+", " ", "binlow"}], ")"}], "/", "2"}]}], 
          ")"}]}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
        "the", " ", "weight", " ", "in", " ", "this", " ", "function", " ", 
         "will", " ", "be", " ", "bin", " ", "average"}], " ", "=", " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"weightcloser", "*", "bincloser"}], " ", "+", " ", 
           RowBox[{"1", "*", "binfar"}]}], ")"}], "/", 
         RowBox[{"(", 
          RowBox[{"weightcloser", "+", "1"}], ")"}]}]}], "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"(*", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"e", ".", "g", ".", " ", "rapidity"}], " ", "peak", " ", 
         "is", " ", "usually", " ", "0"}], ",", " ", 
        RowBox[{"binlow", " ", "=", " ", "1.2"}], ",", " ", 
        RowBox[{"binup", " ", "=", " ", 
         RowBox[{
         "1.6", "\[IndentingNewLine]", "so", " ", "the", " ", "binlow", " ", 
          "is", " ", "closer", " ", "to", " ", "the", " ", "peak"}]}], ",", 
        " ", 
        RowBox[{
         RowBox[{"so", " ", "the", " ", "bin", " ", "average"}], " ", "=", 
         " ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"weightcloser", "*", "binlow"}], " ", "+", " ", 
            RowBox[{"1", "*", "binup"}]}], ")"}], "/", 
          RowBox[{"(", 
           RowBox[{"weightcloser", "+", "1"}], ")"}]}]}]}], 
       "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"WeightBinAveBySpectrumPeak", "[", 
         RowBox[{
         "binlowin_", ",", "binupin_", ",", "peakposin_", ",", 
          "weightcloserin_"}], "]"}], ":=", "\[IndentingNewLine]", 
        RowBox[{"Module", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"binlow", "=", "binlowin"}], ",", 
            RowBox[{"binup", "=", "binupin"}], ",", 
            RowBox[{"peakpos", "=", "peakposin"}], ",", 
            RowBox[{"weightcloser", "=", "weightcloserin"}], ",", 
            "\[IndentingNewLine]", "BinClose", ",", "BinFar", ",", "BinAve"}],
            "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{
            "if", " ", "one", " ", "side", " ", "of", " ", "bins", " ", "is", 
             " ", "closer", " ", "to", " ", "the", " ", "peak"}], ",", " ", 
            RowBox[{
            "define", " ", "it", " ", "as", " ", "close", " ", "bin"}]}], 
           "*)"}], "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Abs", "[", 
               RowBox[{"peakpos", "-", "binup"}], "]"}], ">", 
              RowBox[{"Abs", "[", 
               RowBox[{"peakpos", "-", "binlow"}], "]"}]}], ",", 
             RowBox[{
              RowBox[{"BinClose", "=", "binlow"}], ";", 
              RowBox[{"BinFar", "=", "binup"}]}], ",", 
             RowBox[{
              RowBox[{"BinClose", "=", "binup"}], ";", 
              RowBox[{"BinFar", "=", "binlow"}]}]}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"BinAve", "=", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"weightcloser", "*", "BinClose"}], "+", 
               RowBox[{"1.0", "*", "BinFar"}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"weightcloser", "+", "1.0"}], ")"}]}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{
             "if", " ", "peak", " ", "in", " ", "between", " ", "the", " ", 
              "range"}], ",", " ", 
             RowBox[{
             "the", " ", "dominant", " ", "value", " ", "should", " ", "be", 
              " ", "at", " ", "the", " ", "peak"}]}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"peakpos", ">=", "binlow"}], " ", "&&", " ", 
              RowBox[{"peakpos", "<=", "binup"}]}], ",", 
             RowBox[{"BinAve", "=", "peakpos"}]}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{"return", " ", "bin", " ", "average"}], "*)"}], 
           "\[IndentingNewLine]", "BinAve"}]}], "\[IndentingNewLine]", 
         "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"20171208", ":", " ", 
          RowBox[{"for", " ", "some", " ", "input", " ", "values", " ", 
           RowBox[{"from", " ", ".", "dta"}], " ", "files", " ", "are", " ", 
           "max"}]}], ",", " ", 
         RowBox[{
         "min", " ", "rather", " ", "than", " ", "the", " ", "average", " ", 
          "values"}], ",", " ", 
         RowBox[{
         "use", " ", "following", " ", "two", " ", "functions", " ", "to", 
          " ", "get", " ", "the", " ", "average", " ", "values"}]}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
         "we", " ", "need", " ", "to", " ", "know", " ", "1.", " ", "the", 
          " ", "input", " ", "value", " ", "is", " ", "binup", " ", "or", " ",
           "binlow"}], ",", " ", 
         RowBox[{
         "2.", " ", "we", " ", "need", " ", "to", " ", "have", " ", "values", 
          " ", "of", " ", "each", " ", "bin", " ", "ticks"}]}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
         "we", " ", "find", " ", "the", " ", "bin", " ", "tick", " ", "index",
           " ", "for", " ", "the", " ", "input", " ", 
          RowBox[{"binup", "/", "binlow"}]}], ",", " ", 
         RowBox[{
         "then", " ", "we", " ", "output", " ", "the", " ", "bin", " ", 
          "center", " ", "as", " ", "the", " ", "average", " ", "value", " ", 
          "we", " ", "need"}]}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"GetAveByBinUp", "[", 
         RowBox[{
         "binupin_", ",", "binsin_", ",", "peakposin_", ",", 
          "weightcloserin_"}], "]"}], ":=", "\[IndentingNewLine]", 
        RowBox[{"Module", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"binup", "=", "binupin"}], ",", 
            RowBox[{"bins", "=", "binsin"}], ",", "Posbinup", ",", 
            "BoolYmaxExist", ",", "binave"}], "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"BoolYmaxExist", "=", "False"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
            "check", " ", "the", " ", "input", " ", "is", " ", "the", " ", 
             "uplimit", " ", "of", " ", "one", " ", "of", " ", "the", " ", 
             "bin"}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"binup", "==", 
                RowBox[{"bins", "[", 
                 RowBox[{"[", "i", "]"}], "]"}]}], ",", 
               RowBox[{
                RowBox[{"Posbinup", "=", "i"}], ";", 
                RowBox[{"BoolYmaxExist", "=", "True"}]}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", 
               RowBox[{"Length", "[", "bins", "]"}]}], "}"}]}], "]"}], ";", 
           " ", "\[IndentingNewLine]", 
           RowBox[{"If", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"BoolYmaxExist", "\[Equal]", "False"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
              "Print", "[", 
               "\"\<GetAveByBinUp: error, the input binup is not in the list \
of bin list, the average bin value could not be calculated \>\"", "]"}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"Print", "[", 
               RowBox[{"\"\<binup value: \>\"", ",", "binup"}], "]"}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"Print", "[", 
               RowBox[{"\"\<bin list: \>\"", ",", "bins"}], "]"}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"Abort", "[", "]"}]}]}], " ", "\[IndentingNewLine]", 
            "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
            "input", " ", "can", " ", "not", " ", "be", " ", "the", " ", 
             "smallest", " ", "bin", " ", "edge"}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Posbinup", "\[Equal]", "1"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
              "Print", "[", 
               "\"\<GetAveByBinUp: error, the input binup could not be the \
first element of the input bin list \>\"", "]"}], ";", "\[IndentingNewLine]", 
              
              RowBox[{"Print", "[", 
               RowBox[{"\"\<binup value: \>\"", ",", "binup"}], "]"}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"Print", "[", 
               RowBox[{"\"\<bin list: \>\"", ",", "bins"}], "]"}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"Abort", "[", "]"}]}]}], " ", "\[IndentingNewLine]", 
            "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{"average", " ", "the", " ", "bin", " ", "center"}], 
            "*)"}], "\[IndentingNewLine]", 
           RowBox[{"binave", "=", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"bins", "[", 
                RowBox[{"[", "Posbinup", "]"}], "]"}], "+", 
               RowBox[{"bins", "[", 
                RowBox[{"[", 
                 RowBox[{"Posbinup", "-", "1"}], "]"}], "]"}]}], ")"}], "/", 
             "2.0"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
            "weight", " ", "bin", " ", "center", " ", "by", " ", "the", " ", 
             "peak", " ", "of", " ", "the", " ", "kinematical", " ", 
             "spectrum"}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"binave", "=", 
            RowBox[{"WeightBinAveBySpectrumPeak", "[", 
             RowBox[{
              RowBox[{"bins", "[", 
               RowBox[{"[", 
                RowBox[{"Posbinup", "-", "1"}], "]"}], "]"}], ",", 
              RowBox[{"bins", "[", 
               RowBox[{"[", "Posbinup", "]"}], "]"}], ",", "peakposin", ",", 
              "weightcloserin"}], "]"}]}], ";", "\[IndentingNewLine]", 
           "binave"}]}], "\[IndentingNewLine]", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"GetAveByBinLow", "[", 
         RowBox[{
         "binlowin_", ",", "binsin_", ",", "peakposin_", ",", 
          "weightcloserin_"}], "]"}], ":=", "\[IndentingNewLine]", 
        RowBox[{"Module", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"binlow", "=", "binlowin"}], ",", 
            RowBox[{"bins", "=", "binsin"}], ",", "Posbinlow", ",", 
            "BoolYmaxExist", ",", "binave"}], "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
           "check", " ", "the", " ", "input", " ", "is", " ", "the", " ", 
            "uplimit", " ", "of", " ", "one", " ", "of", " ", "the", " ", 
            "bin"}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"BoolYmaxExist", "=", "False"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"binlow", "==", 
                RowBox[{"bins", "[", 
                 RowBox[{"[", "i", "]"}], "]"}]}], ",", 
               RowBox[{
                RowBox[{"Posbinlow", "=", "i"}], ";", 
                RowBox[{"BoolYmaxExist", "=", "True"}]}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", 
               RowBox[{"Length", "[", "bins", "]"}]}], "}"}]}], "]"}], ";", 
           " ", "\[IndentingNewLine]", 
           RowBox[{"If", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"BoolYmaxExist", "\[Equal]", "False"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
              "Print", "[", 
               "\"\<GetAveByBinLow: error, the input binlow is not in the \
list of bin list, the average bin value could not be calculated \>\"", "]"}], 
              ";", "\[IndentingNewLine]", 
              RowBox[{"Print", "[", 
               RowBox[{"\"\<binlow value: \>\"", ",", "binlow"}], "]"}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"Print", "[", 
               RowBox[{"\"\<bin list: \>\"", ",", "bins"}], "]"}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"Abort", "[", "]"}]}]}], " ", "\[IndentingNewLine]", 
            "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
            "input", " ", "can", " ", "not", " ", "be", " ", "the", " ", 
             "largest", " ", "bin", " ", "edge"}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Posbinlow", "\[Equal]", 
              RowBox[{"Length", "[", "bins", "]"}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
              "Print", "[", 
               "\"\<GetAveByBinLow: error, the input binlow could not be the \
last element of the input bin list \>\"", "]"}], ";", "\[IndentingNewLine]", 
              RowBox[{"Print", "[", 
               RowBox[{"\"\<binlow value: \>\"", ",", "binlow"}], "]"}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"Print", "[", 
               RowBox[{"\"\<bin list: \>\"", ",", "bins"}], "]"}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"Abort", "[", "]"}]}]}], " ", "\[IndentingNewLine]", 
            "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{"average", " ", "the", " ", "bin", " ", "center"}], 
            "*)"}], "\[IndentingNewLine]", 
           RowBox[{"binave", "=", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"bins", "[", 
                RowBox[{"[", "Posbinlow", "]"}], "]"}], "+", 
               RowBox[{"bins", "[", 
                RowBox[{"[", 
                 RowBox[{"Posbinlow", "+", "1"}], "]"}], "]"}]}], ")"}], "/", 
             "2.0"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
            "weight", " ", "bin", " ", "center", " ", "by", " ", "the", " ", 
             "peak", " ", "of", " ", "the", " ", "kinematical", " ", 
             "spectrum"}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"binave", "=", 
            RowBox[{"WeightBinAveBySpectrumPeak", "[", 
             RowBox[{
              RowBox[{"bins", "[", 
               RowBox[{"[", "Posbinlow", "]"}], "]"}], ",", 
              RowBox[{"bins", "[", 
               RowBox[{"[", 
                RowBox[{"Posbinlow", "+", "1"}], "]"}], "]"}], ",", 
              "peakposin", ",", "weightcloserin"}], "]"}]}], ";", 
           "\[IndentingNewLine]", "binave"}]}], "\[IndentingNewLine]", 
         "]"}]}], ";", "\n", 
       RowBox[{"(*", "\n", 
        RowBox[{
         RowBox[{"data", "=", 
          RowBox[{"data", "/.", 
           RowBox[{"List", "\[RuleDelayed]", "LF"}]}]}], ";", "\n", 
         RowBox[{"data", "=", 
          RowBox[{"data", "/.", 
           RowBox[{
            RowBox[{"LF", "[", "x__", "]"}], "\[RuleDelayed]", 
            RowBox[{
             RowBox[{"{", "x", "}"}], "[", 
             RowBox[{"[", "Xindex", "]"}], "]"}]}]}]}], ";", "\n", "data"}], 
        "\n", "*)"}], "\n", 
       RowBox[{"(*", "\n", 
        RowBox[{
         RowBox[{"output", "=", 
          RowBox[{"Table", "[", "\n", 
           RowBox[{
            RowBox[{"datatmp", "=", 
             RowBox[{
              RowBox[{"data", "[", 
               RowBox[{"[", "i", "]"}], "]"}], "/.", 
              RowBox[{"List", "\[RuleDelayed]", "LF"}]}]}], ",", "\n", 
            RowBox[{"{", 
             RowBox[{"i", ",", "1", ",", 
              RowBox[{"Length", "[", "data", "]"}]}], "}"}]}], "\n", "]"}]}], 
         ";"}], "\n", "*)"}], "\n", "\n", 
       RowBox[{"expItype", "=", 
        RowBox[{"ExptIDinfo", "[", "ExptID", "]"}]}], ";", "\n", 
       RowBox[{"sqrtS", "=", 
        RowBox[{"ExptIDEcm", "[", "ExptID", "]"}]}], ";", "\n", 
       RowBox[{"S", "=", 
        RowBox[{"sqrtS", "^", "2"}]}], ";", "\n", "\n", 
       RowBox[{"(*", 
        RowBox[{"test", " ", "mathematica", " ", "symbols"}], "*)"}], "\n", 
       SqrtBox["S"], ";", 
       SuperscriptBox["\[ExponentialE]", "1.5"], ";", 
       RowBox[{"Log", "[", "39", "]"}], ";", 
       FractionBox["8", "1"], ";", 
       FractionBox["5", "3"], ";", 
       FractionBox["5", 
        SqrtBox["S"]], ";", "\n", "\n", "\n", 
       RowBox[{"output", "=", "\n", 
        RowBox[{"Switch", "[", 
         RowBox[{"expItype", ",", "\n", "\"\<DIS\>\"", ",", "\n", 
          RowBox[{"data", "/.", 
           RowBox[{
            RowBox[{"LF", "[", "a__", "]"}], ":>", 
            RowBox[{"LF", "@@", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Sequence", "@@", 
                RowBox[{"{", "a", "}"}]}], ",", 
               RowBox[{
                RowBox[{"{", "a", "}"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"{", "a", "}"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}]}], "}"}]}]}]}], ",", "\n", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"20171130", ":", " ", 
             RowBox[{"VBP1", " ", "no", " ", "data", " ", "set"}]}], ",", " ", 
            RowBox[{
            "formula", " ", "will", " ", "not", " ", "affect", " ", "the", 
             " ", "result"}]}], "*)"}], "\n", "\"\<VBP1\>\"", ",", "\n", 
          RowBox[{"data", "/.", 
           RowBox[{
            RowBox[{"LF", "[", "a__", "]"}], ":>", 
            RowBox[{"LF", "@@", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Sequence", "@@", 
                RowBox[{"{", "a", "}"}]}], ",", 
               RowBox[{"(*", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{"{", "a", "}"}], "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "/", 
                  RowBox[{"Sqrt", "[", "S", "]"}]}], ","}], "*)"}], 
               RowBox[{
                RowBox[{
                 RowBox[{"{", "a", "}"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "/", 
                RowBox[{"Sqrt", "[", "S", "]"}]}], ",", 
               RowBox[{
                RowBox[{"{", "a", "}"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}]}]}], ",", "\n", 
          "\"\<VBP2\>\"", ",", "\n", 
          RowBox[{"Join", "[", 
           RowBox[{
            RowBox[{"data", "/.", 
             RowBox[{
              RowBox[{"LF", "[", "a__", "]"}], ":>", 
              RowBox[{"LF", "@@", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Sequence", "@@", 
                  RowBox[{"{", "a", "}"}]}], ",", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", "\n", "\n",
                   "\n", "\n", 
                  SuperscriptBox["\[ExponentialE]", 
                   RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]]}], ",", 
                 RowBox[{
                  RowBox[{"{", "a", "}"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}]}]}], ",", 
            RowBox[{"data", "/.", 
             RowBox[{
              RowBox[{"LF", "[", "a__", "]"}], ":>", 
              RowBox[{"LF", "@@", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Sequence", "@@", 
                  RowBox[{"{", "a", "}"}]}], ",", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", "\n", "\n", 
                  RowBox[{"E", "^", 
                   RowBox[{"-", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}]}]}], ",", 
                 RowBox[{
                  RowBox[{"{", "a", "}"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}]}]}]}], "]"}], ",", 
          RowBox[{"(*", " ", 
           RowBox[{"x1", " ", "=", " ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"Q", "/", "sqrt"}], 
               RowBox[{"(", "S", ")"}]}], ")"}], "*", "exp", 
             RowBox[{"(", 
              RowBox[{"+", 
               RowBox[{"-", "y"}]}], ")"}]}]}], " ", "*)"}], "\n", 
          "\"\<VBP3\>\"", ",", "\n", 
          RowBox[{"Join", "[", 
           RowBox[{
            RowBox[{"data", "/.", 
             RowBox[{
              RowBox[{"LF", "[", "a__", "]"}], ":>", 
              RowBox[{"LF", "@@", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Sequence", "@@", 
                  RowBox[{"{", "a", "}"}]}], ",", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", "\n", "\n",
                   "\n", "\n", 
                  SuperscriptBox["\[ExponentialE]", 
                   RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]]}], ",", 
                 RowBox[{
                  RowBox[{"{", "a", "}"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}]}]}], ",", 
            RowBox[{"data", "/.", 
             RowBox[{
              RowBox[{"LF", "[", "a__", "]"}], ":>", 
              RowBox[{"LF", "@@", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Sequence", "@@", 
                  RowBox[{"{", "a", "}"}]}], ",", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                  RowBox[{"E", "^", 
                   RowBox[{"-", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}]}]}], ",", 
                 RowBox[{
                  RowBox[{"{", "a", "}"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}]}]}]}], "]"}], ",", 
          RowBox[{"(*", " ", 
           RowBox[{"formula", " ", "not", " ", "decided", " ", "yet"}], " ", 
           "*)"}], "\n", "\"\<ID267\>\"", ",", "\n", 
          RowBox[{"Join", "[", 
           RowBox[{
            RowBox[{"data", "/.", 
             RowBox[{
              RowBox[{"LF", "[", "a__", "]"}], ":>", 
              RowBox[{"LF", "@@", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Sequence", "@@", 
                  RowBox[{"{", "a", "}"}]}], ",", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"80.39", "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", "\n", "\n",
                   "\n", "\n", 
                  SuperscriptBox["\[ExponentialE]", 
                   RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]]}], ",", "80.39"}], 
                "}"}]}]}]}], ",", 
            RowBox[{"data", "/.", 
             RowBox[{
              RowBox[{"LF", "[", "a__", "]"}], ":>", 
              RowBox[{"LF", "@@", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Sequence", "@@", 
                  RowBox[{"{", "a", "}"}]}], ",", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"80.39", "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                  RowBox[{"E", "^", 
                   RowBox[{"-", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}]}]}], ",", "80.39"}], 
                "}"}]}]}]}]}], "]"}], ",", 
          RowBox[{"(*", " ", 
           RowBox[{"formula", " ", "not", " ", "decided", " ", "yet"}], " ", 
           "*)"}], "\n", "\"\<ID247\>\"", ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"peakposin", "=", 
            RowBox[{"-", "10000.0"}]}], ";", 
           RowBox[{"weightcloserin", "=", "1.0"}], ";", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"WeightBinAveBySpectrumPeak", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"{", "a", "}"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"{", "a", "}"}], "[", 
                RowBox[{"[", "3", "]"}], "]"}], ",", "peakposin", ",", 
               "weightcloserin"}], "]"}], ";"}], "*)"}], "\n", 
           RowBox[{"data", "/.", 
            RowBox[{
             RowBox[{"LF", "[", "a__", "]"}], ":>", 
             RowBox[{"LF", "@@", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Sequence", "@@", 
                 RowBox[{"{", "a", "}"}]}], ",", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"Sqrt", "[", 
                   RowBox[{
                    RowBox[{"91.19", "^", "2"}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"WeightBinAveBySpectrumPeak", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "peakposin", ",", 
                    "weightcloserin"}], "]"}], ")"}], "^", "2"}]}], "]"}], 
                  "/", 
                  RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], ",", 
                RowBox[{"Sqrt", "[", 
                 RowBox[{
                  RowBox[{"91.19", "^", "2"}], "+", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"WeightBinAveBySpectrumPeak", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "peakposin", ",", 
                    "weightcloserin"}], "]"}], ")"}], "^", "2"}]}], "]"}]}], 
               "}"}]}]}]}]}], ",", "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{"20171208", " ", "new", " ", "data", " ", "from", " ", 
            RowBox[{"TJ", "'"}], "s", " ", "HERA2", " ", "ev02"}], " ", 
           "*)"}], "\[IndentingNewLine]", "\"\<ID252\>\"", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"d\[Sigma]", "/", 
             SubscriptBox["dm", "ll"]}], "dy"}], "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{
             RowBox[{"pT", 
              RowBox[{"(", "l1", ")"}]}], ">", 
             RowBox[{"40", " ", "GeV"}]}], ",", " ", 
            RowBox[{
             RowBox[{"pT", 
              RowBox[{"(", "l2", ")"}]}], ">", 
             RowBox[{"30", " ", "GeV"}]}], ",", " ", 
            RowBox[{
             RowBox[{"so", " ", "mll"}], " ", ">", " ", 
             RowBox[{
             "70", " ", "GeV", " ", "for", " ", "the", " ", "formula"}]}]}], 
           "*)"}], "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{
             RowBox[{"in", " ", ".", "dta"}], " ", 
             RowBox[{"files", ":", " ", 
              RowBox[{"col1", " ", "\[Equal]", " ", "<", "y", ">"}]}]}], ",", 
            " ", 
            RowBox[{"col2", " ", "\[Equal]", " ", 
             SubscriptBox["mll", "min"]}], ",", " ", 
            RowBox[{"col3", " ", "\[Equal]", " ", "unset"}]}], "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"mllrange", "=", 
            RowBox[{"{", 
             RowBox[{
             "116.0", ",", "150.0", ",", "200.0", ",", "300.0", ",", "500.0", 
              ",", "1500.0"}], "}"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"peakposin", "=", 
            RowBox[{"-", "10000.0"}]}], ";", 
           RowBox[{"weightcloserin", "=", "1.0"}], ";", "\n", 
           RowBox[{"Select", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Join", "[", 
              RowBox[{
               RowBox[{"data", "/.", 
                RowBox[{
                 RowBox[{"LF", "[", "a__", "]"}], "\[RuleDelayed]", 
                 RowBox[{"LF", "@@", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"Sequence", "@@", 
                    RowBox[{"{", "a", "}"}]}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"GetAveByBinLow", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "mllrange", ",", 
                    "peakposin", ",", "weightcloserin"}], "]"}], "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ")"}]}]}], ",", 
                    RowBox[{"GetAveByBinLow", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "mllrange", ",", 
                    "peakposin", ",", "weightcloserin"}], "]"}]}], 
                   "}"}]}]}]}], ",", "\[IndentingNewLine]", 
               RowBox[{"data", "/.", 
                RowBox[{
                 RowBox[{"LF", "[", "a__", "]"}], "\[RuleDelayed]", 
                 RowBox[{"LF", "@@", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"Sequence", "@@", 
                    RowBox[{"{", "a", "}"}]}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"GetAveByBinLow", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "mllrange", ",", 
                    "peakposin", ",", "weightcloserin"}], "]"}], "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                    RowBox[{"E", "^", 
                    RowBox[{"-", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ")"}]}]}]}], ",", 
                    RowBox[{"GetAveByBinLow", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "mllrange", ",", 
                    "peakposin", ",", "weightcloserin"}], "]"}]}], 
                   "}"}]}]}]}]}], "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{"(*", 
              RowBox[{
              "delete", " ", "the", " ", "point", " ", "who", " ", "or", " ", 
               "whose", " ", "pair", " ", "has", " ", "too", " ", 
               RowBox[{"large", "/", "small"}], " ", "x"}], "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{"(*", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"(", " ", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"GetAveByBinLow", "[", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "mllrange", ",", 
                    "peakposin", ",", "weightcloserin"}], "]"}], ">", 
                   "70.0"}], ")"}], " ", "&&", " ", "\[IndentingNewLine]", 
                 RowBox[{"(", " ", 
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"GetAveByBinLow", "[", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "mllrange", ",", 
                    "peakposin", ",", "weightcloserin"}], "]"}], "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ")"}]}]}], "<", "1.0"}], 
                   " ", "&&", " ", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"GetAveByBinLow", "[", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "mllrange", ",", 
                    "peakposin", ",", "weightcloserin"}], "]"}], "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ")"}]}]}], ">", " ", 
                    SuperscriptBox["10.0", 
                    RowBox[{"-", "10"}]]}], " ", "&&", " ", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"GetAveByBinLow", "[", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "mllrange", ",", 
                    "peakposin", ",", "weightcloserin"}], "]"}], "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                    RowBox[{"E", "^", 
                    RowBox[{"-", 
                    RowBox[{"(", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ")"}]}]}]}], "<", "1.0"}],
                    " ", "&&", " ", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"GetAveByBinLow", "[", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "mllrange", ",", 
                    "peakposin", ",", "weightcloserin"}], "]"}], "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                    RowBox[{"E", "^", 
                    RowBox[{"-", 
                    RowBox[{"(", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ")"}]}]}]}], ">", 
                    SuperscriptBox["10.0", 
                    RowBox[{"-", "10"}]]}]}], ")"}]}], " ", 
                "\[IndentingNewLine]", ")"}], "&"}], "\[IndentingNewLine]", 
              "*)"}], "\[IndentingNewLine]", 
             RowBox[{"(*", 
              RowBox[{
              "20180322", " ", "only", " ", "delete", " ", "the", " ", 
               "point", " ", "with", " ", "too", " ", 
               RowBox[{"large", "/", "small"}], " ", "x"}], "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"(", " ", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"GetAveByBinLow", "[", 
                   RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "mllrange", ",", 
                    "peakposin", ",", "weightcloserin"}], "]"}], ">", 
                  "70.0"}], ")"}], " ", "&&", " ", "\[IndentingNewLine]", 
                RowBox[{"(", " ", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"#", "[", 
                    RowBox[{"[", 
                    RowBox[{"-", "2"}], "]"}], "]"}], "<", "1.0"}], " ", "&&",
                   " ", 
                  RowBox[{
                   RowBox[{"#", "[", 
                    RowBox[{"[", 
                    RowBox[{"-", "2"}], "]"}], "]"}], ">", " ", 
                   SuperscriptBox["10.0", 
                    RowBox[{"-", "10"}]]}]}], " ", ")"}]}], " ", 
               "\[IndentingNewLine]", ")"}], "&"}]}], "\[IndentingNewLine]", 
            "]"}]}], ",", "\[IndentingNewLine]", "\"\<ID253\>\"", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{"mll", " ", "ZpT", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d\[Sigma]", "/", 
               SubscriptBox["dp", "T"]}], " ", "in", " ", "ranges", " ", "of",
               " ", 
              SubscriptBox["m", "ll"]}], ")"}]}], "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{
             RowBox[{"in", " ", ".", "dta"}], " ", 
             RowBox[{"files", ":", " ", 
              RowBox[{
               RowBox[{"column", " ", "1"}], " ", "\[Equal]", " ", 
               SubscriptBox["mll", "max"]}]}]}], ",", " ", 
            RowBox[{"col2", " ", "\[Equal]", " ", "ptmin"}], ",", " ", 
            RowBox[{"col3", " ", "\[Equal]", " ", "ptmax"}]}], "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"mllrange", "=", 
            RowBox[{"{", 
             RowBox[{
             "12.0", ",", "20.0", ",", "30.0", ",", "46.0", ",", "66.0", ",", 
              "116.0", ",", "150.0"}], "}"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"peakposin", "=", 
            RowBox[{"-", "10000.0"}]}], ";", 
           RowBox[{"weightcloserin", "=", "1.0"}], ";", "\n", 
           RowBox[{"data", "/.", 
            RowBox[{
             RowBox[{"LF", "[", "a__", "]"}], ":>", 
             RowBox[{"LF", "@@", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Sequence", "@@", 
                 RowBox[{"{", "a", "}"}]}], ",", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"Sqrt", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"GetAveByBinUp", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", "mllrange", ",", 
                    "peakposin", ",", "weightcloserin"}], "]"}], "^", "2"}], 
                    "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "+", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}], ")"}], "/", "2.0"}], 
                    ")"}], "^", "2"}]}], "]"}], "/", 
                  RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], ",", 
                RowBox[{"Sqrt", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"GetAveByBinUp", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", "mllrange", ",", 
                    "peakposin", ",", "weightcloserin"}], "]"}], "^", "2"}], 
                  "+", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "+", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}], ")"}], "/", "2.0"}], 
                    ")"}], "^", "2"}]}], "]"}]}], "}"}]}]}]}]}], ",", 
          "\[IndentingNewLine]", "\"\<ID254\>\"", ",", "\[IndentingNewLine]", 
          
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"d\[Sigma]", "/", 
             SubscriptBox["dp", "T"]}], "dy"}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{
             RowBox[{"in", " ", ".", "dta"}], " ", 
             RowBox[{"files", ":", " ", 
              RowBox[{"col1", " ", "\[Equal]", " ", 
               SubscriptBox["y", "max"]}]}]}], ",", " ", 
            RowBox[{"col2", " ", "\[Equal]", " ", 
             SubscriptBox["pT", "min"]}], ",", " ", 
            RowBox[{"col3", " ", "\[Equal]", " ", 
             SubscriptBox["pT", "max"]}]}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"yrange", "=", 
            RowBox[{"{", 
             RowBox[{
             "0.0", ",", "0.4", ",", "0.8", ",", "1.2", ",", "1.6", ",", 
              "2.0"}], "}"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"peakposin", "=", 
            RowBox[{"-", "10000.0"}]}], ";", 
           RowBox[{"weightcloserin", "=", "1.0"}], ";", "\n", 
           RowBox[{"Join", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"data", "/.", 
              RowBox[{
               RowBox[{"LF", "[", "a__", "]"}], "\[RuleDelayed]", 
               RowBox[{"LF", "@@", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Sequence", "@@", 
                   RowBox[{"{", "a", "}"}]}], ",", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Sqrt", "[", 
                    RowBox[{
                    RowBox[{"91.19", "^", "2"}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "+", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}], ")"}], "/", "2.0"}], 
                    ")"}], "^", "2"}]}], "]"}], "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                   RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"GetAveByBinUp", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", "yrange", ",", 
                    "peakposin", ",", "weightcloserin"}], "]"}], ")"}]}]}], 
                  ",", 
                  RowBox[{"Sqrt", "[", 
                   RowBox[{
                    RowBox[{"91.19", "^", "2"}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "+", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}], ")"}], "/", "2.0"}], 
                    ")"}], "^", "2"}]}], "]"}]}], "}"}]}]}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"data", "/.", 
              RowBox[{
               RowBox[{"LF", "[", "a__", "]"}], "\[RuleDelayed]", 
               RowBox[{"LF", "@@", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Sequence", "@@", 
                   RowBox[{"{", "a", "}"}]}], ",", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Sqrt", "[", 
                    RowBox[{
                    RowBox[{"91.19", "^", "2"}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "+", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}], ")"}], "/", "2.0"}], 
                    ")"}], "^", "2"}]}], "]"}], "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                   RowBox[{"E", "^", 
                    RowBox[{"-", 
                    RowBox[{"(", 
                    RowBox[{"GetAveByBinUp", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", "yrange", ",", 
                    "peakposin", ",", "weightcloserin"}], "]"}], ")"}]}]}]}], 
                  ",", 
                  RowBox[{"Sqrt", "[", 
                   RowBox[{
                    RowBox[{"91.19", "^", "2"}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "+", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}], ")"}], "/", "2.0"}], 
                    ")"}], "^", "2"}]}], "]"}]}], "}"}]}]}]}]}], 
            "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
          "\"\<ID255\>\"", ",", "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"d\[Sigma]", "/", "pT"}], 
            RowBox[{"(", 
             RowBox[{"W", "/", "Z"}], ")"}]}], "*)"}], "\[IndentingNewLine]", 
          
          RowBox[{"(*", 
           RowBox[{
            RowBox[{
             RowBox[{"in", " ", ".", "dta"}], " ", 
             RowBox[{"files", ":", " ", 
              RowBox[{
               RowBox[{"column", " ", "1"}], " ", "\[Equal]", " ", "ycut", 
               " ", "<", " ", "2.5"}]}]}], ",", " ", 
            RowBox[{"col2", " ", "\[Equal]", " ", "ptmin"}], ",", " ", 
            RowBox[{"col3", " ", "\[Equal]", " ", "ptmax"}]}], "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"in", " ", "HERA2", " ", "ev02"}], ",", " ", 
            RowBox[{
            "the", " ", "first", " ", "4", " ", "points", " ", "are", " ", 
             "W", " ", "process", " ", "events"}], ",", " ", 
            RowBox[{
            "the", " ", "last", " ", "5", " ", "points", " ", "are", " ", "Z",
              " ", "process", " ", "events"}]}], "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"peakposin", "=", 
            RowBox[{"-", "10000.0"}]}], ";", 
           RowBox[{"(*", 
            RowBox[{"ptmu", " ", ">", " ", 
             RowBox[{"15", " ", "GeV"}]}], "*)"}], 
           RowBox[{"weightcloserin", "=", "1.0"}], ";", "\n", 
           RowBox[{"Join", "[", "\[IndentingNewLine]", 
            RowBox[{"(*", "W", "*)"}], "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"Take", "[", 
               RowBox[{"data", ",", "4"}], "]"}], "/.", 
              RowBox[{
               RowBox[{"LF", "[", "a__", "]"}], "\[RuleDelayed]", 
               RowBox[{"LF", "@@", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Sequence", "@@", 
                   RowBox[{"{", "a", "}"}]}], ",", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"Sqrt", "[", 
                    RowBox[{
                    RowBox[{"80.39", "^", "2"}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"WeightBinAveBySpectrumPeak", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "peakposin", ",", 
                    "weightcloserin"}], "]"}], ")"}], "^", "2"}]}], "]"}], 
                    "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], ",", 
                  RowBox[{"Sqrt", "[", 
                   RowBox[{
                    RowBox[{"80.39", "^", "2"}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"WeightBinAveBySpectrumPeak", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "peakposin", ",", 
                    "weightcloserin"}], "]"}], ")"}], "^", "2"}]}], "]"}]}], 
                 "}"}]}]}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"(*", "Z", "*)"}], "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Take", "[", 
               RowBox[{"data", ",", 
                RowBox[{"-", "5"}]}], "]"}], "/.", 
              RowBox[{
               RowBox[{"LF", "[", "a__", "]"}], "\[RuleDelayed]", 
               RowBox[{"LF", "@@", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Sequence", "@@", 
                   RowBox[{"{", "a", "}"}]}], ",", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"Sqrt", "[", 
                    RowBox[{
                    RowBox[{"91.19", "^", "2"}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"WeightBinAveBySpectrumPeak", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "peakposin", ",", 
                    "weightcloserin"}], "]"}], ")"}], "^", "2"}]}], "]"}], 
                    "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], ",", 
                  RowBox[{"Sqrt", "[", 
                   RowBox[{
                    RowBox[{"91.19", "^", "2"}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"WeightBinAveBySpectrumPeak", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "peakposin", ",", 
                    "weightcloserin"}], "]"}], ")"}], "^", "2"}]}], "]"}]}], 
                 "}"}]}]}]}]}], "\[IndentingNewLine]", "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{"formula", " ", "not", " ", "decided", " ", "yet"}], " ", 
           "*)"}], "\n", "\"\<JP\>\"", ",", "\n", 
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{
             RowBox[{
             "this", " ", "form", " ", "is", " ", "for", " ", "q1q2"}], " ", 
             "\[Rule]", " ", "j1j2"}], ",", " ", 
            RowBox[{"estimate", " ", "x1"}], ",", " ", 
            RowBox[{
            "x2", " ", "of", " ", "jet", " ", "as", " ", "peak", " ", "of", 
             " ", "y", 
             RowBox[{"(", "j1", ")"}]}], ",", " ", 
            RowBox[{"y", 
             RowBox[{"(", "j2", ")"}]}]}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"peakposin", "=", 
            RowBox[{"-", "10000.0"}]}], ";", 
           RowBox[{"weightcloserin", "=", "1.0"}], ";", 
           RowBox[{"(*", 
            RowBox[{"test", " ", "strong", " ", "weight"}], "*)"}], "\n", 
           RowBox[{"Select", "[", "\n", 
            RowBox[{
             RowBox[{"Join", "[", 
              RowBox[{
               RowBox[{"data", "/.", 
                RowBox[{
                 RowBox[{"LF", "[", "a__", "]"}], ":>", 
                 RowBox[{"LF", "@@", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"Sequence", "@@", 
                    RowBox[{"{", "a", "}"}]}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"2", "*", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ")"}], "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"WeightBinAveBySpectrumPeak", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "peakposin", ",", 
                    "weightcloserin"}], "]"}], ")"}]}]}], ",", 
                    RowBox[{"2", "*", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}]}], "}"}]}]}]}], ",", 
               RowBox[{"data", "/.", 
                RowBox[{
                 RowBox[{"LF", "[", "a__", "]"}], ":>", 
                 RowBox[{"LF", "@@", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"Sequence", "@@", 
                    RowBox[{"{", "a", "}"}]}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"2", "*", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ")"}], "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                    RowBox[{"E", "^", 
                    RowBox[{"-", 
                    RowBox[{"(", 
                    RowBox[{"WeightBinAveBySpectrumPeak", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "peakposin", ",", 
                    "weightcloserin"}], "]"}], ")"}]}]}]}], ",", 
                    RowBox[{"2", "*", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}]}], "}"}]}]}]}]}], "]"}], 
             ",", "\[IndentingNewLine]", 
             RowBox[{"(*", 
              RowBox[{
              "delete", " ", "the", " ", "point", " ", "who", " ", "or", " ", 
               "whose", " ", "pair", " ", "has", " ", "too", " ", 
               RowBox[{"large", "/", "small"}], " ", "x"}], "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{"(*", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"(", " ", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"2", "*", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ")"}], "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                   RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"WeightBinAveBySpectrumPeak", "[", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "peakposin", ",", 
                    "weightcloserin"}], "]"}], ")"}]}]}], "<", "1.0"}], " ", "&&",
                  " ", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"2", "*", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ")"}], "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                   RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"WeightBinAveBySpectrumPeak", "[", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "peakposin", ",", 
                    "weightcloserin"}], "]"}], ")"}]}]}], ">", 
                  SuperscriptBox["10.0", 
                   RowBox[{"-", "10"}]]}], " ", "&&", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"2", "*", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ")"}], "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                   RowBox[{"E", "^", 
                    RowBox[{"-", 
                    RowBox[{"(", 
                    RowBox[{"WeightBinAveBySpectrumPeak", "[", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "peakposin", ",", 
                    "weightcloserin"}], "]"}], ")"}]}]}]}], "<", "1.0"}], " ",
                  "&&", " ", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"2", "*", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ")"}], "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                   RowBox[{"E", "^", 
                    RowBox[{"-", 
                    RowBox[{"(", 
                    RowBox[{"WeightBinAveBySpectrumPeak", "[", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "peakposin", ",", 
                    "weightcloserin"}], "]"}], ")"}]}]}]}], ">", 
                  SuperscriptBox["10.0", 
                   RowBox[{"-", "10"}]]}]}], " ", ")"}], "&"}], 
              "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
             RowBox[{"(*", 
              RowBox[{
              "20180322", " ", "only", " ", "delete", " ", "the", " ", 
               "point", " ", "with", " ", "too", " ", 
               RowBox[{"large", "/", "small"}], " ", "x"}], "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"(", " ", 
               RowBox[{
                RowBox[{
                 RowBox[{"#", "[", 
                  RowBox[{"[", 
                   RowBox[{"-", "2"}], "]"}], "]"}], "<", "1.0"}], " ", "&&", 
                " ", 
                RowBox[{
                 RowBox[{"#", "[", 
                  RowBox[{"[", 
                   RowBox[{"-", "2"}], "]"}], "]"}], ">", " ", 
                 SuperscriptBox["10.0", 
                  RowBox[{"-", "10"}]]}]}], " ", ")"}], "&"}]}], 
            "\[IndentingNewLine]", "]"}]}], ",", 
          RowBox[{"(*", 
           RowBox[{"x1", "=", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"Subscript", "[", 
                RowBox[{"p", ",", " ", "Tj"}], "]"}], "/", 
               RowBox[{"(", 
                RowBox[{"2", 
                 RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}]}], ")"}], "*", 
             RowBox[{"e", "^", 
              RowBox[{"Subscript", "[", 
               RowBox[{"y", ",", " ", "j"}], "]"}]}]}]}], "*)"}], "\n", "\n", 
          
          RowBox[{"(*", 
           RowBox[{
            RowBox[{
             RowBox[{
             "this", " ", "form", " ", "is", " ", "for", " ", "q1q2"}], " ", 
             "\[Rule]", " ", "W"}], ",", " ", 
            RowBox[{"Z", " ", "or", " ", "something"}], ",", " ", 
            RowBox[{"so", " ", "rapidity", " ", "is", " ", "yjj"}], ",", " ", 
            
            RowBox[{
            "estimating", " ", "x", " ", "as", " ", "peak", " ", "of", " ", 
             "yjj"}]}], "*)"}], "\n", 
          RowBox[{"(*", "\n", 
           RowBox[{
            RowBox[{"data", "/.", 
             RowBox[{
              RowBox[{"LF", "[", "a__", "]"}], "\[RuleDelayed]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"2", "\[Times]", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{"Sqrt", "[", "S", "]"}], ")"}]}], ")"}], ",", 
                RowBox[{"2", "\[Times]", 
                 RowBox[{
                  RowBox[{"{", "a", "}"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}]}]}], "}"}]}]}], ","}], "\n", 
           "*)"}], "\n", 
          RowBox[{"(*", 
           RowBox[{"20171118", ":", " ", 
            RowBox[{"add", " ", 
             RowBox[{"565", " ", "~", "568"}], " ", 
             RowBox[{"(", 
              RowBox[{"ttbar", " ", "production"}], ")"}], " ", 
             "formulas"}]}], "*)"}], "\n", 
          RowBox[{"(*", 
           RowBox[{"pT", ",", " ", 
            RowBox[{
            "the", " ", "same", " ", "as", " ", "the", " ", "formula", " ", 
             "of", " ", "JP"}]}], "*)"}], "\n", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"20171126", ":", " ", 
             RowBox[{"pt", " ", "events"}]}], ",", " ", 
            RowBox[{
             RowBox[{"<", "y", ">"}], " ", "=", " ", "0"}]}], "*)"}], "\n", 
          "\"\<ttbarpT\>\"", ",", "\[IndentingNewLine]", 
          RowBox[{"Select", "[", "\n", 
           RowBox[{
            RowBox[{"data", "/.", 
             RowBox[{
              RowBox[{"LF", "[", "a__", "]"}], ":>", 
              RowBox[{"LF", "@@", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Sequence", "@@", 
                  RowBox[{"{", "a", "}"}]}], ",", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"2", "*", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ")"}], "/", 
                   RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], ",", 
                 RowBox[{"2", "*", 
                  RowBox[{
                   RowBox[{"{", "a", "}"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}]}]}], "}"}]}]}]}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{
             "delete", " ", "the", " ", "point", " ", "who", " ", "or", " ", 
              "whose", " ", "pair", " ", "has", " ", "too", " ", 
              RowBox[{"large", "/", "small"}], " ", "x"}], "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{"(*", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"(", " ", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"2", "*", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ")"}], "/", 
                   RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "<", "1.0"}], 
                " ", "&&", " ", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"2", "*", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ")"}], "/", 
                   RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], ">", 
                 SuperscriptBox["10.0", 
                  RowBox[{"-", "10"}]]}]}], " ", ")"}], "&"}], 
             "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{
             "20180322", " ", "only", " ", "delete", " ", "the", " ", "point",
               " ", "with", " ", "too", " ", 
              RowBox[{"large", "/", "small"}], " ", "x"}], "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"(", " ", 
              RowBox[{
               RowBox[{
                RowBox[{"#", "[", 
                 RowBox[{"[", 
                  RowBox[{"-", "2"}], "]"}], "]"}], "<", "1.0"}], " ", "&&", 
               " ", 
               RowBox[{
                RowBox[{"#", "[", 
                 RowBox[{"[", 
                  RowBox[{"-", "2"}], "]"}], "]"}], ">", " ", 
                SuperscriptBox["10.0", 
                 RowBox[{"-", "10"}]]}]}], " ", ")"}], "&"}]}], 
           "\[IndentingNewLine]", "]"}], ",", "\n", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"mu", " ", "=", " ", "mtt"}], ",", " ", 
            RowBox[{"x", " ", "=", " ", 
             RowBox[{"mtt", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"since", " ", "y"}], " ", "=", " ", 
                RowBox[{"0", " ", "for", " ", "this", " ", "case"}]}], 
               ")"}]}]}]}], "*)"}], "\n", "\"\<ttbarmtt\>\"", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Select", "[", "\n", 
           RowBox[{
            RowBox[{"data", "/.", 
             RowBox[{
              RowBox[{"LF", "[", "a__", "]"}], ":>", 
              RowBox[{"LF", "@@", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Sequence", "@@", 
                  RowBox[{"{", "a", "}"}]}], ",", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "/", 
                   RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], ",", 
                 RowBox[{
                  RowBox[{"{", "a", "}"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}]}], "}"}]}]}]}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{
             "delete", " ", "the", " ", "point", " ", "who", " ", "or", " ", 
              "whose", " ", "pair", " ", "has", " ", "too", " ", 
              RowBox[{"large", "/", "small"}], " ", "x"}], "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{"(*", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"(", " ", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "/", 
                   RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "<", "1.0"}], 
                " ", "&&", " ", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "/", 
                   RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], ">", 
                 SuperscriptBox["10.0", 
                  RowBox[{"-", "10"}]]}]}], " ", ")"}], "&"}], 
             "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{
             "20180322", " ", "only", " ", "delete", " ", "the", " ", "point",
               " ", "with", " ", "too", " ", 
              RowBox[{"large", "/", "small"}], " ", "x"}], "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"(", " ", 
              RowBox[{
               RowBox[{
                RowBox[{"#", "[", 
                 RowBox[{"[", 
                  RowBox[{"-", "2"}], "]"}], "]"}], "<", "1.0"}], " ", "&&", 
               " ", 
               RowBox[{
                RowBox[{"#", "[", 
                 RowBox[{"[", 
                  RowBox[{"-", "2"}], "]"}], "]"}], ">", " ", 
                SuperscriptBox["10.0", 
                 RowBox[{"-", "10"}]]}]}], " ", ")"}], "&"}]}], 
           "\[IndentingNewLine]", "]"}], ",", "\n", 
          RowBox[{"(*", 
           RowBox[{"ytt", ",", " ", 
            RowBox[{
             RowBox[{
              RowBox[{"ya", "==", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"yt", "+", "ytbar"}], ")"}], "/", "2"}]}], ":", " ", 
              
              RowBox[{
               RowBox[{
                RowBox[{"mu", "~", " ", "2"}], "mt"}], "+", 
               RowBox[{"100", "GeV"}]}]}], " ", "=", " ", 
             RowBox[{"450", " ", "GeV"}]}], ",", " ", 
            RowBox[{"x", " ", "=", " ", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"Q", "/", 
                RowBox[{"\[Sqrt]", "S"}]}], ")"}], "*", 
              RowBox[{"e", "^", 
               RowBox[{"+", 
                RowBox[{"-", "y"}]}]}]}]}]}], "*)"}], "\n", "\"\<ttbary\>\"", 
          ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"peakposin", "=", 
            RowBox[{"-", "10000.0"}]}], ";", 
           RowBox[{"weightcloserin", "=", "1.0"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Select", "[", "\n", 
            RowBox[{
             RowBox[{"Join", "[", 
              RowBox[{
               RowBox[{"data", "/.", 
                RowBox[{
                 RowBox[{"LF", "[", "a__", "]"}], ":>", 
                 RowBox[{"LF", "@@", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"Sequence", "@@", 
                    RowBox[{"{", "a", "}"}]}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"400.0", "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"WeightBinAveBySpectrumPeak", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "peakposin", ",", 
                    "weightcloserin"}], "]"}], ")"}]}]}], ",", "400.0"}], 
                   "}"}]}]}]}], ",", 
               RowBox[{"data", "/.", 
                RowBox[{
                 RowBox[{"LF", "[", "a__", "]"}], ":>", 
                 RowBox[{"LF", "@@", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"Sequence", "@@", 
                    RowBox[{"{", "a", "}"}]}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"400.0", "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                    RowBox[{"E", "^", 
                    RowBox[{"-", 
                    RowBox[{"(", 
                    RowBox[{"WeightBinAveBySpectrumPeak", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "peakposin", ",", 
                    "weightcloserin"}], "]"}], ")"}]}]}]}], ",", "400.0"}], 
                   "}"}]}]}]}]}], "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{"(*", 
              RowBox[{
              "delete", " ", "the", " ", "point", " ", "who", " ", "or", " ", 
               "whose", " ", "pair", " ", "has", " ", "too", " ", 
               RowBox[{"large", "/", "small"}], " ", "x"}], "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{"(*", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"(", " ", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"400.0", "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                   RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"WeightBinAveBySpectrumPeak", "[", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "peakposin", ",", 
                    "weightcloserin"}], "]"}], ")"}]}]}], "<", "1.0"}], " ", "&&",
                  " ", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"400.0", "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                   RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"WeightBinAveBySpectrumPeak", "[", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "peakposin", ",", 
                    "weightcloserin"}], "]"}], ")"}]}]}], ">", 
                  RowBox[{
                   SuperscriptBox["10.0", 
                    RowBox[{"-", "10"}]], "\[IndentingNewLine]", 
                   RowBox[{"(", 
                    RowBox[{"400.0", "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                   RowBox[{"E", "^", 
                    RowBox[{"-", 
                    RowBox[{"(", 
                    RowBox[{"WeightBinAveBySpectrumPeak", "[", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "peakposin", ",", 
                    "weightcloserin"}], "]"}], ")"}]}]}]}], "<", "1.0"}], " ",
                  "&&", " ", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"400.0", "/", 
                    RowBox[{"Sqrt", "[", "S", "]"}]}], ")"}], "*", 
                   RowBox[{"E", "^", 
                    RowBox[{"-", 
                    RowBox[{"(", 
                    RowBox[{"WeightBinAveBySpectrumPeak", "[", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", "peakposin", ",", 
                    "weightcloserin"}], "]"}], ")"}]}]}]}], ">", 
                  SuperscriptBox["10.0", 
                   RowBox[{"-", "10"}]]}]}], " ", ")"}], "&"}], 
              "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
             RowBox[{"(*", 
              RowBox[{
              "20180322", " ", "only", " ", "delete", " ", "the", " ", 
               "point", " ", "with", " ", "too", " ", 
               RowBox[{"large", "/", "small"}], " ", "x"}], "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"(", " ", 
               RowBox[{
                RowBox[{
                 RowBox[{"#", "[", 
                  RowBox[{"[", 
                   RowBox[{"-", "2"}], "]"}], "]"}], "<", "1.0"}], " ", "&&", 
                " ", 
                RowBox[{
                 RowBox[{"#", "[", 
                  RowBox[{"[", 
                   RowBox[{"-", "2"}], "]"}], "]"}], ">", " ", 
                 SuperscriptBox["10.0", 
                  RowBox[{"-", "10"}]]}]}], " ", ")"}], "&"}]}], 
            "\[IndentingNewLine]", "]"}]}], ",", "\n", "_", ",", "\n", 
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<Wrong expItype value, \>\"", ",", "expItype", ",", 
            "\"\<, \>\"", ",", "ExptID"}], "]"}]}], " ", 
         RowBox[{"(*", 
          RowBox[{"data", "/.", 
           RowBox[{
            RowBox[{"LF", "[", "a__", "]"}], "\[RuleDelayed]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"{", "a", "}"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], ",", 
              RowBox[{
               RowBox[{"{", "a", "}"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}]}], "*)"}], "\n", 
         "]"}]}], ";", "\n", "\n", 
       RowBox[{"(*", "\n", 
        RowBox[{
         RowBox[{"output", "=", 
          RowBox[{"Table", "[", "\n", 
           RowBox[{
            RowBox[{"datatmp", "=", 
             RowBox[{
              RowBox[{"output", "[", 
               RowBox[{"[", "i", "]"}], "]"}], "/.", 
              RowBox[{"List", "\[RuleDelayed]", "LF"}]}]}], ",", "\n", 
            RowBox[{"{", 
             RowBox[{"i", ",", "1", ",", 
              RowBox[{"Length", "[", "output", "]"}]}], "}"}]}], "\n", 
           "]"}]}], ";"}], "\n", "*)"}], "\n", "\n", "output"}]}], " ", "\n", 
     "]"}]}], ";"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.721150001887135*^9, 3.7211501009476433`*^9}, {
   3.7211505421493063`*^9, 3.7211505503787127`*^9}, {3.721150645708261*^9, 
   3.7211506460877237`*^9}, 3.721150695389825*^9, {3.7211507357333393`*^9, 
   3.72115076777687*^9}, {3.7215240641802692`*^9, 3.721524075826379*^9}, {
   3.721524145676441*^9, 3.721524214016493*^9}, {3.721524297734665*^9, 
   3.7215243191032763`*^9}, {3.721524372026087*^9, 3.721524393590251*^9}, {
   3.721524438237602*^9, 3.721524585237278*^9}, {3.721524683436452*^9, 
   3.721524761604816*^9}, {3.721524832421174*^9, 3.721524936597439*^9}, {
   3.721761517820938*^9, 3.7217615797216663`*^9}, {3.721761772606629*^9, 
   3.72176182267636*^9}, {3.721762546965995*^9, 3.721762617326653*^9}, {
   3.72176265460751*^9, 3.7217627637698174`*^9}, 3.72176281701503*^9, {
   3.721762907399836*^9, 3.7217630085050898`*^9}, {3.721763041826972*^9, 
   3.721763067145*^9}, {3.721764120334045*^9, 3.7217642935102043`*^9}, {
   3.721764428901711*^9, 3.721764447934544*^9}, {3.721764480355042*^9, 
   3.721764512479927*^9}, {3.721764592043152*^9, 3.721764600005816*^9}, {
   3.721765099626886*^9, 3.7217651707824574`*^9}, {3.7217652253823757`*^9, 
   3.721765247291644*^9}, {3.7217652900414467`*^9, 3.721765296693766*^9}, {
   3.7217663955037603`*^9, 3.7217664396227303`*^9}, {3.7217664853468513`*^9, 
   3.7217664938862*^9}, {3.7217665649908*^9, 3.7217666005661793`*^9}, {
   3.721766657736594*^9, 3.7217666858548737`*^9}, {3.721766788011923*^9, 
   3.721766827811179*^9}, {3.721766918907454*^9, 3.721766937739646*^9}, {
   3.721766984366001*^9, 3.721767029412972*^9}, {3.721767074845194*^9, 
   3.721767115212381*^9}, {3.721767324947452*^9, 3.721767946958911*^9}, {
   3.721768880868032*^9, 3.721769101549056*^9}, {3.72176918163652*^9, 
   3.7217691978783903`*^9}, {3.721769240220069*^9, 3.7217692439326553`*^9}, {
   3.721769439920089*^9, 3.721769443831173*^9}, {3.721769475672997*^9, 
   3.721769486902194*^9}, {3.721769587356853*^9, 3.72176960145079*^9}, {
   3.721769677968289*^9, 3.721769692048749*^9}, {3.7217697351288548`*^9, 
   3.72176974678716*^9}, {3.721769796849009*^9, 3.721769964162303*^9}, {
   3.721770127873336*^9, 3.7217701518430643`*^9}, {3.721770290175799*^9, 
   3.7217702973107243`*^9}, {3.721770342278771*^9, 3.721770345070546*^9}, {
   3.721772689607499*^9, 3.721772698511643*^9}, {3.72177279276609*^9, 
   3.721772929214117*^9}, {3.7217730559737988`*^9, 3.721773057965013*^9}, {
   3.7217732950165167`*^9, 3.721773324141385*^9}, {3.721774021355245*^9, 
   3.7217741174178667`*^9}, {3.7217741558299513`*^9, 3.721774158461564*^9}, {
   3.7217741978720703`*^9, 3.721774238972616*^9}, {3.721775020254633*^9, 
   3.721775049231081*^9}, {3.7218701412636423`*^9, 3.721870314616563*^9}, {
   3.721870360229135*^9, 3.7218704734150143`*^9}, {3.721870528619329*^9, 
   3.721870554264369*^9}, {3.721870624354707*^9, 3.7218706783131533`*^9}, {
   3.7218707248802757`*^9, 3.72187108326361*^9}, {3.721871131412075*^9, 
   3.721871139572337*^9}, {3.7218711702190733`*^9, 3.72187135945609*^9}, {
   3.721871403214951*^9, 3.721871649252925*^9}, {3.721883718252163*^9, 
   3.72188396452207*^9}, {3.721884005356559*^9, 3.721884033877461*^9}, {
   3.721884134220833*^9, 3.721884139954885*^9}, {3.7218847642062273`*^9, 
   3.7218847669722137`*^9}, {3.7218848117643747`*^9, 3.721884934587799*^9}, {
   3.721885220361355*^9, 3.7218852521222553`*^9}, {3.721885756383704*^9, 
   3.721885779021843*^9}, {3.721889999533785*^9, 3.721890000357785*^9}, {
   3.7218900503382*^9, 3.721890051169963*^9}, {3.721890081866666*^9, 
   3.721890084921377*^9}, {3.721890137895969*^9, 3.721890143108102*^9}, {
   3.7218902033450947`*^9, 3.721890292919965*^9}, {3.721890393889077*^9, 
   3.721890406011196*^9}, {3.7218904579249363`*^9, 3.72189047958325*^9}, {
   3.7218905132911243`*^9, 3.721890545241392*^9}, {3.721890645750559*^9, 
   3.7218906688138933`*^9}, {3.721890723856266*^9, 3.721890784401512*^9}, {
   3.721890861528533*^9, 3.7218909232405243`*^9}, {3.7218909643569307`*^9, 
   3.721891071603278*^9}, {3.72189231194761*^9, 3.721892314909483*^9}, {
   3.7218930721730824`*^9, 3.721893080370695*^9}, {3.721893863811369*^9, 
   3.721893868652896*^9}, {3.7218948125731564`*^9, 3.721894838111979*^9}, {
   3.721959223644745*^9, 3.7219592277716703`*^9}, {3.7219592883392563`*^9, 
   3.721959336451902*^9}, {3.72381681221717*^9, 3.723816863020546*^9}, {
   3.723816915542287*^9, 3.7238169483538094`*^9}, {3.7238169884120493`*^9, 
   3.723817085740057*^9}, {3.723817138832765*^9, 3.723817190597393*^9}, {
   3.723973750874295*^9, 3.7239737537216997`*^9}, {3.7307624432143183`*^9, 
   3.7307625402685623`*^9}, {3.7307628213117847`*^9, 3.730762971592671*^9}, {
   3.730763004014716*^9, 3.730763097045967*^9}, {3.730763134176324*^9, 
   3.730763159433503*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"selectExptresidual", "[", 
     RowBox[{"ExptIDin_", ",", "datain_", ",", "Sin_"}], "]"}], ":=", "\n", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ExptID", "=", "ExptIDin"}], ",", 
        RowBox[{"data", "=", "datain"}], ",", 
        RowBox[{"S", "=", "Sin"}], ",", "sqrtS", ",", "expItype", ",", 
        "datatmp", ",", "output", ",", "i"}], "}"}], ",", "\n", 
      RowBox[{
       RowBox[{"expItype", "=", 
        RowBox[{"ExptIDinfo", "[", "ExptID", "]"}]}], ";", "\n", 
       RowBox[{"output", "=", 
        RowBox[{"data", "/.", 
         RowBox[{
          RowBox[{"LF", "[", "a__", "]"}], ":>", 
          RowBox[{
           RowBox[{"{", "a", "}"}], "[", 
           RowBox[{"[", "13", "]"}], "]"}]}]}]}], ";", "\n", "output"}]}], 
     " ", "\n", "]"}]}], ";"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"obsxQ", "[", "datain_", "]"}], ":=", "\n", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"data", "=", "datain"}], ",", "sqrtS", ",", "expItype", ",", 
        "datatmp", ",", "output", ",", "i", ",", "ExptID", ",", "S"}], "}"}], 
      ",", "\n", 
      RowBox[{
       RowBox[{"ExptID", "=", 
        RowBox[{"data", "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], ";", "\n", 
       RowBox[{"S", "=", "dummy"}], ";", "\n", 
       RowBox[{"output", "=", 
        RowBox[{"selectExptxQ", "[", 
         RowBox[{"ExptID", ",", 
          RowBox[{"data", "[", 
           RowBox[{"[", "7", "]"}], "]"}], ",", "S"}], "]"}]}], ";", "\n", 
       "output"}]}], " ", "\n", "]"}]}], ";"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"obsxQresidual", "[", "datain_", "]"}], ":=", "\n", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"data", "=", "datain"}], ",", "sqrtS", ",", "expItype", ",", 
        "datatmp", ",", "output", ",", "i", ",", "ExptID", ",", "S", ",", 
        "xQ", ",", "residual", ",", "j", ",", "NormFac"}], "}"}], ",", "\n", 
      RowBox[{
       RowBox[{"ExptID", "=", 
        RowBox[{"data", "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], ";", "\n", 
       RowBox[{"expItype", "=", 
        RowBox[{"ExptIDinfo", "[", "ExptID", "]"}]}], ";", "\n", "\n", 
       RowBox[{"S", "=", "dummy"}], ";", "\n", 
       RowBox[{"(*", 
        RowBox[{"get", " ", 
         RowBox[{"{", 
          RowBox[{"x", ",", "Q"}], "}"}], " ", "points"}], "*)"}], "\n", 
       RowBox[{"xQ", "=", 
        RowBox[{"selectExptxQ", "[", 
         RowBox[{"ExptID", ",", 
          RowBox[{"data", "[", 
           RowBox[{"[", "7", "]"}], "]"}], ",", "S"}], "]"}]}], ";", "\n", 
       "\n", 
       RowBox[{"(*", 
        RowBox[{"get", " ", "residual", " ", "method", " ", "1"}], "*)"}], 
       "\n", 
       RowBox[{"(*", "\n", 
        RowBox[{
         RowBox[{"residual", "=", 
          RowBox[{
           RowBox[{"data", "[", 
            RowBox[{"[", "7", "]"}], "]"}], "/.", 
           RowBox[{
            RowBox[{"LF", "[", "a__", "]"}], "\[RuleDelayed]", 
            RowBox[{
             RowBox[{"{", "a", "}"}], "[", 
             RowBox[{"[", "13", "]"}], "]"}]}]}]}], ";", "\n", 
         RowBox[{"residual", "=", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"#", ">", "0"}], ",", 
               RowBox[{"Sqrt", "[", "#", "]"}], ",", 
               RowBox[{"-", 
                RowBox[{"Sqrt", "[", 
                 RowBox[{"-", "#"}], "]"}]}]}], "]"}], "&"}], ",", "residual",
             ",", 
            RowBox[{"{", "1", "}"}]}], "]"}]}], ";"}], "\n", "*)"}], "\n", 
       "\n", 
       RowBox[{"(*", 
        RowBox[{"get", " ", "residual", " ", "method", " ", "2"}], "*)"}], 
       "\n", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"result", " ", "of", " ", "method1"}], "&"}], "2", " ", 
          "mostly", " ", "diff", " ", "in", " ", "5", "%"}], ",", " ", 
         RowBox[{
         "method", " ", "2", " ", "should", " ", "be", " ", "accurate"}]}], 
        "*)"}], "\n", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"2017.01", ".18"}], ":", " ", 
         RowBox[{
         "NormFac", " ", "should", " ", "be", " ", "in", " ", "formula", " ", 
          "or", " ", 
          RowBox[{"not", "?"}]}]}], "*)"}], "\n", 
       RowBox[{"NormFac", "=", 
        RowBox[{"data", "[", 
         RowBox[{"[", "4", "]"}], "]"}]}], ";", "\n", 
       RowBox[{"residual", "=", 
        RowBox[{
         RowBox[{"data", "[", 
          RowBox[{"[", "7", "]"}], "]"}], "/.", 
         RowBox[{
          RowBox[{"LF", "[", "a__", "]"}], ":>", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"{", "a", "}"}], "[", 
               RowBox[{"[", "5", "]"}], "]"}], "*", "NormFac"}], "-", 
             RowBox[{
              RowBox[{"{", "a", "}"}], "[", 
              RowBox[{"[", "11", "]"}], "]"}]}], ")"}], "/", 
           RowBox[{
            RowBox[{"{", "a", "}"}], "[", 
            RowBox[{"[", "12", "]"}], "]"}]}]}]}]}], ";", "\n", "\n", "\n", 
       "\n", 
       RowBox[{"(*", 
        RowBox[{"get", " ", 
         RowBox[{"(", 
          RowBox[{"x", ",", "Q", ",", 
           RowBox[{"residual", 
            RowBox[{"(", "i", ")"}]}]}], ")"}]}], "*)"}], "\n", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"for", " ", "DIS"}], ",", " ", "JP", ",", " ", 
         RowBox[{"every", " ", "data", " ", "make", " ", "2", " ", "points"}],
          ",", " ", 
         RowBox[{
         "so", " ", "the", " ", "residual", " ", "value", " ", "of", " ", 
          "the", " ", "same", " ", "data", " ", "point", " ", "should", " ", 
          "map", " ", "to", " ", "two", " ", "points"}]}], "*)"}], "\n", 
       RowBox[{"output", "=", "\n", 
        RowBox[{"Table", "[", "\n", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"residual", ":", " ", "1"}], ",", "2", ",", "3", ",", 
           RowBox[{
            RowBox[{
             RowBox[{"4", "..."}], "N"}], "-", "1"}], ",", "0", ",", "1", ",",
            "2", ",", "3", ",", 
           RowBox[{
            RowBox[{"...", "N"}], "-", "1"}], ",", "0", ",", " ", 
           RowBox[{
            RowBox[{"then", " ", "for", " ", 
             RowBox[{"residual", "[", "i", "]"}]}], "=", "0"}], ",", " ", 
           RowBox[{"it", " ", "should", " ", "be", " ", "N"}]}], "*)"}], "\n", 
         RowBox[{
          RowBox[{
           RowBox[{"j", "=", 
            RowBox[{
             RowBox[{"Mod", "[", 
              RowBox[{"i", ",", 
               RowBox[{"Length", "[", "residual", "]"}]}], " ", "]"}], "+", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Mod", "[", 
                 RowBox[{"i", ",", 
                  RowBox[{"Length", "[", "residual", "]"}]}], "]"}], "==", 
                "0"}], ",", 
               RowBox[{"Length", "[", "residual", "]"}], ",", "0"}], 
              "]"}]}]}], ";", "\n", 
           RowBox[{"Append", "[", 
            RowBox[{
             RowBox[{"xQ", "[", 
              RowBox[{"[", "i", "]"}], "]"}], ",", 
             RowBox[{"residual", "[", 
              RowBox[{"[", "j", " ", "]"}], "]"}]}], " ", "]"}]}], ",", "\n", 
          
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", 
            RowBox[{"Length", "[", "xQ", "]"}]}], "}"}]}], "\n", "]"}]}], ";",
        "\n", "\n", "\n", "output"}]}], "\n", "]"}]}], ";"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"selectExptobservable", "[", 
    RowBox[{"datain_", ",", "obsin_"}], "]"}], ":=", "\n", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"data", "=", "datain"}], ",", 
       RowBox[{"obs", "=", "obsin"}], ",", "sqrtS", ",", "expItype", ",", 
       "datatmp", ",", "output", ",", "i"}], "}"}], ",", "\n", 
     RowBox[{"(*", 
      RowBox[{"info", " ", "of", " ", "data"}], "*)"}], "\n", 
     RowBox[{"(*", 
      RowBox[{"ExptID", ",", 
       RowBox[{"ExptIDtoName", "[", "ExptID", "]"}], ",", "R2String", ",", 
       "NormFac", ",", "NPoints", ",", "DataDescription", ",", "DataList", 
       ",", "S"}], "*)"}], "\n", "\n", 
     RowBox[{
      RowBox[{"output", "=", 
       RowBox[{"obs", "[", "data", "]"}]}], ";", "\n", "output"}]}], " ", 
    "\n", "]"}]}], ";"}]}], "Code",
 InitializationCell->False],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "replace", " ", "all", " ", "datalist", " ", "of", " ", "experiment", " ", 
    
    RowBox[{"(", 
     RowBox[{"output", " ", "of", " ", "ReadExptTable"}], ")"}], " ", "by", 
    " ", "xQ", " ", "list"}], " ", "*)"}], "\n", 
  RowBox[{
   RowBox[{"selectExptxQall", "[", 
    RowBox[{"datain_", ",", "Sin_"}], "]"}], ":=", "\n", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"data", "=", "datain"}], ",", 
       RowBox[{"S", "=", "Sin"}], ",", "ExptID", ",", "datatmp", ",", 
       "output", ",", "i"}], "}"}], ",", "\n", 
     RowBox[{
      RowBox[{"output", "=", "\n", 
       RowBox[{"Table", "[", "\n", 
        RowBox[{"(*", "\n", 
         RowBox[{
          RowBox[{"ExptID", "=", 
           RowBox[{"data", "[", 
            RowBox[{"[", 
             RowBox[{"iExperiment", ",", "1"}], "]"}], "]"}]}], ";", "\n", 
          RowBox[{"datatmp", "=", 
           RowBox[{"data", "[", 
            RowBox[{"[", 
             RowBox[{"iExperiment", ",", "7"}], "]"}], "]"}]}], ";"}], "\n", 
         "*)"}], "\n", 
        RowBox[{"(*", " ", "\n", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"selectExptxQ", "[", 
             RowBox[{
              RowBox[{"ExptList1", "[", 
               RowBox[{"[", 
                RowBox[{"24", ",", "1"}], "]"}], "]"}], ",", 
              RowBox[{"ExptList1", "[", 
               RowBox[{"[", 
                RowBox[{"24", ",", "7"}], "]"}], "]"}]}], "]"}], " ", "\n", 
            RowBox[{"data", "[", 
             RowBox[{"iExperiment", ",", "7"}], "]"}]}], "=", 
           RowBox[{"selectExptxQ", "[", 
            RowBox[{"ExptID", ",", "datatmp"}], "]"}]}], ";"}], "\n", "*)"}], 
        "\n", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"data", "[", 
            RowBox[{"[", 
             RowBox[{"iExperiment", ",", "7"}], "]"}], "]"}], "=", 
           RowBox[{"selectExptxQ", "[", 
            RowBox[{
             RowBox[{"data", "[", 
              RowBox[{"[", 
               RowBox[{"iExperiment", ",", "1"}], "]"}], "]"}], ",", 
             RowBox[{"data", "[", 
              RowBox[{"[", 
               RowBox[{"iExperiment", ",", "7"}], "]"}], "]"}]}], "]"}]}], 
          " ", ";", "\n", 
          RowBox[{"data", "[", 
           RowBox[{"[", "iExperiment", "]"}], "]"}]}], "\n", ",", "\n", 
         RowBox[{"{", 
          RowBox[{"iExperiment", ",", 
           RowBox[{"Length", "[", "data", "]"}]}], "}"}]}], "\n", "]"}]}], 
      ";", "\n", "output"}]}], "\n", "\n", "]"}]}]}]], "Code",
 InitializationCell->False],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"input", " ", "data", " ", 
       RowBox[{"(", 
        RowBox[{"output", " ", "of", " ", "ReadExptTable"}], ")"}]}], " ", 
      "&"}], " ", "ExptID"}], ",", "\n", 
    RowBox[{
    "then", " ", "find", " ", "whether", " ", "data", " ", "of", " ", 
     "ExptID", " ", "included", " ", "in", " ", "it"}], ",", "\n", 
    RowBox[{
    "if", " ", "data", " ", "of", " ", "ExptID", " ", "is", " ", "included"}],
     ",", " ", 
    RowBox[{"then", " ", "output", " ", 
     RowBox[{"(", 
      RowBox[{"x", ",", "Q"}], ")"}], " ", "of", " ", "it", "\n", "if", " ", 
     "it", " ", "is", " ", "not", " ", "included"}], ",", " ", 
    RowBox[{
    "then", " ", "return", " ", "a", " ", "massage", " ", 
     "\"\<can not find ExptID\>\"", "\n", "\n", "output", " ", "the", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"exp", " ", "index"}], ",", " ", "flavour"}], ")"}], " ", "of",
      " ", "a", " ", "data", " ", "from", " ", "datain_", "\n", "output", " ", 
     RowBox[{"formate", ":", "\n", 
      RowBox[{"{", " ", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"expN", ",", " ", "expid", ",", " ", "f"}], "}"}], ",", " ", 
        
        RowBox[{"{", 
         RowBox[{
          RowBox[{"LF", "[", 
           RowBox[{"x1", ",", " ", "Q1"}], "]"}], ",", " ", 
          RowBox[{"LF", "[", 
           RowBox[{"x2", ",", " ", "Q2"}], "]"}], ",", "..."}], "}"}]}], " ", 
       "}"}]}]}]}], "\n", "*)"}], "\n", 
  RowBox[{
   RowBox[{
    RowBox[{"extractdata2", "[", 
     RowBox[{"datain_", ",", "Nexpin_", ",", "fin_"}], "]"}], ":=", "\n", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"data", "=", "datain"}], ",", 
        RowBox[{"Nexp", "=", "Nexpin"}], ",", 
        RowBox[{"f", "=", "fin"}], ",", "mystr", ",", "expN", ",", "expid", 
        ",", "dataout", ",", "dataflavor", ",", "nodataflavor", ",", 
        "WorkDir", ",", "DataFile", ",", "myfile", ",", "tmpexpdata"}], "}"}],
       ",", "\n", 
      RowBox[{
       RowBox[{"expN", "=", "0"}], ";", "\n", 
       RowBox[{"expid", "=", "Nexpin"}], ";", "\n", "\n", 
       RowBox[{"dataflavor", "=", 
        RowBox[{"{", "}"}]}], ";", "nodataflavor", ";", "\n", "\n", 
       RowBox[{"Do", "[", "\n", 
        RowBox[{
         RowBox[{
          RowBox[{"If", "[", "\n", 
           RowBox[{
            RowBox[{
             RowBox[{"data", "[", 
              RowBox[{"[", 
               RowBox[{"iExperiment", ",", "1"}], "]"}], "]"}], "==", 
             "expid"}], ",", "\n", 
            RowBox[{
             RowBox[{"dataflavor", "=", 
              RowBox[{"selectExptxQ", "[", 
               RowBox[{
                RowBox[{"data", "[", 
                 RowBox[{"[", 
                  RowBox[{"iExperiment", ",", "1"}], "]"}], "]"}], ",", 
                RowBox[{"data", "[", 
                 RowBox[{"[", 
                  RowBox[{"iExperiment", ",", "7"}], "]"}], "]"}], " ", ",", 
                RowBox[{"data", "[", 
                 RowBox[{"[", 
                  RowBox[{"iExperiment", ",", "8"}], "]"}], "]"}]}], " ", 
               "]"}]}], ";", "\n", 
             RowBox[{"expN", "=", "iExperiment"}], ";"}]}], "\n", " ", "]"}], 
          ";"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"iExperiment", ",", "1", ",", 
           RowBox[{"Length", "[", "data", "]"}]}], "}"}]}], "\n", "]"}], ";", 
       "\n", "\n", 
       RowBox[{"If", "[", "\n", 
        RowBox[{
         RowBox[{"expN", "==", "0"}], ",", "\n", 
         RowBox[{
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<the experiment does not exist in the data, \>\"", ",", 
            "expid"}], "]"}], ";"}]}], "\n", "]"}], ";", "\n", 
       RowBox[{"dataflavor", "=", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"expN", ",", "expid", ",", "f"}], "}"}], ",", 
          "dataflavor"}], "}"}]}], ";", "\n", "\n", "dataflavor"}]}], "\n", 
     "]"}]}], "\n", "\n", 
   RowBox[{"(*", "\n", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
       "2016.11", ".18", " ", "botingw", "\n", "input", " ", "data", " ", 
        RowBox[{"(", 
         RowBox[{"output", " ", "of", " ", "ReadExptTable"}], ")"}]}], " ", 
       "&"}], " ", "ExptID"}], ",", "\n", 
     RowBox[{
     "then", " ", "find", " ", "whether", " ", "data", " ", "of", " ", 
      "ExptID", " ", "included", " ", "in", " ", "it"}], ",", "\n", 
     RowBox[{
     "if", " ", "data", " ", "of", " ", "ExptID", " ", "is", " ", 
      "included"}], ",", " ", 
     RowBox[{
     "then", " ", "output", " ", "obsevable", " ", "we", " ", "want", " ", 
      "of", " ", "it", "\n", "if", " ", "it", " ", "is", " ", "not", " ", 
      "included"}], ",", " ", 
     RowBox[{
     "then", " ", "return", " ", "a", " ", "massage", " ", 
      "\"\<can not find ExptID\>\"", "\n", "\n", "output", " ", "the", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"exp", " ", "index"}], ",", " ", "flavour"}], ")"}], " ", 
      "of", " ", "a", " ", "data", " ", "from", " ", "datain_", "\n", 
      "output", " ", 
      RowBox[{"formate", ":", "\n", 
       RowBox[{"{", " ", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"expN", ",", " ", "expid", ",", " ", "f"}], "}"}], ",", " ", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"LF", "[", 
            RowBox[{"obs1", ",", " ", "obs2", ",", "..."}], "]"}], ",", " ", 
           RowBox[{"LF", "[", 
            RowBox[{"obs1", ",", " ", "obs2", ",", "..."}], "]"}], ",", 
           "..."}], "}"}]}], " ", "}"}]}]}]}], "\n", "*)"}], "\n", 
   RowBox[{
    RowBox[{"extractobsfromdata", "[", 
     RowBox[{"datain_", ",", "Nexpin_", ",", "fin_", ",", "obsin_"}], "]"}], ":=",
     "\n", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"data", "=", "datain"}], ",", 
        RowBox[{"Nexp", "=", "Nexpin"}], ",", 
        RowBox[{"f", "=", "fin"}], ",", 
        RowBox[{"obs", "=", "obsin"}], ",", "mystr", ",", "expN", ",", 
        "expid", ",", "dataout", ",", "dataflavor", ",", "nodataflavor", ",", 
        "WorkDir", ",", "DataFile", ",", "myfile", ",", "tmpexpdata"}], "}"}],
       ",", "\n", 
      RowBox[{
       RowBox[{"expN", "=", "0"}], ";", "\n", 
       RowBox[{"expid", "=", "Nexpin"}], ";", "\n", "\n", 
       RowBox[{"dataflavor", "=", 
        RowBox[{"{", "}"}]}], ";", "nodataflavor", ";", "\n", "\n", 
       RowBox[{"Do", "[", "\n", 
        RowBox[{
         RowBox[{
          RowBox[{"If", "[", "\n", 
           RowBox[{
            RowBox[{
             RowBox[{"data", "[", 
              RowBox[{"[", 
               RowBox[{"iExperiment", ",", "1"}], "]"}], "]"}], "==", 
             "expid"}], ",", "\n", 
            RowBox[{"(*", "\n", 
             RowBox[{
              RowBox[{"dataflavor", "=", 
               RowBox[{"selectExptxQ", "[", 
                RowBox[{
                 RowBox[{"data", "[", 
                  RowBox[{"[", 
                   RowBox[{"iExperiment", ",", "1"}], "]"}], "]"}], ",", 
                 RowBox[{"data", "[", 
                  RowBox[{"[", 
                   RowBox[{"iExperiment", ",", "7"}], "]"}], "]"}], " ", ",", 
                 
                 RowBox[{"data", "[", 
                  RowBox[{"[", 
                   RowBox[{"iExperiment", ",", "8"}], "]"}], "]"}]}], " ", 
                "]"}]}], ";"}], "\n", "*)"}], "\n", 
            RowBox[{
             RowBox[{"dataflavor", "=", 
              RowBox[{"selectExptobservable", "[", 
               RowBox[{
                RowBox[{"data", "[", 
                 RowBox[{"[", "iExperiment", "]"}], "]"}], ",", "obs"}], " ", 
               "]"}]}], ";", "\n", 
             RowBox[{"expN", "=", "iExperiment"}], ";"}]}], "\n", " ", "]"}], 
          ";"}], ",", "\n", 
         RowBox[{"{", 
          RowBox[{"iExperiment", ",", "1", ",", 
           RowBox[{"Length", "[", "data", "]"}]}], "}"}]}], "\n", "]"}], ";", 
       "\n", "\n", 
       RowBox[{"If", "[", "\n", 
        RowBox[{
         RowBox[{"expN", "==", "0"}], ",", "\n", 
         RowBox[{
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<the experiment does not exist in the data, \>\"", ",", 
            "expid"}], "]"}], ";"}]}], "\n", "]"}], ";", "\n", 
       RowBox[{"dataflavor", "=", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"expN", ",", "expid", ",", "f"}], "}"}], ",", 
          "dataflavor"}], "}"}]}], ";", "\n", "\n", "dataflavor"}]}], "\n", 
     "]"}]}], "\n"}]}]], "Code",
 InitializationCell->False],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"use", " ", "data"}], "*)"}], "\n", 
  RowBox[{
   RowBox[{
    RowBox[{"makexQdataset", "[", 
     RowBox[{"datain_", ",", "Nexpin_", ",", "fin_"}], "]"}], ":=", "\n", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"data", "=", "datain"}], ",", 
        RowBox[{"Nexp", "=", "Nexpin"}], ",", 
        RowBox[{"f", "=", "fin"}], ",", "dataplot", ",", "allplot2", ",", 
        "lgd", ",", "nodatalist", ",", "outputdata"}], "}"}], ",", "\n", 
      RowBox[{
       RowBox[{"dataplot", "=", 
        RowBox[{"{", "}"}]}], ";", 
       RowBox[{"nodatalist", "=", 
        RowBox[{"{", "}"}]}], ";", "\n", 
       RowBox[{"(*", " ", 
        RowBox[{
         RowBox[{"no", " ", "function"}], ",", " ", 
         RowBox[{
          RowBox[{
           RowBox[{"delete", " ", 
            RowBox[{"it", ".", "\n", "dataplot"}]}], "=", 
           RowBox[{"Append", "[", 
            RowBox[{"dataplot", ",", 
             RowBox[{"extractdata2", "[", 
              RowBox[{"data", ",", 
               RowBox[{"Nexp", "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{"-", "5"}]}], "]"}]}], " ", "]"}]}], ";", "\n", 
          RowBox[{"dataplot", "=", 
           RowBox[{"Append", "[", 
            RowBox[{"dataplot", ",", 
             RowBox[{"extractdata2", "[", 
              RowBox[{"data", ",", 
               RowBox[{"Nexp", "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", "3"}], "]"}]}], " ", 
            "]"}]}], ";"}]}], "\n", "*)"}], "\n", 
       RowBox[{"dataplot", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"extractdata2", "[", 
           RowBox[{"data", ",", 
            RowBox[{"Nexp", "[", 
             RowBox[{"[", "i", "]"}], "]"}], ",", 
            RowBox[{"f", "[", 
             RowBox[{"[", "i", "]"}], "]"}]}], "]"}], " ", ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", 
            RowBox[{"Length", "[", "Nexp", "]"}]}], "}"}]}], "]"}]}], ";", 
       "\n", 
       RowBox[{"(*", 
        RowBox[{"make", " ", "list", " ", "of", " ", 
         RowBox[{"(", 
          RowBox[{"expid", ",", " ", "f"}], ")"}], " ", "sets", " ", "which", 
         " ", "have", " ", "no", " ", "data", " ", "in", " ", "it"}], "*)"}], 
       "\n", 
       RowBox[{"Do", "[", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{"dataplot", "[", 
              RowBox[{"[", 
               RowBox[{"i", ",", "2"}], "]"}], "]"}], " ", "]"}], "==", "0"}],
            ",", 
           RowBox[{"nodatalist", "=", 
            RowBox[{"Append", "[", 
             RowBox[{"nodatalist", ",", "i"}], "]"}]}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"Length", "[", "Nexp", "]"}]}], "}"}]}], "]"}], ";", "\n", 
       
       RowBox[{"(*", 
        RowBox[{"delete", " ", 
         RowBox[{"(", 
          RowBox[{"expid", ",", " ", "f"}], ")"}], " ", "with", " ", "no", 
         " ", "data", " ", "by", " ", "list", " ", "we", " ", "made"}], 
        "*)"}], "\n", 
       RowBox[{"Do", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"dataplot", "=", 
           RowBox[{"Drop", "[", 
            RowBox[{"dataplot", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"nodatalist", "[", 
                RowBox[{"[", "i", "]"}], "]"}], "+", "1", "-", "i"}], "}"}]}],
             "]"}]}], ";", 
          RowBox[{"Nexp", "=", 
           RowBox[{"Drop", "[", 
            RowBox[{"Nexp", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"nodatalist", "[", 
                RowBox[{"[", "i", "]"}], "]"}], "+", "1", "-", "i"}], "}"}]}],
             "]"}]}], ";", 
          RowBox[{"f", "=", 
           RowBox[{"Drop", "[", 
            RowBox[{"f", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"nodatalist", "[", 
                RowBox[{"[", "i", "]"}], "]"}], "+", "1", "-", "i"}], "}"}]}],
             "]"}]}]}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"Length", "[", "nodatalist", "]"}]}], "}"}]}], "]"}], ";", 
       "\n", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"define", " ", "output", " ", 
          RowBox[{"data", ":", " ", 
           RowBox[{
           "delete", " ", "subset", " ", "of", " ", "histogram", " ", 
            "data"}]}]}], ",", " ", 
         RowBox[{"means", " ", "we", " ", 
          RowBox[{"don", "'"}], "t", " ", "want", " ", "to", " ", "know", " ",
           "which", " ", "subset", " ", "a", " ", "data", " ", "point", " ", 
          "belong", " ", "to"}]}], "*)"}], "\n", 
       RowBox[{"outputdata", "=", 
        RowBox[{"Flatten", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"dataplot", "[", 
              RowBox[{"[", 
               RowBox[{"i", ",", "2"}], "]"}], "]"}], "/.", 
             RowBox[{"LF", "->", "List"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "1", ",", 
              RowBox[{"Length", "[", "Nexp", "]"}]}], "}"}]}], "]"}], ",", 
          "1"}], "]"}]}], ";", "\n", "\n", "outputdata"}]}], "\n", " ", 
     "]"}]}], ";"}]}]], "Code",
 InitializationCell->False],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"use", " ", "data"}], "*)"}], "\n", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"makeobsdataset", "[", 
      RowBox[{"datain_", ",", "Nexpin_", ",", "fin_", ",", "obsin_"}], "]"}], 
     ":=", "\n", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"data", "=", "datain"}], ",", 
         RowBox[{"Nexp", "=", "Nexpin"}], ",", 
         RowBox[{"f", "=", "fin"}], ",", 
         RowBox[{"obs", "=", "obsin"}], ",", "dataplot", ",", "allplot2", ",",
          "lgd", ",", "nodatalist", ",", "outputdata"}], "}"}], ",", "\n", 
       RowBox[{
        RowBox[{"dataplot", "=", 
         RowBox[{"{", "}"}]}], ";", 
        RowBox[{"nodatalist", "=", 
         RowBox[{"{", "}"}]}], ";", "\n", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{"no", " ", "function"}], ",", " ", 
          RowBox[{
           RowBox[{
            RowBox[{"delete", " ", 
             RowBox[{"it", ".", "\n", "dataplot"}]}], "=", 
            RowBox[{"Append", "[", 
             RowBox[{"dataplot", ",", 
              RowBox[{"extractdata2", "[", 
               RowBox[{"data", ",", 
                RowBox[{"Nexp", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{"-", "5"}]}], "]"}]}], " ", "]"}]}], ";", "\n", 
           RowBox[{"dataplot", "=", 
            RowBox[{"Append", "[", 
             RowBox[{"dataplot", ",", 
              RowBox[{"extractdata2", "[", 
               RowBox[{"data", ",", 
                RowBox[{"Nexp", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], ",", "3"}], "]"}]}], " ", 
             "]"}]}], ";"}]}], "\n", "*)"}], "\n", "\n", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"f", " ", "is", " ", "dummy"}], ",", " ", 
          RowBox[{"give", " ", "it", " ", "some", " ", "value"}]}], "*)"}], 
        "\n", 
        RowBox[{"f", "=", 
         RowBox[{"Table", "[", 
          RowBox[{"1", ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", 
             RowBox[{"Length", "[", "Nexp", "]"}]}], "}"}]}], "]"}]}], ";", 
        "\n", "\n", 
        RowBox[{"dataplot", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"extractobsfromdata", "[", 
            RowBox[{"data", ",", 
             RowBox[{"Nexp", "[", 
              RowBox[{"[", "i", "]"}], "]"}], ",", 
             RowBox[{"f", "[", 
              RowBox[{"[", "i", "]"}], "]"}], ",", "obs"}], "]"}], " ", ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", 
             RowBox[{"Length", "[", "Nexp", "]"}]}], "}"}]}], "]"}]}], ";", 
        "\n", 
        RowBox[{"(*", 
         RowBox[{"make", " ", "list", " ", "of", " ", 
          RowBox[{"(", 
           RowBox[{"expid", ",", " ", "f"}], ")"}], " ", "sets", " ", "which",
           " ", "have", " ", "no", " ", "data", " ", "in", " ", "it"}], 
         "*)"}], "\n", 
        RowBox[{"Do", "[", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"dataplot", "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", "2"}], "]"}], "]"}], " ", "]"}], "==", 
             "0"}], ",", 
            RowBox[{"nodatalist", "=", 
             RowBox[{"Append", "[", 
              RowBox[{"nodatalist", ",", "i"}], "]"}]}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", 
            RowBox[{"Length", "[", "Nexp", "]"}]}], "}"}]}], "]"}], ";", "\n", 
        RowBox[{"(*", 
         RowBox[{"delete", " ", 
          RowBox[{"(", 
           RowBox[{"expid", ",", " ", "f"}], ")"}], " ", "with", " ", "no", 
          " ", "data", " ", "by", " ", "list", " ", "we", " ", "made"}], 
         "*)"}], "\n", 
        RowBox[{"Do", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"dataplot", "=", 
            RowBox[{"Drop", "[", 
             RowBox[{"dataplot", ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"nodatalist", "[", 
                 RowBox[{"[", "i", "]"}], "]"}], "+", "1", "-", "i"}], 
               "}"}]}], "]"}]}], ";", 
           RowBox[{"Nexp", "=", 
            RowBox[{"Drop", "[", 
             RowBox[{"Nexp", ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"nodatalist", "[", 
                 RowBox[{"[", "i", "]"}], "]"}], "+", "1", "-", "i"}], 
               "}"}]}], "]"}]}], ";", 
           RowBox[{"f", "=", 
            RowBox[{"Drop", "[", 
             RowBox[{"f", ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"nodatalist", "[", 
                 RowBox[{"[", "i", "]"}], "]"}], "+", "1", "-", "i"}], 
               "}"}]}], "]"}]}]}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", 
            RowBox[{"Length", "[", "nodatalist", "]"}]}], "}"}]}], "]"}], ";",
         "\n", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"define", " ", "output", " ", 
           RowBox[{"data", ":", " ", 
            RowBox[{
            "delete", " ", "subset", " ", "of", " ", "histogram", " ", 
             "data"}]}]}], ",", " ", 
          RowBox[{"means", " ", "we", " ", 
           RowBox[{"don", "'"}], "t", " ", "want", " ", "to", " ", "know", 
           " ", "which", " ", "subset", " ", "a", " ", "data", " ", "point", 
           " ", "belong", " ", "to"}]}], "*)"}], "\n", 
        RowBox[{"outputdata", "=", 
         RowBox[{"Flatten", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"dataplot", "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", "2"}], "]"}], "]"}], "/.", 
              RowBox[{"LF", "->", "List"}]}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "1", ",", 
               RowBox[{"Length", "[", "Nexp", "]"}]}], "}"}]}], "]"}], ",", 
           "1"}], "]"}]}], ";", "\n", "\n", "outputdata"}]}], "\n", " ", 
      "]"}]}], ";"}], "\n", "\n", 
   RowBox[{"(*", 
    RowBox[{"2016.11", ".04", " ", "botingw"}], "*)"}], "\n", 
   RowBox[{"(*", 
    RowBox[{
    "plot", " ", "pdf", " ", "function", " ", "with", " ", "log", " ", "log", 
     " ", "scale"}], "*)"}], "\n", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"if", " ", "plotrangein"}], "\[Equal]", "\"\<None\>\""}], ",", 
     " ", 
     RowBox[{
     "then", " ", "plotrange", " ", "is", " ", "by", " ", "default"}]}], 
    "*)"}], "\n", 
   RowBox[{"(*", 
    RowBox[{"example", " ", 
     RowBox[{"input", ":"}]}], " ", "*)"}], "\n", 
   RowBox[{"(*", "\n", 
    RowBox[{
     RowBox[{
      RowBox[{"myMarker", "\n", "myplotstyle", "\n", "title"}], "=", 
      "\"\<(x, Q) points of experiments based on CT14LN fitting\\n (Heavy \
Nucleons included)\>\""}], ";", "\n", 
     RowBox[{"xtitle", "=", "\"\<x\>\""}], ";", "\n", 
     RowBox[{"ytitle", "=", "\"\<Q [GeV]\>\""}], ";", "\n", 
     RowBox[{"lgd", "=", 
      RowBox[{"{", 
       RowBox[{
       "\"\<pl \[Rule] lX, NC\>\"", ",", "\"\<pl \[Rule] clX, NC\>\"", ",", 
        "\"\<\[Nu]N \[Rule] X, CC\>\"", ",", "\"\<\[Nu]N \[Rule] cX, CC\>\"", 
        ",", "\"\<pOverscript[p, _] \[Rule] l^+l^-X, \[ScriptD]\[Sigma]/\
\[ScriptD]y\>\"", ",", 
        "\"\<pOverscript[p, _] \[Rule] l\[Nu]X, A(Subscript[y, l])\>\""}], 
       "}"}]}], ";", "\n", 
     RowBox[{"lgdpos", "=", 
      RowBox[{"{", 
       RowBox[{"0.15", ",", "0.6"}], "}"}]}], ";", "\n", 
     RowBox[{
      RowBox[{
       RowBox[{"PDFloglogplot", "[", 
        RowBox[{
        "tmpDISdataf1", ",", "myMarker", ",", "myplotstyle", ",", "title", 
         ",", "xtitle", ",", "ytitle", ",", 
         RowBox[{"{", 
          RowBox[{"0.001", ",", "5", ",", "1", ",", "500"}], "}"}], ",", 
         "lgd", ",", "lgdpos"}], "]"}], "\n", "\n", "myMarker"}], "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\"\<\[FilledCircle]\>\"", ",", "6.272`"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\"\<\[FilledSquare]\>\"", ",", "6.272`"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\"\<\[FilledDiamond]\>\"", ",", "7.616`"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\"\<\[FilledDiamond]\>\"", ",", "7.616`"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\"\<\[EmptyCircle]\>\"", ",", "7.167999999999999`"}], "}"}],
         ",", 
        RowBox[{"{", 
         RowBox[{"\"\<\[EmptySquare]\>\"", ",", "7.167999999999999`"}], 
         "}"}]}], "}"}]}], ";", "\n", 
     RowBox[{"myplotstyle", "=", 
      RowBox[{"{", 
       RowBox[{",", ",", ",", ",", ","}], "}"}]}], ";"}], "\n", "\n", "*)"}], 
   "\n", 
   RowBox[{
    RowBox[{"PDFloglogplot", "[", 
     RowBox[{
     "datain_", ",", "plotmarkerin_", ",", "plotstylein_", ",", "titlein_", 
      ",", "xtitlein_", ",", "ytitlein_", ",", "plotrangein_", ",", "lgdin_", 
      ",", "lgdposin_"}], "]"}], ":=", "\n", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"data", "=", "datain"}], ",", 
        RowBox[{"plotmarker", "=", "plotmarkerin"}], ",", 
        RowBox[{"plotstyle", "=", "plotstylein"}], ",", 
        RowBox[{"title", "=", "titlein"}], ",", 
        RowBox[{"xtitle", "=", "xtitlein"}], ",", 
        RowBox[{"ytitle", "=", "ytitlein"}], ",", 
        RowBox[{"plotrange", "=", "plotrangein"}], ",", 
        RowBox[{"lgd", "=", "lgdin"}], ",", 
        RowBox[{"lgdpos", "=", "lgdposin"}], ",", "plotxQout", ",", "minx", 
        ",", "maxx", ",", "miny", ",", "maxy", ",", "imgsize", ",", 
        "titlesize", ",", "xtitlesize", ",", "ytitlesize", ",", 
        "lgdlabelsize", ",", "ticklablesize", ",", "plotrangetmp"}], "}"}], 
      ",", "\n", "\n", 
      RowBox[{"(*", "default", "*)"}], "\n", 
      RowBox[{
       RowBox[{"minx", "=", "0.00001"}], ";", "\n", 
       RowBox[{"maxx", "=", "1"}], ";", "\n", 
       RowBox[{"miny", "=", "1"}], ";", "\n", 
       RowBox[{"maxy", "=", "1100"}], ";", "\n", 
       RowBox[{"imgsize", "=", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", "600", "}"}], ",", 
          RowBox[{"{", "600", "}"}]}], "}"}]}], ";", "\n", 
       RowBox[{"titlesize", "=", "24"}], ";", "\n", 
       RowBox[{"xtitlesize", "=", "18"}], ";", "\n", 
       RowBox[{"ytitlesize", "=", "18"}], ";", "\n", 
       RowBox[{"lgdlabelsize", "=", "12"}], ";", "\n", 
       RowBox[{"ticklablesize", "=", "18"}], ";", "\n", "\n", 
       RowBox[{"(*", 
        RowBox[{
        "if", " ", "want", " ", "to", " ", "customize", " ", "the", " ", 
         "plot", " ", "range"}], "*)"}], "\n", 
       RowBox[{"plotrangetmp", "=", 
        RowBox[{"ToString", "[", "plotrange", "]"}]}], ";", "\n", 
       RowBox[{"If", "[", "\n", 
        RowBox[{
         RowBox[{"plotrangetmp", "!=", "\"\<None\>\""}], ",", "\n", 
         RowBox[{
          RowBox[{"minx", "=", 
           RowBox[{"plotrange", "[", 
            RowBox[{"[", "1", "]"}], "]"}]}], ";", "\n", 
          RowBox[{"maxx", "=", 
           RowBox[{"plotrange", "[", 
            RowBox[{"[", "2", "]"}], "]"}]}], ";", "\n", 
          RowBox[{"miny", "=", 
           RowBox[{"plotrange", "[", 
            RowBox[{"[", "3", "]"}], "]"}]}], ";", "\n", 
          RowBox[{"maxy", "=", 
           RowBox[{"plotrange", "[", 
            RowBox[{"[", "4", "]"}], "]"}]}], ";"}]}], "\n", "]"}], ";", "\n",
        "\n", "\n", 
       RowBox[{"plotxQout", "=", 
        RowBox[{"ListLogLogPlot", "[", "\n", 
         RowBox[{"data", ",", "\n", "\n", 
          RowBox[{"Frame", "->", "True"}], ",", "\n", 
          RowBox[{"(*", "\n", 
           RowBox[{
            RowBox[{"PlotMarkers", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"Automatic", ",", "Markersize"}], "}"}]}], ","}], "\n", 
           "*)"}], "\n", 
          RowBox[{"PlotMarkers", "->", "plotmarker"}], ",", "\n", 
          RowBox[{"PlotStyle", "->", "plotstyle"}], ",", "\n", 
          RowBox[{"BaseStyle", "->", 
           RowBox[{"{", 
            RowBox[{"FontSize", "->", "18"}], 
            RowBox[{"(*", 
             RowBox[{",", 
              RowBox[{"FontFamily", "\[Rule]", 
               RowBox[{
               "\"\<Helvetica\>\"", "  ", "test", " ", "close", " ", 
                "it"}]}]}], "*)"}], "}"}]}], ",", "\n", 
          RowBox[{"ImageSize", "->", "imgsize"}], ",", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"size", " ", "of", " ", "image"}], ",", " ", 
            RowBox[{"including", " ", "title"}], ",", " ", 
            RowBox[{"xy", " ", "title"}], ",", " ", 
            RowBox[{
            "it", " ", "is", " ", "not", " ", "just", " ", "size", " ", "of", 
             " ", "image", " ", "frame"}]}], " ", "*)"}], "\n", 
          RowBox[{"FrameLabel", "->", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"xtitle", ",", "xtitlesize"}], "]"}], ",", 
             RowBox[{"Style", "[", 
              RowBox[{"ytitle", ",", "ytitlesize"}], "]"}]}], "}"}]}], ",", 
          "\n", 
          RowBox[{"PlotLabel", "->", 
           RowBox[{"Style", "[", 
            RowBox[{"title", ",", "titlesize"}], "]"}]}], ",", "\n", 
          RowBox[{"FrameTicksStyle", "->", 
           RowBox[{"Directive", "[", 
            RowBox[{"Black", ",", "ticklablesize"}], "]"}]}], ",", "\n", 
          RowBox[{"PlotRange", "->", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"minx", ",", "maxx"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"miny", ",", "maxy"}], "}"}]}], "}"}]}], ",", "\n", 
          RowBox[{"PlotLegends", "->", 
           RowBox[{"Placed", "[", 
            RowBox[{
             RowBox[{"PointLegend", "[", 
              RowBox[{"lgd", ",", 
               RowBox[{"LabelStyle", "->", 
                RowBox[{"Directive", "[", 
                 RowBox[{"Black", ",", "lgdlabelsize", ",", 
                  RowBox[{
                  "FontFamily", "->", "\"\<Latin Modern Roman Caps\>\""}]}], 
                 "]"}]}], ",", 
               RowBox[{"LegendMarkerSize", "->", "15"}], ",", 
               RowBox[{"LegendFunction", "->", "Framed"}]}], " ", "]"}], ",", 
             "lgdpos"}], "]"}]}], ",", "\n", 
          RowBox[{"GridLines", "->", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
              "0.00001", ",", "0.0001", ",", "0.001", ",", "0.01", ",", 
               "0.1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"10", ",", "50", ",", "100", ",", "500", ",", "1000"}], 
              "}"}]}], "}"}]}], ",", "\n", 
          RowBox[{"GridLinesStyle", "->", 
           RowBox[{"Directive", "[", "Dashed", "]"}]}], ",", "\n", 
          RowBox[{"AspectRatio", "->", "1"}]}], 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"size", " ", "ratio", " ", "of", " ", "x"}], ",", " ", 
           RowBox[{"y", " ", "frame"}]}], " ", "*)"}], "\n", "\n", "\n", 
         "]"}]}], ";", "\n", "\n", "plotxQout"}]}], "\n", " ", 
     "]"}]}]}]}]], "Code",
 InitializationCell->False],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"input", ":", " ", "RGB"}], "=", 
    RowBox[{
    "\"\<R\>\"", " ", "or", " ", "\"\<G\>\"", " ", "or", " ", "\"\<B\>\"", 
     " ", "or", " ", "\"\<Brown\>\"", " ", "or", " ", "\"\<Gray\>\""}]}], 
   "*)"}], "\n", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"output", ":", " ", 
     RowBox[{"red", " ", 
      RowBox[{"(", 
       RowBox[{"red", ",", " ", 
        RowBox[{"deep", " ", "red"}], ",", " ", 
        RowBox[{
         RowBox[{"deep", " ", "orange"}], "..."}]}], ")"}]}]}], ",", " ", 
    "green", ",", " ", "blue", ",", " ", "blown", ",", " ", 
    RowBox[{"gray", " ", "color", " ", "lists"}]}], "*)"}], "\n", 
  RowBox[{
   RowBox[{
    RowBox[{"colorset", "[", "RGBin_", "]"}], ":=", "\n", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"RGB", "=", "RGBin"}], ",", "colorset", ",", "Rcolor", ",", 
        "Gcolor", ",", "Bcolor", ",", "Graycolor", ",", "Browncolor", ",", 
        "output"}], "}"}], ",", "\n", 
      RowBox[{
       RowBox[{"colorset", "=", 
        RowBox[{"ColorData", "[", 
         RowBox[{"\"\<WebSafe\>\"", ",", "\"\<ColorList\>\""}], "]"}]}], ";", 
       "\n", 
       RowBox[{"Rcolor", "=", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"colorset", "[", 
           RowBox[{"[", "12", "]"}], "]"}], ",", 
          RowBox[{"colorset", "[", 
           RowBox[{"[", "14", "]"}], "]"}], ",", 
          RowBox[{"colorset", "[", 
           RowBox[{"[", "32", "]"}], "]"}], ",", 
          RowBox[{"colorset", "[", 
           RowBox[{"[", "18", "]"}], "]"}], ",", 
          RowBox[{"colorset", "[", 
           RowBox[{"[", "23", "]"}], "]"}], ",", 
          RowBox[{"colorset", "[", 
           RowBox[{"[", "29", "]"}], "]"}], ",", 
          RowBox[{"colorset", "[", 
           RowBox[{"[", "36", "]"}], "]"}], ",", 
          RowBox[{"colorset", "[", 
           RowBox[{"[", "22", "]"}], "]"}], ",", "Red", ",", 
          RowBox[{"colorset", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"43", "*", "1"}], "+", "29"}], "]"}], "]"}]}], "}"}]}], 
       ";", "\n", 
       RowBox[{"Gcolor", "=", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"colorset", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"43", "*", "4"}], "+", "12"}], "]"}], "]"}], ",", 
          RowBox[{"colorset", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"43", "*", "4"}], "+", "14"}], "]"}], "]"}], ",", 
          RowBox[{"colorset", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"43", "*", "4"}], "+", "20"}], "]"}], "]"}], ",", 
          RowBox[{"colorset", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"43", "*", "4"}], "+", "26"}], "]"}], "]"}], ",", 
          RowBox[{"colorset", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"43", "*", "4"}], "+", "32"}], "]"}], "]"}], ",", 
          RowBox[{"colorset", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"43", "*", "2"}], "+", "40"}], "]"}], "]"}], ",", 
          RowBox[{"colorset", "[", 
           RowBox[{"[", "41", "]"}], "]"}], ",", "Green"}], "}"}]}], ";", 
       "\n", 
       RowBox[{"Bcolor", "=", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"colorset", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"43", "*", "4"}], "+", "3"}], "]"}], "]"}], ",", 
          RowBox[{"colorset", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"43", "*", "4"}], "+", "9"}], "]"}], "]"}], ",", 
          RowBox[{"colorset", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"43", "*", "4"}], "+", "15"}], "]"}], "]"}], ",", 
          RowBox[{"colorset", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"43", "*", "4"}], "+", "22"}], "]"}], "]"}], ",", 
          RowBox[{"colorset", "[", 
           RowBox[{"[", "43", "]"}], "]"}], ",", 
          RowBox[{"colorset", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"43", "*", "2"}], "+", "7"}], "]"}], "]"}], ",", 
          RowBox[{"colorset", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"43", "*", "2"}], "+", "13"}], "]"}], "]"}], ",", 
          RowBox[{"colorset", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"43", "*", "1"}], "+", "30"}], "]"}], "]"}], ",", 
          "Blue"}], "}"}]}], ";", "\n", 
       RowBox[{"Graycolor", "=", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"colorset", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"43", "*", "1"}], "+", "1"}], "]"}], "]"}], ",", 
          RowBox[{"colorset", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"43", "*", "2"}], "+", "1"}], "]"}], "]"}], ",", 
          RowBox[{"colorset", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"43", "*", "3"}], "+", "1"}], "]"}], "]"}], ",", 
          RowBox[{"colorset", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"43", "*", "4"}], "+", "1"}], "]"}], "]"}], ",", 
          "Gray"}], "}"}]}], ";", "\n", 
       RowBox[{"Browncolor", "=", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"colorset", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"43", "*", "2"}], "+", "9"}], "]"}], "]"}], ",", 
          RowBox[{"colorset", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"43", "*", "1"}], "+", "9"}], "]"}], "]"}], ",", 
          RowBox[{"colorset", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"43", "*", "3"}], "+", "9"}], "]"}], "]"}], ",", 
          RowBox[{"colorset", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"43", "*", "2"}], "+", "16"}], "]"}], "]"}], ",", 
          RowBox[{"colorset", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"43", "*", "2"}], "+", "22"}], "]"}], "]"}], ",", 
          "Brown"}], "}"}]}], ";", "\n", "\n", 
       RowBox[{"output", "=", "\n", 
        RowBox[{"Switch", "[", "\n", 
         RowBox[{
         "RGB", ",", "\n", "\"\<R\>\"", ",", "Rcolor", ",", "\n", "\"\<G\>\"",
           ",", "Gcolor", ",", "\n", "\"\<B\>\"", ",", "Bcolor", ",", "\n", 
          "\"\<Gray\>\"", ",", "Graycolor", ",", "\n", "\"\<Brown\>\"", ",", 
          "Browncolor", ",", "\n", "_", ",", "\n", 
          RowBox[{
          "Print", "[", 
           "\"\<error, input should be \\\"R\\\" or \\\"G\\\" or \\\"B\\\" or \
\\\"Brown\\\" or \\\"Gray\\\"\>\"", "]"}]}], "\n", "]"}]}], ";", "\n", "\n", 
       "output"}]}], "\n", "\n", "]"}]}], "\n", "\n", "\n", "\n", "\n", "\n", 
   "\n"}]}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{"End", "[", "]"}], ";", "  ", 
  RowBox[{"(*", " ", 
   RowBox[{"End", " ", "Private", " ", "Context"}], " ", "*)"}], "\n", "\n", 
  RowBox[{"EndPackage", "[", "]"}], ";", " ", 
  RowBox[{"(*", " ", 
   RowBox[{"End", " ", "Package", " ", "Context"}], " ", "*)"}]}]], "Code"]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1535, 876},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
FrontEndVersion->"11.0 for Linux x86 (64-bit) (July 28, 2016)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 117, 3, 55, "Text"],
Cell[CellGroupData[{
Cell[700, 27, 31, 0, 65, "Section"],
Cell[734, 29, 2445, 75, 596, "Code"],
Cell[3182, 106, 110, 3, 52, "Code"],
Cell[3295, 111, 51, 0, 33, "Text"],
Cell[3349, 113, 194, 5, 68, "Input",
 InitializationCell->True],
Cell[3546, 120, 48, 3, 55, "Text"],
Cell[3597, 125, 167, 4, 51, "Input",
 InitializationCell->True],
Cell[3767, 131, 238, 6, 51, "Input",
 InitializationCell->True],
Cell[4008, 139, 238, 6, 51, "Input",
 InitializationCell->True],
Cell[4249, 147, 393, 13, 51, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[4667, 164, 114, 3, 45, "Subsection"],
Cell[4784, 169, 176, 3, 33, "Text"],
Cell[4963, 174, 6420, 163, 974, "Input",
 InitializationCell->True],
Cell[11386, 339, 111, 3, 33, "Text"],
Cell[11500, 344, 2974, 82, 536, "Input",
 InitializationCell->True],
Cell[14477, 428, 821, 22, 220, "Code"],
Cell[15301, 452, 26, 0, 30, "Input"],
Cell[15330, 454, 8174, 204, 1528, "Input",
 InitializationCell->True],
Cell[23507, 660, 17151, 406, 1367, "Code"]
}, Open  ]],
Cell[CellGroupData[{
Cell[40695, 1071, 59, 0, 44, "Subsection"],
Cell[40757, 1073, 132, 3, 33, "Text"],
Cell[40892, 1078, 2071, 49, 415, "Input",
 InitializationCell->True],
Cell[42966, 1129, 217, 4, 55, "Text"],
Cell[43186, 1135, 205, 7, 48, "Input",
 InitializationCell->True],
Cell[43394, 1144, 12578, 261, 1450, "Input",
 InitializationCell->True],
Cell[55975, 1407, 5387, 139, 434, "Input"],
Cell[61365, 1548, 2802, 76, 468, "Code",
 InitializationCell->False],
Cell[64170, 1626, 18202, 447, 2514, "Code"],
Cell[82375, 2075, 13691, 345, 1583, "Code",
 InitializationCell->False],
Cell[96069, 2422, 163754, 3724, 11828, "Input",
 InitializationCell->True],
Cell[259826, 6148, 8608, 224, 1148, "Code",
 InitializationCell->False],
Cell[268437, 6374, 2665, 71, 411, "Code",
 InitializationCell->False],
Cell[271105, 6447, 8712, 217, 1407, "Code",
 InitializationCell->False],
Cell[279820, 6666, 5450, 142, 356, "Code",
 InitializationCell->False],
Cell[285273, 6810, 15226, 368, 1738, "Code",
 InitializationCell->False],
Cell[300502, 7180, 6860, 179, 647, "Code"],
Cell[307365, 7361, 309, 7, 89, "Code"]
}, Open  ]]
}, Open  ]]
}
]
*)

